/*
 * Copyright (C) 2015 MediaTek Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef _CUST_BATTERY_METER_TABLE_H
#define _CUST_BATTERY_METER_TABLE_H

/* ============================================================*/
/* define*/
/* ============================================================*/
#define BAT_NTC_10 1
#define BAT_NTC_47 0
#define BAT_NTC_100 0

#if (BAT_NTC_10 == 1)
#define RBAT_PULL_UP_R             16900
#define RBAT_PULL_DOWN_R           30000
#endif
#if (BAT_NTC_47 == 1)
#define RBAT_PULL_UP_R             61900
#define RBAT_PULL_DOWN_R           100000
#endif
#if (BAT_NTC_100 == 1)
#define RBAT_PULL_UP_R             24000
#define RBAT_PULL_DOWN_R           100000000
#endif
#define RBAT_PULL_UP_VOLT          1800


/* ============================================================*/
/* ENUM*/
/* ============================================================*/

/* ============================================================*/
/* structure*/
/* ============================================================*/

/* ============================================================*/
/* typedef*/
/* ============================================================*/
typedef struct _BATTERY_PROFILE_STRUCT {
	signed int percentage;
	signed int voltage;
} BATTERY_PROFILE_STRUCT, *BATTERY_PROFILE_STRUCT_P;

typedef struct _R_PROFILE_STRUCT {
	signed int resistance;
	signed int voltage;
} R_PROFILE_STRUCT, *R_PROFILE_STRUCT_P;

typedef enum {
	T1_0C,
	T2_25C,
	T3_50C
} PROFILE_TEMPERATURE;

/* ============================================================*/
/* External Variables*/
/* ============================================================*/

/* ============================================================*/
/* External function*/
/* ============================================================*/

/* ============================================================*/
/* <DOD, Battery_Voltage> Table*/
/* ============================================================*/
#if (BAT_NTC_10 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
		{-20 , 75022},
		{-15 , 57926},
		{-10 , 45168},
		{ -5 , 35548},
		{  0 , 28224},
		{  5 , 22595},
		{ 10 , 18231},
		{ 15 , 14820},
		{ 20 , 12133},
		{ 25 , 10000},
		{ 30 , 8295},
		{ 35 , 6922},
		{ 40 , 5810},
		{ 45 , 4903},
		{ 50 , 4160},
		{ 55 , 3547},
		{ 60 , 3039}
};
#endif

#if (BAT_NTC_47 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
		{-20, 483954},
		{-15, 360850},
		{-10, 271697},
		{ -5, 206463},
		{  0, 158214},
		{  5, 122259},
		{ 10, 95227},
		{ 15, 74730},
		{ 20, 59065},
		{ 25, 47000},
		{ 30, 37643},
		{ 35, 30334},
		{ 40, 24591},
		{ 45, 20048},
		{ 50, 16433},
		{ 55, 13539},
		{ 60, 11210}
};
#endif

#if (BAT_NTC_100 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
		{-20, 1151037},
		{-15, 846579},
		{-10, 628988},
		{ -5, 471632},
		{  0, 357012},
		{  5, 272500},
		{ 10, 209710},
		{ 15, 162651},
		{ 20, 127080},
		{ 25, 100000},
		{ 30, 79222},
		{ 35, 63167},
		{ 40, 50677},
		{ 45, 40904},
		{ 50, 33195},
		{ 55, 27091},
		{ 60, 22224}
};
#endif

/* T0 -10C*/
BATTERY_PROFILE_STRUCT battery_profile_t0[] = {
		{0  , 4190},
		{1  , 4168},
		{2  , 4149},
		{4  , 4131},
		{5  , 4116},
		{6  , 4101},
		{7  , 4088},
		{8  , 4076},
		{10 , 4065},
		{11 , 4057},
		{12 , 4050},
		{13 , 4044},
		{14 , 4040},
		{16 , 4036},
		{17 , 4031},
		{18 , 4025},
		{19 , 4017},
		{21 , 4008},
		{22 , 3998},
		{23 , 3987},
		{24 , 3976},
		{25 , 3964},
		{27 , 3954},
		{28 , 3943},
		{29 , 3934},
		{30 , 3925},
		{31 , 3918},
		{33 , 3912},
		{34 , 3905},
		{35 , 3898},
		{36 , 3890},
		{37 , 3881},
		{39 , 3873},
		{40 , 3863},
		{41 , 3852},
		{42 , 3840},
		{43 , 3827},
		{45 , 3820},
		{46 , 3802},
		{47 , 3788},
		{48 , 3774},
		{49 , 3762},
		{51 , 3749},
		{52 , 3738},
		{53 , 3727},
		{54 , 3717},
		{55 , 3707},
		{57 , 3698},
		{58 , 3690},
		{59 , 3682},
		{60 , 3675},
		{62 , 3668},
		{63 , 3661},
		{64 , 3655},
		{65 , 3650},
		{66 , 3645},
		{68 , 3640},
		{69 , 3635},
		{70 , 3630},
		{71 , 3625},
		{72 , 3620},
		{74 , 3615},
		{75 , 3608},
		{76 , 3602},
		{77 , 3594},
		{78 , 3587},
		{80 , 3579},
		{81 , 3572},
		{82 , 3565},
		{83 , 3558},
		{84 , 3550},
		{86 , 3542},
		{87 , 3531},
		{88 , 3522},
		{89 , 3511},
		{90 , 3500},
		{92 , 3489},
		{93 , 3481},
		{94 , 3475},
		{95 , 3469},
		{97 , 3462},
		{98 , 3452},
		{99 , 3434},
		{100, 3396}
};

/* T1 0C*/
BATTERY_PROFILE_STRUCT battery_profile_t1[] = {
		{0  , 4190},
		{1  , 4168},
		{2  , 4149},
		{4  , 4131},
		{5  , 4116},
		{6  , 4101},
		{7  , 4088},
		{8  , 4076},
		{10 , 4065},
		{11 , 4057},
		{12 , 4050},
		{13 , 4044},
		{14 , 4040},
		{16 , 4036},
		{17 , 4031},
		{18 , 4025},
		{19 , 4017},
		{21 , 4008},
		{22 , 3998},
		{23 , 3987},
		{24 , 3976},
		{25 , 3964},
		{27 , 3954},
		{28 , 3943},
		{29 , 3934},
		{30 , 3925},
		{31 , 3918},
		{33 , 3912},
		{34 , 3905},
		{35 , 3898},
		{36 , 3890},
		{37 , 3881},
		{39 , 3873},
		{40 , 3863},
		{41 , 3852},
		{42 , 3840},
		{43 , 3827},
		{45 , 3820},
		{46 , 3802},
		{47 , 3788},
		{48 , 3774},
		{49 , 3762},
		{51 , 3749},
		{52 , 3738},
		{53 , 3727},
		{54 , 3717},
		{55 , 3707},
		{57 , 3698},
		{58 , 3690},
		{59 , 3682},
		{60 , 3675},
		{62 , 3668},
		{63 , 3661},
		{64 , 3655},
		{65 , 3650},
		{66 , 3645},
		{68 , 3640},
		{69 , 3635},
		{70 , 3630},
		{71 , 3625},
		{72 , 3620},
		{74 , 3615},
		{75 , 3608},
		{76 , 3602},
		{77 , 3594},
		{78 , 3587},
		{80 , 3579},
		{81 , 3572},
		{82 , 3565},
		{83 , 3558},
		{84 , 3550},
		{86 , 3542},
		{87 , 3531},
		{88 , 3522},
		{89 , 3511},
		{90 , 3500},
		{92 , 3489},
		{93 , 3481},
		{94 , 3475},
		{95 , 3469},
		{97 , 3462},
		{98 , 3452},
		{99 , 3434},
		{100, 3396}
};

/* T2 25C*/
BATTERY_PROFILE_STRUCT battery_profile_t2[] = {
		{0  , 4190},
		{1  , 4168},
		{2  , 4149},
		{4  , 4131},
		{5  , 4116},
		{6  , 4101},
		{7  , 4088},
		{8  , 4076},
		{10 , 4065},
		{11 , 4057},
		{12 , 4050},
		{13 , 4044},
		{14 , 4040},
		{16 , 4036},
		{17 , 4031},
		{18 , 4025},
		{19 , 4017},
		{21 , 4008},
		{22 , 3998},
		{23 , 3987},
		{24 , 3976},
		{25 , 3964},
		{27 , 3954},
		{28 , 3943},
		{29 , 3934},
		{30 , 3925},
		{31 , 3918},
		{33 , 3912},
		{34 , 3905},
		{35 , 3898},
		{36 , 3890},
		{37 , 3881},
		{39 , 3873},
		{40 , 3863},
		{41 , 3852},
		{42 , 3840},
		{43 , 3827},
		{45 , 3820},
		{46 , 3802},
		{47 , 3788},
		{48 , 3774},
		{49 , 3762},
		{51 , 3749},
		{52 , 3738},
		{53 , 3727},
		{54 , 3717},
		{55 , 3707},
		{57 , 3698},
		{58 , 3690},
		{59 , 3682},
		{60 , 3675},
		{62 , 3668},
		{63 , 3661},
		{64 , 3655},
		{65 , 3650},
		{66 , 3645},
		{68 , 3640},
		{69 , 3635},
		{70 , 3630},
		{71 , 3625},
		{72 , 3620},
		{74 , 3615},
		{75 , 3608},
		{76 , 3602},
		{77 , 3594},
		{78 , 3587},
		{80 , 3579},
		{81 , 3572},
		{82 , 3565},
		{83 , 3558},
		{84 , 3550},
		{86 , 3542},
		{87 , 3531},
		{88 , 3522},
		{89 , 3511},
		{90 , 3500},
		{92 , 3489},
		{93 , 3481},
		{94 , 3475},
		{95 , 3469},
		{97 , 3462},
		{98 , 3452},
		{99 , 3434},
		{100, 3396}
};

/* T3 50C*/
BATTERY_PROFILE_STRUCT battery_profile_t3[] = {
		{0  , 4190},
		{1  , 4168},
		{2  , 4149},
		{4  , 4131},
		{5  , 4116},
		{6  , 4101},
		{7  , 4088},
		{8  , 4076},
		{10 , 4065},
		{11 , 4057},
		{12 , 4050},
		{13 , 4044},
		{14 , 4040},
		{16 , 4036},
		{17 , 4031},
		{18 , 4025},
		{19 , 4017},
		{21 , 4008},
		{22 , 3998},
		{23 , 3987},
		{24 , 3976},
		{25 , 3964},
		{27 , 3954},
		{28 , 3943},
		{29 , 3934},
		{30 , 3925},
		{31 , 3918},
		{33 , 3912},
		{34 , 3905},
		{35 , 3898},
		{36 , 3890},
		{37 , 3881},
		{39 , 3873},
		{40 , 3863},
		{41 , 3852},
		{42 , 3840},
		{43 , 3827},
		{45 , 3820},
		{46 , 3802},
		{47 , 3788},
		{48 , 3774},
		{49 , 3762},
		{51 , 3749},
		{52 , 3738},
		{53 , 3727},
		{54 , 3717},
		{55 , 3707},
		{57 , 3698},
		{58 , 3690},
		{59 , 3682},
		{60 , 3675},
		{62 , 3668},
		{63 , 3661},
		{64 , 3655},
		{65 , 3650},
		{66 , 3645},
		{68 , 3640},
		{69 , 3635},
		{70 , 3630},
		{71 , 3625},
		{72 , 3620},
		{74 , 3615},
		{75 , 3608},
		{76 , 3602},
		{77 , 3594},
		{78 , 3587},
		{80 , 3579},
		{81 , 3572},
		{82 , 3565},
		{83 , 3558},
		{84 , 3550},
		{86 , 3542},
		{87 , 3531},
		{88 , 3522},
		{89 , 3511},
		{90 , 3500},
		{92 , 3489},
		{93 , 3481},
		{94 , 3475},
		{95 , 3469},
		{97 , 3462},
		{98 , 3452},
		{99 , 3434},
		{100, 3396}
};

/* battery profile for actual temperature. The size should be the same as T1, T2 and T3*/
BATTERY_PROFILE_STRUCT battery_profile_temperature[] = {
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
};

/* ============================================================*/
/* <Rbat, Battery_Voltage> Table*/
/* ============================================================*/
/* T0 -10C*/
R_PROFILE_STRUCT r_profile_t0[] = {
		{167 , 4190},
		{167 , 4168},
		{169 , 4149},
		{170 , 4131},
		{172 , 4116},
		{176 , 4101},
		{179 , 4088},
		{180 , 4076},
		{183 , 4065},
		{186 , 4057},
		{190 , 4050},
		{190 , 4044},
		{194 , 4040},
		{199 , 4036},
		{204 , 4031},
		{204 , 4025},
		{203 , 4017},
		{203 , 4008},
		{203 , 3998},
		{204 , 3987},
		{208 , 3976},
		{207 , 3964},
		{209 , 3954},
		{209 , 3943},
		{215 , 3934},
		{218 , 3925},
		{223 , 3918},
		{228 , 3912},
		{229 , 3905},
		{230 , 3898},
		{230 , 3890},
		{233 , 3881},
		{233 , 3873},
		{230 , 3863},
		{226 , 3852},
		{219 , 3840},
		{208 , 3827},
		{189 , 3820},
		{180 , 3802},
		{179 , 3788},
		{175 , 3774},
		{175 , 3762},
		{171 , 3749},
		{171 , 3738},
		{171 , 3727},
		{171 , 3717},
		{171 , 3707},
		{170 , 3698},
		{171 , 3690},
		{171 , 3682},
		{175 , 3675},
		{178 , 3668},
		{180 , 3661},
		{183 , 3655},
		{186 , 3650},
		{186 , 3645},
		{189 , 3640},
		{188 , 3635},
		{189 , 3630},
		{187 , 3625},
		{188 , 3620},
		{185 , 3615},
		{182 , 3608},
		{178 , 3602},
		{176 , 3594},
		{176 , 3587},
		{173 , 3579},
		{175 , 3572},
		{176 , 3565},
		{179 , 3558},
		{180 , 3550},
		{182 , 3542},
		{180 , 3531},
		{182 , 3522},
		{184 , 3511},
		{184 , 3500},
		{180 , 3489},
		{182 , 3481},
		{190 , 3475},
		{201 , 3469},
		{213 , 3462},
		{226 , 3452},
		{236 , 3434},
		{237 , 3396}
};
/* T1 0C*/
R_PROFILE_STRUCT r_profile_t1[] = {
		{167 , 4190},
		{167 , 4168},
		{169 , 4149},
		{170 , 4131},
		{172 , 4116},
		{176 , 4101},
		{179 , 4088},
		{180 , 4076},
		{183 , 4065},
		{186 , 4057},
		{190 , 4050},
		{190 , 4044},
		{194 , 4040},
		{199 , 4036},
		{204 , 4031},
		{204 , 4025},
		{203 , 4017},
		{203 , 4008},
		{203 , 3998},
		{204 , 3987},
		{208 , 3976},
		{207 , 3964},
		{209 , 3954},
		{209 , 3943},
		{215 , 3934},
		{218 , 3925},
		{223 , 3918},
		{228 , 3912},
		{229 , 3905},
		{230 , 3898},
		{230 , 3890},
		{233 , 3881},
		{233 , 3873},
		{230 , 3863},
		{226 , 3852},
		{219 , 3840},
		{208 , 3827},
		{189 , 3820},
		{180 , 3802},
		{179 , 3788},
		{175 , 3774},
		{175 , 3762},
		{171 , 3749},
		{171 , 3738},
		{171 , 3727},
		{171 , 3717},
		{171 , 3707},
		{170 , 3698},
		{171 , 3690},
		{171 , 3682},
		{175 , 3675},
		{178 , 3668},
		{180 , 3661},
		{183 , 3655},
		{186 , 3650},
		{186 , 3645},
		{189 , 3640},
		{188 , 3635},
		{189 , 3630},
		{187 , 3625},
		{188 , 3620},
		{185 , 3615},
		{182 , 3608},
		{178 , 3602},
		{176 , 3594},
		{176 , 3587},
		{173 , 3579},
		{175 , 3572},
		{176 , 3565},
		{179 , 3558},
		{180 , 3550},
		{182 , 3542},
		{180 , 3531},
		{182 , 3522},
		{184 , 3511},
		{184 , 3500},
		{180 , 3489},
		{182 , 3481},
		{190 , 3475},
		{201 , 3469},
		{213 , 3462},
		{226 , 3452},
		{236 , 3434},
		{237 , 3396}
};
/* T2 25C*/
R_PROFILE_STRUCT r_profile_t2[] = {
		{167 , 4190},
		{167 , 4168},
		{169 , 4149},
		{170 , 4131},
		{172 , 4116},
		{176 , 4101},
		{179 , 4088},
		{180 , 4076},
		{183 , 4065},
		{186 , 4057},
		{190 , 4050},
		{190 , 4044},
		{194 , 4040},
		{199 , 4036},
		{204 , 4031},
		{204 , 4025},
		{203 , 4017},
		{203 , 4008},
		{203 , 3998},
		{204 , 3987},
		{208 , 3976},
		{207 , 3964},
		{209 , 3954},
		{209 , 3943},
		{215 , 3934},
		{218 , 3925},
		{223 , 3918},
		{228 , 3912},
		{229 , 3905},
		{230 , 3898},
		{230 , 3890},
		{233 , 3881},
		{233 , 3873},
		{230 , 3863},
		{226 , 3852},
		{219 , 3840},
		{208 , 3827},
		{189 , 3820},
		{180 , 3802},
		{179 , 3788},
		{175 , 3774},
		{175 , 3762},
		{171 , 3749},
		{171 , 3738},
		{171 , 3727},
		{171 , 3717},
		{171 , 3707},
		{170 , 3698},
		{171 , 3690},
		{171 , 3682},
		{175 , 3675},
		{178 , 3668},
		{180 , 3661},
		{183 , 3655},
		{186 , 3650},
		{186 , 3645},
		{189 , 3640},
		{188 , 3635},
		{189 , 3630},
		{187 , 3625},
		{188 , 3620},
		{185 , 3615},
		{182 , 3608},
		{178 , 3602},
		{176 , 3594},
		{176 , 3587},
		{173 , 3579},
		{175 , 3572},
		{176 , 3565},
		{179 , 3558},
		{180 , 3550},
		{182 , 3542},
		{180 , 3531},
		{182 , 3522},
		{184 , 3511},
		{184 , 3500},
		{180 , 3489},
		{182 , 3481},
		{190 , 3475},
		{201 , 3469},
		{213 , 3462},
		{226 , 3452},
		{236 , 3434},
		{237 , 3396}
};
/* T3 50C*/
R_PROFILE_STRUCT r_profile_t3[] = {
		{167 , 4190},
		{167 , 4168},
		{169 , 4149},
		{170 , 4131},
		{172 , 4116},
		{176 , 4101},
		{179 , 4088},
		{180 , 4076},
		{183 , 4065},
		{186 , 4057},
		{190 , 4050},
		{190 , 4044},
		{194 , 4040},
		{199 , 4036},
		{204 , 4031},
		{204 , 4025},
		{203 , 4017},
		{203 , 4008},
		{203 , 3998},
		{204 , 3987},
		{208 , 3976},
		{207 , 3964},
		{209 , 3954},
		{209 , 3943},
		{215 , 3934},
		{218 , 3925},
		{223 , 3918},
		{228 , 3912},
		{229 , 3905},
		{230 , 3898},
		{230 , 3890},
		{233 , 3881},
		{233 , 3873},
		{230 , 3863},
		{226 , 3852},
		{219 , 3840},
		{208 , 3827},
		{189 , 3820},
		{180 , 3802},
		{179 , 3788},
		{175 , 3774},
		{175 , 3762},
		{171 , 3749},
		{171 , 3738},
		{171 , 3727},
		{171 , 3717},
		{171 , 3707},
		{170 , 3698},
		{171 , 3690},
		{171 , 3682},
		{175 , 3675},
		{178 , 3668},
		{180 , 3661},
		{183 , 3655},
		{186 , 3650},
		{186 , 3645},
		{189 , 3640},
		{188 , 3635},
		{189 , 3630},
		{187 , 3625},
		{188 , 3620},
		{185 , 3615},
		{182 , 3608},
		{178 , 3602},
		{176 , 3594},
		{176 , 3587},
		{173 , 3579},
		{175 , 3572},
		{176 , 3565},
		{179 , 3558},
		{180 , 3550},
		{182 , 3542},
		{180 , 3531},
		{182 , 3522},
		{184 , 3511},
		{184 , 3500},
		{180 , 3489},
		{182 , 3481},
		{190 , 3475},
		{201 , 3469},
		{213 , 3462},
		{226 , 3452},
		{236 , 3434},
		{237 , 3396}
};
/* r-table profile for actual temperature. The size should be the same as T1, T2 and T3*/
R_PROFILE_STRUCT r_profile_temperature[] = {
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
};

/* ============================================================*/
/* function prototype*/
/* ============================================================*/
int fgauge_get_saddles(void);
BATTERY_PROFILE_STRUCT_P fgauge_get_profile(unsigned int temperature);

int fgauge_get_saddles_r_table(void);
R_PROFILE_STRUCT_P fgauge_get_profile_r_table(unsigned int temperature);

#endif	/*#ifndef _CUST_BATTERY_METER_TABLE_H*/

