/*
 * Copyright (C) 2015 MediaTek Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef _MT6323_PMIC_UPMU_HW_H_
#define _MT6323_PMIC_UPMU_HW_H_

#define CHR_CON0           0x0000
#define CHR_CON1           0x0002
#define CHR_CON2           0x0004
#define CHR_CON3           0x0006
#define CHR_CON4           0x0008
#define CHR_CON5           0x000A
#define CHR_CON6           0x000C
#define CHR_CON7           0x000E
#define CHR_CON8           0x0010
#define CHR_CON9           0x0012
#define CHR_CON10          0x0014
#define CHR_CON11          0x0016
#define CHR_CON12          0x0018
#define CHR_CON13          0x001A
#define CHR_CON14          0x001C
#define CHR_CON15          0x001E
#define CHR_CON16          0x0020
#define CHR_CON17          0x0022
#define CHR_CON18          0x0024
#define CHR_CON19          0x0026
#define CHR_CON20          0x0028
#define CHR_CON21          0x002A
#define CHR_CON22          0x002C
#define CHR_CON23          0x002E
#define CHR_CON24          0x0030
#define CHR_CON25          0x0032
#define CHR_CON26          0x0034
#define CHR_CON27          0x0036
#define CHR_CON28          0x0038
#define CHR_CON29          0x003A
#define STRUP_CON0         0x003C
#define STRUP_CON2         0x003E
#define STRUP_CON3         0x0040
#define STRUP_CON4         0x0042
#define STRUP_CON5         0x0044
#define STRUP_CON6         0x0046
#define STRUP_CON7         0x0048
#define STRUP_CON8         0x004A
#define STRUP_CON9         0x004C
#define STRUP_CON10        0x004E
#define STRUP_CON11        0x0050
#define SPK_CON0           0x0052
#define SPK_CON1           0x0054
#define SPK_CON2           0x0056
#define SPK_CON6           0x005E
#define SPK_CON7           0x0060
#define SPK_CON8           0x0062
#define SPK_CON9           0x0064
#define SPK_CON10          0x0066
#define SPK_CON11          0x0068
#define SPK_CON12          0x006A
#define CID                0x0100
#define TOP_CKPDN0         0x0102
#define TOP_CKPDN0_SET     0x0104
#define TOP_CKPDN0_CLR     0x0106
#define TOP_CKPDN1         0x0108
#define TOP_CKPDN1_SET     0x010A
#define TOP_CKPDN1_CLR     0x010C
#define TOP_CKPDN2         0x010E
#define TOP_CKPDN2_SET     0x0110
#define TOP_CKPDN2_CLR     0x0112
#define TOP_RST_CON        0x0114
#define TOP_RST_CON_SET    0x0116
#define TOP_RST_CON_CLR    0x0118
#define TOP_RST_MISC       0x011A
#define TOP_RST_MISC_SET   0x011C
#define TOP_RST_MISC_CLR   0x011E
#define TOP_CKCON0         0x0120
#define TOP_CKCON0_SET     0x0122
#define TOP_CKCON0_CLR     0x0124
#define TOP_CKCON1         0x0126
#define TOP_CKCON1_SET     0x0128
#define TOP_CKCON1_CLR     0x012A
#define TOP_CKTST0         0x012C
#define TOP_CKTST1         0x012E
#define TOP_CKTST2         0x0130
#define TEST_OUT           0x0132
#define TEST_CON0          0x0134
#define TEST_CON1          0x0136
#define EN_STATUS0         0x0138
#define EN_STATUS1         0x013A
#define OCSTATUS0          0x013C
#define OCSTATUS1          0x013E
#define PGSTATUS           0x0140
#define CHRSTATUS          0x0142
#define TDSEL_CON          0x0144
#define RDSEL_CON          0x0146
#define SMT_CON0           0x0148
#define SMT_CON1           0x014A
#define SMT_CON2           0x014C
#define SMT_CON3           0x014E
#define SMT_CON4           0x0150
#define DRV_CON0           0x0152
#define DRV_CON1           0x0154
#define DRV_CON2           0x0156
#define DRV_CON3           0x0158
#define DRV_CON4           0x015A
#define SIMLS1_CON         0x015C
#define SIMLS2_CON         0x015E
#define INT_CON0           0x0160
#define INT_CON0_SET       0x0162
#define INT_CON0_CLR       0x0164
#define INT_CON1           0x0166
#define INT_CON1_SET       0x0168
#define INT_CON1_CLR       0x016A
#define INT_MISC_CON       0x016C
#define INT_MISC_CON_SET   0x016E
#define INT_MISC_CON_CLR   0x0170
#define INT_STATUS0        0x0172
#define INT_STATUS1        0x0174
#define OC_GEAR_0          0x0176
#define OC_GEAR_1          0x0178
#define OC_GEAR_2          0x017A
#define OC_CTL_VPROC       0x017C
#define OC_CTL_VSYS        0x017E
#define OC_CTL_VPA         0x0180
#define FQMTR_CON0         0x0182
#define FQMTR_CON1         0x0184
#define FQMTR_CON2         0x0186
#define RG_SPI_CON         0x0188
#define DEW_DIO_EN         0x018A
#define DEW_READ_TEST      0x018C
#define DEW_WRITE_TEST     0x018E
#define DEW_CRC_SWRST      0x0190
#define DEW_CRC_EN         0x0192
#define DEW_CRC_VAL        0x0194
#define DEW_DBG_MON_SEL    0x0196
#define DEW_CIPHER_KEY_SEL 0x0198
#define DEW_CIPHER_IV_SEL  0x019A
#define DEW_CIPHER_EN      0x019C
#define DEW_CIPHER_RDY     0x019E
#define DEW_CIPHER_MODE    0x01A0
#define DEW_CIPHER_SWRST   0x01A2
#define DEW_RDDMY_NO       0x01A4
#define DEW_RDATA_DLY_SEL  0x01A6
#define BUCK_CON0          0x0200
#define BUCK_CON1          0x0202
#define BUCK_CON2          0x0204
#define BUCK_CON3          0x0206
#define BUCK_CON4          0x0208
#define BUCK_CON5          0x020A
#define VPROC_CON0         0x020C
#define VPROC_CON1         0x020E
#define VPROC_CON2         0x0210
#define VPROC_CON3         0x0212
#define VPROC_CON4         0x0214
#define VPROC_CON5         0x0216
#define VPROC_CON7         0x021A
#define VPROC_CON8         0x021C
#define VPROC_CON9         0x021E
#define VPROC_CON10        0x0220
#define VPROC_CON11        0x0222
#define VPROC_CON12        0x0224
#define VPROC_CON13        0x0226
#define VPROC_CON14        0x0228
#define VPROC_CON15        0x022A
#define VPROC_CON18        0x0230
#define VSYS_CON0          0x0232
#define VSYS_CON1          0x0234
#define VSYS_CON2          0x0236
#define VSYS_CON3          0x0238
#define VSYS_CON4          0x023A
#define VSYS_CON5          0x023C
#define VSYS_CON7          0x0240
#define VSYS_CON8          0x0242
#define VSYS_CON9          0x0244
#define VSYS_CON10         0x0246
#define VSYS_CON11         0x0248
#define VSYS_CON12         0x024A
#define VSYS_CON13         0x024C
#define VSYS_CON14         0x024E
#define VSYS_CON15         0x0250
#define VSYS_CON18         0x0256
#define VPA_CON0           0x0300
#define VPA_CON1           0x0302
#define VPA_CON2           0x0304
#define VPA_CON3           0x0306
#define VPA_CON4           0x0308
#define VPA_CON5           0x030A
#define VPA_CON7           0x030E
#define VPA_CON8           0x0310
#define VPA_CON9           0x0312
#define VPA_CON10          0x0314
#define VPA_CON11          0x0316
#define VPA_CON12          0x0318
#define VPA_CON14          0x031C
#define VPA_CON16          0x0320
#define VPA_CON17          0x0322
#define VPA_CON18          0x0324
#define VPA_CON19          0x0326
#define VPA_CON20          0x0328
#define BUCK_K_CON0        0x032A
#define BUCK_K_CON1        0x032C
#define BUCK_K_CON2        0x032E
#define ISINK0_CON0        0x0330
#define ISINK0_CON1        0x0332
#define ISINK0_CON2        0x0334
#define ISINK0_CON3        0x0336
#define ISINK1_CON0        0x0338
#define ISINK1_CON1        0x033A
#define ISINK1_CON2        0x033C
#define ISINK1_CON3        0x033E
#define ISINK2_CON0        0x0340
#define ISINK2_CON1        0x0342
#define ISINK2_CON2        0x0344
#define ISINK2_CON3        0x0346
#define ISINK3_CON0        0x0348
#define ISINK3_CON1        0x034A
#define ISINK3_CON2        0x034C
#define ISINK3_CON3        0x034E
#define ISINK_ANA0         0x0350
#define ISINK_ANA1         0x0352
#define ISINK_PHASE_DLY    0x0354
#define ISINK_EN_CTRL      0x0356
#define ANALDO_CON0        0x0400
#define ANALDO_CON1        0x0402
#define ANALDO_CON2        0x0404
#define ANALDO_CON3        0x0406
#define ANALDO_CON4        0x0408
#define ANALDO_CON5        0x040A
#define ANALDO_CON6        0x040C
#define ANALDO_CON7        0x040E
#define ANALDO_CON8        0x0410
#define ANALDO_CON10       0x0412
#define ANALDO_CON15       0x0414
#define ANALDO_CON16       0x0416
#define ANALDO_CON17       0x0418
#define ANALDO_CON18       0x041A
#define ANALDO_CON19       0x041C
#define ANALDO_CON20       0x041E
#define ANALDO_CON21       0x0420
#define DIGLDO_CON0        0x0500
#define DIGLDO_CON2        0x0502
#define DIGLDO_CON3        0x0504
#define DIGLDO_CON5        0x0506
#define DIGLDO_CON6        0x0508
#define DIGLDO_CON7        0x050A
#define DIGLDO_CON8        0x050C
#define DIGLDO_CON9        0x050E
#define DIGLDO_CON10       0x0510
#define DIGLDO_CON11       0x0512
#define DIGLDO_CON12       0x0514
#define DIGLDO_CON13       0x0516
#define DIGLDO_CON14       0x0518
#define DIGLDO_CON15       0x051A
#define DIGLDO_CON16       0x051C
#define DIGLDO_CON17       0x051E
#define DIGLDO_CON18       0x0520
#define DIGLDO_CON19       0x0522
#define DIGLDO_CON20       0x0524
#define DIGLDO_CON21       0x0526
#define DIGLDO_CON23       0x0528
#define DIGLDO_CON24       0x052A
#define DIGLDO_CON26       0x052C
#define DIGLDO_CON27       0x052E
#define DIGLDO_CON28       0x0530
#define DIGLDO_CON29       0x0532
#define DIGLDO_CON30       0x0534
#define DIGLDO_CON31       0x0536
#define DIGLDO_CON32       0x0538
#define DIGLDO_CON33       0x053A
#define DIGLDO_CON34       0x053C
#define DIGLDO_CON35       0x053E
#define DIGLDO_CON36       0x0540
#define DIGLDO_CON39       0x0542
#define DIGLDO_CON40       0x0544
#define DIGLDO_CON41       0x0546
#define DIGLDO_CON42       0x0548
#define DIGLDO_CON43       0x054A
#define DIGLDO_CON44       0x054C
#define DIGLDO_CON45       0x054E
#define DIGLDO_CON46       0x0550
#define DIGLDO_CON47       0x0552
#define DIGLDO_CON48       0x0554
#define DIGLDO_CON49       0x0556
#define DIGLDO_CON50       0x0558
#define DIGLDO_CON51       0x055A
#define DIGLDO_CON52       0x055C
#define DIGLDO_CON53       0x055E
#define DIGLDO_CON54       0x0560
#define EFUSE_CON0         0x0600
#define EFUSE_CON1         0x0602
#define EFUSE_CON2         0x0604
#define EFUSE_CON3         0x0606
#define EFUSE_CON4         0x0608
#define EFUSE_CON5         0x060A
#define EFUSE_CON6         0x060C
#define EFUSE_VAL_0_15     0x060E
#define EFUSE_VAL_16_31    0x0610
#define EFUSE_VAL_32_47    0x0612
#define EFUSE_VAL_48_63    0x0614
#define EFUSE_VAL_64_79    0x0616
#define EFUSE_VAL_80_95    0x0618
#define EFUSE_VAL_96_111   0x061A
#define EFUSE_VAL_112_127  0x061C
#define EFUSE_VAL_128_143  0x061E
#define EFUSE_VAL_144_159  0x0620
#define EFUSE_VAL_160_175  0x0622
#define EFUSE_VAL_176_191  0x0624
#define EFUSE_DOUT_0_15    0x0626
#define EFUSE_DOUT_16_31   0x0628
#define EFUSE_DOUT_32_47   0x062A
#define EFUSE_DOUT_48_63   0x062C
#define EFUSE_DOUT_64_79   0x062E
#define EFUSE_DOUT_80_95   0x0630
#define EFUSE_DOUT_96_111  0x0632
#define EFUSE_DOUT_112_127 0x0634
#define EFUSE_DOUT_128_143 0x0636
#define EFUSE_DOUT_144_159 0x0638
#define EFUSE_DOUT_160_175 0x063A
#define EFUSE_DOUT_176_191 0x063C
#define EFUSE_CON7         0x063E
#define EFUSE_CON8         0x0640
#define EFUSE_CON9         0x0642
#define RTC_MIX_CON0       0x0644
#define RTC_MIX_CON1       0x0646
#define AUDTOP_CON0        0x0700
#define AUDTOP_CON1        0x0702
#define AUDTOP_CON2        0x0704
#define AUDTOP_CON3        0x0706
#define AUDTOP_CON4        0x0708
#define AUDTOP_CON5        0x070A
#define AUDTOP_CON6        0x070C
#define AUDTOP_CON7        0x070E
#define AUDTOP_CON8        0x0710
#define AUDTOP_CON9        0x0712
#define AUXADC_ADC0        0x0714
#define AUXADC_ADC1        0x0716
#define AUXADC_ADC2        0x0718
#define AUXADC_ADC3        0x071A
#define AUXADC_ADC4        0x071C
#define AUXADC_ADC5        0x071E
#define AUXADC_ADC6        0x0720
#define AUXADC_ADC7        0x0722
#define AUXADC_ADC8        0x0724
#define AUXADC_ADC9        0x0726
#define AUXADC_ADC10       0x0728
#define AUXADC_ADC11       0x072A
#define AUXADC_ADC12       0x072C
#define AUXADC_ADC13       0x072E
#define AUXADC_ADC14       0x0730
#define AUXADC_ADC15       0x0732
#define AUXADC_ADC16       0x0734
#define AUXADC_ADC17       0x0736
#define AUXADC_ADC18       0x0738
#define AUXADC_ADC19       0x073A
#define AUXADC_ADC20       0x073C
#define AUXADC_RSV1        0x073E
#define AUXADC_RSV2        0x0740
#define AUXADC_CON0        0x0742
#define AUXADC_CON1        0x0744
#define AUXADC_CON2        0x0746
#define AUXADC_CON3        0x0748
#define AUXADC_CON4        0x074A
#define AUXADC_CON5        0x074C
#define AUXADC_CON6        0x074E
#define AUXADC_CON7        0x0750
#define AUXADC_CON8        0x0752
#define AUXADC_CON9        0x0754
#define AUXADC_CON10       0x0756
#define AUXADC_CON11       0x0758
#define AUXADC_CON12       0x075A
#define AUXADC_CON13       0x075C
#define AUXADC_CON14       0x075E
#define AUXADC_CON15       0x0760
#define AUXADC_CON16       0x0762
#define AUXADC_CON17       0x0764
#define AUXADC_CON18       0x0766
#define AUXADC_CON19       0x0768
#define AUXADC_CON20       0x076A
#define AUXADC_CON21       0x076C
#define AUXADC_CON22       0x076E
#define AUXADC_CON23       0x0770
#define AUXADC_CON24       0x0772
#define AUXADC_CON25       0x0774
#define AUXADC_CON26       0x0776
#define AUXADC_CON27       0x0778
#define ACCDET_CON0        0x077A
#define ACCDET_CON1        0x077C
#define ACCDET_CON2        0x077E
#define ACCDET_CON3        0x0780
#define ACCDET_CON4        0x0782
#define ACCDET_CON5        0x0784
#define ACCDET_CON6        0x0786
#define ACCDET_CON7        0x0788
#define ACCDET_CON8        0x078A
#define ACCDET_CON9        0x078C
#define ACCDET_CON10       0x078E
#define ACCDET_CON11       0x0790
#define ACCDET_CON12       0x0792
#define ACCDET_CON13       0x0794
#define ACCDET_CON14       0x0796
#define ACCDET_CON15       0x0798
#define ACCDET_CON16       0x079A

#define PMIC_RG_VCDT_HV_EN_MASK                    0x1
#define PMIC_RG_VCDT_HV_EN_SHIFT                   0
#define PMIC_RGS_CHR_LDO_DET_MASK                  0x1
#define PMIC_RGS_CHR_LDO_DET_SHIFT                 1
#define PMIC_RG_PCHR_AUTOMODE_MASK                 0x1
#define PMIC_RG_PCHR_AUTOMODE_SHIFT                2
#define PMIC_RG_CSDAC_EN_MASK                      0x1
#define PMIC_RG_CSDAC_EN_SHIFT                     3
#define PMIC_RG_CHR_EN_MASK                        0x1
#define PMIC_RG_CHR_EN_SHIFT                       4
#define PMIC_RGS_CHRDET_MASK                       0x1
#define PMIC_RGS_CHRDET_SHIFT                      5
#define PMIC_RGS_VCDT_LV_DET_MASK                  0x1
#define PMIC_RGS_VCDT_LV_DET_SHIFT                 6
#define PMIC_RGS_VCDT_HV_DET_MASK                  0x1
#define PMIC_RGS_VCDT_HV_DET_SHIFT                 7
#define PMIC_RG_VCDT_LV_VTH_MASK                   0xF
#define PMIC_RG_VCDT_LV_VTH_SHIFT                  0
#define PMIC_RG_VCDT_HV_VTH_MASK                   0xF
#define PMIC_RG_VCDT_HV_VTH_SHIFT                  4
#define PMIC_RG_VBAT_CV_EN_MASK                    0x1
#define PMIC_RG_VBAT_CV_EN_SHIFT                   1
#define PMIC_RG_VBAT_CC_EN_MASK                    0x1
#define PMIC_RG_VBAT_CC_EN_SHIFT                   2
#define PMIC_RG_CS_EN_MASK                         0x1
#define PMIC_RG_CS_EN_SHIFT                        3
#define PMIC_RGS_CS_DET_MASK                       0x1
#define PMIC_RGS_CS_DET_SHIFT                      5
#define PMIC_RGS_VBAT_CV_DET_MASK                  0x1
#define PMIC_RGS_VBAT_CV_DET_SHIFT                 6
#define PMIC_RGS_VBAT_CC_DET_MASK                  0x1
#define PMIC_RGS_VBAT_CC_DET_SHIFT                 7
#define PMIC_RG_VBAT_CV_VTH_MASK                   0x1F
#define PMIC_RG_VBAT_CV_VTH_SHIFT                  0
#define PMIC_RG_VBAT_CC_VTH_MASK                   0x3
#define PMIC_RG_VBAT_CC_VTH_SHIFT                  6
#define PMIC_RG_CS_VTH_MASK                        0xF
#define PMIC_RG_CS_VTH_SHIFT                       0
#define PMIC_RG_PCHR_TOHTC_MASK                    0x7
#define PMIC_RG_PCHR_TOHTC_SHIFT                   0
#define PMIC_RG_PCHR_TOLTC_MASK                    0x7
#define PMIC_RG_PCHR_TOLTC_SHIFT                   4
#define PMIC_RG_VBAT_OV_EN_MASK                    0x1
#define PMIC_RG_VBAT_OV_EN_SHIFT                   0
#define PMIC_RG_VBAT_OV_VTH_MASK                   0x7
#define PMIC_RG_VBAT_OV_VTH_SHIFT                  1
#define PMIC_RG_VBAT_OV_DEG_MASK                   0x1
#define PMIC_RG_VBAT_OV_DEG_SHIFT                  5
#define PMIC_RGS_VBAT_OV_DET_MASK                  0x1
#define PMIC_RGS_VBAT_OV_DET_SHIFT                 6
#define PMIC_RG_BATON_EN_MASK                      0x1
#define PMIC_RG_BATON_EN_SHIFT                     0
#define PMIC_RG_BATON_HT_EN_MASK                   0x1
#define PMIC_RG_BATON_HT_EN_SHIFT                  1
#define PMIC_BATON_TDET_EN_MASK                    0x1
#define PMIC_BATON_TDET_EN_SHIFT                   2
#define PMIC_RG_BATON_HT_TRIM_MASK                 0x7
#define PMIC_RG_BATON_HT_TRIM_SHIFT                4
#define PMIC_RG_BATON_HT_TRIM_SET_MASK             0x1
#define PMIC_RG_BATON_HT_TRIM_SET_SHIFT            7
#define PMIC_RGS_BATON_UNDET_MASK                  0x1
#define PMIC_RGS_BATON_UNDET_SHIFT                 12
#define PMIC_RG_CSDAC_DATA_MASK                    0x3FF
#define PMIC_RG_CSDAC_DATA_SHIFT                   0
#define PMIC_RG_FRC_CSVTH_USBDL_MASK               0x1
#define PMIC_RG_FRC_CSVTH_USBDL_SHIFT              0
#define PMIC_RGS_PCHR_FLAG_OUT_MASK                0xF
#define PMIC_RGS_PCHR_FLAG_OUT_SHIFT               0
#define PMIC_RG_PCHR_FLAG_EN_MASK                  0x1
#define PMIC_RG_PCHR_FLAG_EN_SHIFT                 4
#define PMIC_RG_OTG_BVALID_EN_MASK                 0x1
#define PMIC_RG_OTG_BVALID_EN_SHIFT                5
#define PMIC_RGS_OTG_BVALID_DET_MASK               0x1
#define PMIC_RGS_OTG_BVALID_DET_SHIFT              6
#define PMIC_RG_PCHR_FLAG_SEL_MASK                 0x3F
#define PMIC_RG_PCHR_FLAG_SEL_SHIFT                0
#define PMIC_RG_PCHR_TESTMODE_MASK                 0x1
#define PMIC_RG_PCHR_TESTMODE_SHIFT                0
#define PMIC_RG_CSDAC_TESTMODE_MASK                0x1
#define PMIC_RG_CSDAC_TESTMODE_SHIFT               1
#define PMIC_RG_PCHR_RST_MASK                      0x1
#define PMIC_RG_PCHR_RST_SHIFT                     2
#define PMIC_RG_PCHR_FT_CTRL_MASK                  0x7
#define PMIC_RG_PCHR_FT_CTRL_SHIFT                 4
#define PMIC_RG_CHRWDT_TD_MASK                     0xF
#define PMIC_RG_CHRWDT_TD_SHIFT                    0
#define PMIC_RG_CHRWDT_EN_MASK                     0x1
#define PMIC_RG_CHRWDT_EN_SHIFT                    4
#define PMIC_RG_CHRWDT_WR_MASK                     0x1
#define PMIC_RG_CHRWDT_WR_SHIFT                    8
#define PMIC_RG_PCHR_RV_MASK                       0xFF
#define PMIC_RG_PCHR_RV_SHIFT                      0
#define PMIC_RG_CHRWDT_INT_EN_MASK                 0x1
#define PMIC_RG_CHRWDT_INT_EN_SHIFT                0
#define PMIC_RG_CHRWDT_FLAG_WR_MASK                0x1
#define PMIC_RG_CHRWDT_FLAG_WR_SHIFT               1
#define PMIC_RGS_CHRWDT_OUT_MASK                   0x1
#define PMIC_RGS_CHRWDT_OUT_SHIFT                  2
#define PMIC_RG_UVLO_VTHL_MASK                     0x3
#define PMIC_RG_UVLO_VTHL_SHIFT                    0
#define PMIC_RG_USBDL_RST_MASK                     0x1
#define PMIC_RG_USBDL_RST_SHIFT                    2
#define PMIC_RG_USBDL_SET_MASK                     0x1
#define PMIC_RG_USBDL_SET_SHIFT                    3
#define PMIC_ADCIN_VSEN_MUX_EN_MASK                0x1
#define PMIC_ADCIN_VSEN_MUX_EN_SHIFT               8
#define PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_MASK       0x1
#define PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_SHIFT      9
#define PMIC_ADCIN_VBAT_EN_MASK                    0x1
#define PMIC_ADCIN_VBAT_EN_SHIFT                   10
#define PMIC_ADCIN_VSEN_EN_MASK                    0x1
#define PMIC_ADCIN_VSEN_EN_SHIFT                   11
#define PMIC_ADCIN_VCHR_EN_MASK                    0x1
#define PMIC_ADCIN_VCHR_EN_SHIFT                   12
#define PMIC_RG_BGR_RSEL_MASK                      0x7
#define PMIC_RG_BGR_RSEL_SHIFT                     0
#define PMIC_RG_BGR_UNCHOP_PH_MASK                 0x1
#define PMIC_RG_BGR_UNCHOP_PH_SHIFT                4
#define PMIC_RG_BGR_UNCHOP_MASK                    0x1
#define PMIC_RG_BGR_UNCHOP_SHIFT                   5
#define PMIC_RG_BC11_BB_CTRL_MASK                  0x1
#define PMIC_RG_BC11_BB_CTRL_SHIFT                 0
#define PMIC_RG_BC11_RST_MASK                      0x1
#define PMIC_RG_BC11_RST_SHIFT                     1
#define PMIC_RG_BC11_VSRC_EN_MASK                  0x3
#define PMIC_RG_BC11_VSRC_EN_SHIFT                 2
#define PMIC_RGS_BC11_CMP_OUT_MASK                 0x1
#define PMIC_RGS_BC11_CMP_OUT_SHIFT                7
#define PMIC_RG_BC11_VREF_VTH_MASK                 0x3
#define PMIC_RG_BC11_VREF_VTH_SHIFT                0
#define PMIC_RG_BC11_CMP_EN_MASK                   0x3
#define PMIC_RG_BC11_CMP_EN_SHIFT                  2
#define PMIC_RG_BC11_IPD_EN_MASK                   0x3
#define PMIC_RG_BC11_IPD_EN_SHIFT                  4
#define PMIC_RG_BC11_IPU_EN_MASK                   0x3
#define PMIC_RG_BC11_IPU_EN_SHIFT                  6
#define PMIC_RG_BC11_BIAS_EN_MASK                  0x1
#define PMIC_RG_BC11_BIAS_EN_SHIFT                 8
#define PMIC_RG_CSDAC_STP_INC_MASK                 0x7
#define PMIC_RG_CSDAC_STP_INC_SHIFT                0
#define PMIC_RG_CSDAC_STP_DEC_MASK                 0x7
#define PMIC_RG_CSDAC_STP_DEC_SHIFT                4
#define PMIC_RG_CSDAC_DLY_MASK                     0x7
#define PMIC_RG_CSDAC_DLY_SHIFT                    0
#define PMIC_RG_CSDAC_STP_MASK                     0x7
#define PMIC_RG_CSDAC_STP_SHIFT                    4
#define PMIC_RG_LOW_ICH_DB_MASK                    0x3F
#define PMIC_RG_LOW_ICH_DB_SHIFT                   0
#define PMIC_RG_CHRIND_ON_MASK                     0x1
#define PMIC_RG_CHRIND_ON_SHIFT                    6
#define PMIC_RG_CHRIND_DIMMING_MASK                0x1
#define PMIC_RG_CHRIND_DIMMING_SHIFT               7
#define PMIC_RG_CV_MODE_MASK                       0x1
#define PMIC_RG_CV_MODE_SHIFT                      0
#define PMIC_RG_VCDT_MODE_MASK                     0x1
#define PMIC_RG_VCDT_MODE_SHIFT                    1
#define PMIC_RG_CSDAC_MODE_MASK                    0x1
#define PMIC_RG_CSDAC_MODE_SHIFT                   2
#define PMIC_RG_TRACKING_EN_MASK                   0x1
#define PMIC_RG_TRACKING_EN_SHIFT                  4
#define PMIC_RG_HWCV_EN_MASK                       0x1
#define PMIC_RG_HWCV_EN_SHIFT                      6
#define PMIC_RG_ULC_DET_EN_MASK                    0x1
#define PMIC_RG_ULC_DET_EN_SHIFT                   7
#define PMIC_RG_BGR_TRIM_EN_MASK                   0x1
#define PMIC_RG_BGR_TRIM_EN_SHIFT                  0
#define PMIC_RG_ICHRG_TRIM_MASK                    0xF
#define PMIC_RG_ICHRG_TRIM_SHIFT                   4
#define PMIC_RG_BGR_TRIM_MASK                      0x1F
#define PMIC_RG_BGR_TRIM_SHIFT                     0
#define PMIC_RG_OVP_TRIM_MASK                      0xF
#define PMIC_RG_OVP_TRIM_SHIFT                     0
#define PMIC_RG_CHR_OSC_TRIM_MASK                  0x1F
#define PMIC_RG_CHR_OSC_TRIM_SHIFT                 0
#define PMIC_QI_BGR_EXT_BUF_EN_MASK                0x1
#define PMIC_QI_BGR_EXT_BUF_EN_SHIFT               5
#define PMIC_RG_BGR_TEST_EN_MASK                   0x1
#define PMIC_RG_BGR_TEST_EN_SHIFT                  6
#define PMIC_RG_BGR_TEST_RSTB_MASK                 0x1
#define PMIC_RG_BGR_TEST_RSTB_SHIFT                7
#define PMIC_RG_DAC_USBDL_MAX_MASK                 0x3FF
#define PMIC_RG_DAC_USBDL_MAX_SHIFT                0
#define PMIC_RG_PCHR_RSV_MASK                      0xFF
#define PMIC_RG_PCHR_RSV_SHIFT                     0
#define PMIC_THR_DET_DIS_MASK                      0x1
#define PMIC_THR_DET_DIS_SHIFT                     0
#define PMIC_RG_THR_TMODE_MASK                     0x1
#define PMIC_RG_THR_TMODE_SHIFT                    1
#define PMIC_RG_THR_TEMP_SEL_MASK                  0x1
#define PMIC_RG_THR_TEMP_SEL_SHIFT                 2
#define PMIC_RG_STRUP_THR_SEL_MASK                 0x3
#define PMIC_RG_STRUP_THR_SEL_SHIFT                3
#define PMIC_THR_HWPDN_EN_MASK                     0x1
#define PMIC_THR_HWPDN_EN_SHIFT                    5
#define PMIC_RG_THRDET_SEL_MASK                    0x1
#define PMIC_RG_THRDET_SEL_SHIFT                   6
#define PMIC_RG_STRUP_IREF_TRIM_MASK               0x1F
#define PMIC_RG_STRUP_IREF_TRIM_SHIFT              0
#define PMIC_RG_USBDL_EN_MASK                      0x1
#define PMIC_RG_USBDL_EN_SHIFT                     0
#define PMIC_RG_FCHR_KEYDET_EN_MASK                0x1
#define PMIC_RG_FCHR_KEYDET_EN_SHIFT               1
#define PMIC_RG_FCHR_PU_EN_MASK                    0x1
#define PMIC_RG_FCHR_PU_EN_SHIFT                   2
#define PMIC_RG_EN_DRVSEL_MASK                     0x1
#define PMIC_RG_EN_DRVSEL_SHIFT                    4
#define PMIC_RG_RST_DRVSEL_MASK                    0x1
#define PMIC_RG_RST_DRVSEL_SHIFT                   5
#define PMIC_RG_VREF_BG_MASK                       0x7
#define PMIC_RG_VREF_BG_SHIFT                      12
#define PMIC_RG_PMU_RSV_MASK                       0xF
#define PMIC_RG_PMU_RSV_SHIFT                      0
#define PMIC_THR_TEST_MASK                         0x3
#define PMIC_THR_TEST_SHIFT                        0
#define PMIC_PMU_THR_DEB_MASK                      0x7
#define PMIC_PMU_THR_DEB_SHIFT                     4
#define PMIC_PMU_THR_STATUS_MASK                   0x7
#define PMIC_PMU_THR_STATUS_SHIFT                  8
#define PMIC_DDUVLO_DEB_EN_MASK                    0x1
#define PMIC_DDUVLO_DEB_EN_SHIFT                   0
#define PMIC_PWRBB_DEB_EN_MASK                     0x1
#define PMIC_PWRBB_DEB_EN_SHIFT                    1
#define PMIC_STRUP_OSC_EN_MASK                     0x1
#define PMIC_STRUP_OSC_EN_SHIFT                    2
#define PMIC_STRUP_OSC_EN_SEL_MASK                 0x1
#define PMIC_STRUP_OSC_EN_SEL_SHIFT                3
#define PMIC_STRUP_FT_CTRL_MASK                    0x3
#define PMIC_STRUP_FT_CTRL_SHIFT                   4
#define PMIC_STRUP_PWRON_FORCE_MASK                0x1
#define PMIC_STRUP_PWRON_FORCE_SHIFT               6
#define PMIC_BIAS_GEN_EN_FORCE_MASK                0x1
#define PMIC_BIAS_GEN_EN_FORCE_SHIFT               7
#define PMIC_STRUP_PWRON_MASK                      0x1
#define PMIC_STRUP_PWRON_SHIFT                     8
#define PMIC_STRUP_PWRON_SEL_MASK                  0x1
#define PMIC_STRUP_PWRON_SEL_SHIFT                 9
#define PMIC_BIAS_GEN_EN_MASK                      0x1
#define PMIC_BIAS_GEN_EN_SHIFT                     10
#define PMIC_BIAS_GEN_EN_SEL_MASK                  0x1
#define PMIC_BIAS_GEN_EN_SEL_SHIFT                 11
#define PMIC_RTC_XOSC32_ENB_SW_MASK                0x1
#define PMIC_RTC_XOSC32_ENB_SW_SHIFT               12
#define PMIC_RTC_XOSC32_ENB_SEL_MASK               0x1
#define PMIC_RTC_XOSC32_ENB_SEL_SHIFT              13
#define PMIC_STRUP_DIG_IO_PG_FORCE_MASK            0x1
#define PMIC_STRUP_DIG_IO_PG_FORCE_SHIFT           15
#define PMIC_VPROC_PG_ENB_MASK                     0x1
#define PMIC_VPROC_PG_ENB_SHIFT                    0
#define PMIC_VSYS_PG_ENB_MASK                      0x1
#define PMIC_VSYS_PG_ENB_SHIFT                     1
#define PMIC_VM_PG_ENB_MASK                        0x1
#define PMIC_VM_PG_ENB_SHIFT                       2
#define PMIC_VIO18_PG_ENB_MASK                     0x1
#define PMIC_VIO18_PG_ENB_SHIFT                    3
#define PMIC_VTCXO_PG_ENB_MASK                     0x1
#define PMIC_VTCXO_PG_ENB_SHIFT                    4
#define PMIC_VA_PG_ENB_MASK                        0x1
#define PMIC_VA_PG_ENB_SHIFT                       5
#define PMIC_VIO28_PG_ENB_MASK                     0x1
#define PMIC_VIO28_PG_ENB_SHIFT                    6
#define PMIC_VGP2_PG_ENB_MASK                      0x1
#define PMIC_VGP2_PG_ENB_SHIFT                     7
#define PMIC_VPROC_PG_H2L_EN_MASK                  0x1
#define PMIC_VPROC_PG_H2L_EN_SHIFT                 8
#define PMIC_VSYS_PG_H2L_EN_MASK                   0x1
#define PMIC_VSYS_PG_H2L_EN_SHIFT                  9
#define PMIC_STRUP_CON6_RSV0_MASK                  0x3
#define PMIC_STRUP_CON6_RSV0_SHIFT                 10
#define PMIC_CLR_JUST_RST_MASK                     0x1
#define PMIC_CLR_JUST_RST_SHIFT                    4
#define PMIC_UVLO_L2H_DEB_EN_MASK                  0x1
#define PMIC_UVLO_L2H_DEB_EN_SHIFT                 5
#define PMIC_JUST_PWRKEY_RST_MASK                  0x1
#define PMIC_JUST_PWRKEY_RST_SHIFT                 14
#define PMIC_QI_OSC_EN_MASK                        0x1
#define PMIC_QI_OSC_EN_SHIFT                       15
#define PMIC_STRUP_EXT_PMIC_EN_MASK                0x1
#define PMIC_STRUP_EXT_PMIC_EN_SHIFT               0
#define PMIC_STRUP_EXT_PMIC_SEL_MASK               0x1
#define PMIC_STRUP_EXT_PMIC_SEL_SHIFT              1
#define PMIC_STRUP_CON8_RSV0_MASK                  0x7F
#define PMIC_STRUP_CON8_RSV0_SHIFT                 8
#define PMIC_QI_EXT_PMIC_EN_MASK                   0x1
#define PMIC_QI_EXT_PMIC_EN_SHIFT                  15
#define PMIC_STRUP_AUXADC_START_SW_MASK            0x1
#define PMIC_STRUP_AUXADC_START_SW_SHIFT           4
#define PMIC_STRUP_AUXADC_RSTB_SW_MASK             0x1
#define PMIC_STRUP_AUXADC_RSTB_SW_SHIFT            5
#define PMIC_STRUP_AUXADC_START_SEL_MASK           0x1
#define PMIC_STRUP_AUXADC_START_SEL_SHIFT          6
#define PMIC_STRUP_AUXADC_RSTB_SEL_MASK            0x1
#define PMIC_STRUP_AUXADC_RSTB_SEL_SHIFT           7
#define PMIC_STRUP_PWROFF_SEQ_EN_MASK              0x1
#define PMIC_STRUP_PWROFF_SEQ_EN_SHIFT             0
#define PMIC_STRUP_PWROFF_PREOFF_EN_MASK           0x1
#define PMIC_STRUP_PWROFF_PREOFF_EN_SHIFT          1
#define PMIC_SPK_EN_L_MASK                         0x1
#define PMIC_SPK_EN_L_SHIFT                        0
#define PMIC_SPKMODE_L_MASK                        0x1
#define PMIC_SPKMODE_L_SHIFT                       2
#define PMIC_SPK_TRIM_EN_L_MASK                    0x1
#define PMIC_SPK_TRIM_EN_L_SHIFT                   3
#define PMIC_SPK_OC_SHDN_DL_MASK                   0x1
#define PMIC_SPK_OC_SHDN_DL_SHIFT                  8
#define PMIC_SPK_THER_SHDN_L_EN_MASK               0x1
#define PMIC_SPK_THER_SHDN_L_EN_SHIFT              9
#define PMIC_RG_SPK_GAINL_MASK                     0x3
#define PMIC_RG_SPK_GAINL_SHIFT                    12
#define PMIC_DA_SPK_OFFSET_L_MASK                  0x1F
#define PMIC_DA_SPK_OFFSET_L_SHIFT                 0
#define PMIC_DA_SPK_LEAD_DGLH_L_MASK               0x1
#define PMIC_DA_SPK_LEAD_DGLH_L_SHIFT              5
#define PMIC_NI_SPK_LEAD_L_MASK                    0x1
#define PMIC_NI_SPK_LEAD_L_SHIFT                   6
#define PMIC_SPK_OFFSET_L_OV_MASK                  0x1
#define PMIC_SPK_OFFSET_L_OV_SHIFT                 7
#define PMIC_SPK_OFFSET_L_SW_MASK                  0x1F
#define PMIC_SPK_OFFSET_L_SW_SHIFT                 8
#define PMIC_SPK_LEAD_L_SW_MASK                    0x1
#define PMIC_SPK_LEAD_L_SW_SHIFT                   13
#define PMIC_SPK_OFFSET_L_MODE_MASK                0x1
#define PMIC_SPK_OFFSET_L_MODE_SHIFT               14
#define PMIC_SPK_TRIM_DONE_L_MASK                  0x1
#define PMIC_SPK_TRIM_DONE_L_SHIFT                 15
#define PMIC_RG_SPK_INTG_RST_L_MASK                0x1
#define PMIC_RG_SPK_INTG_RST_L_SHIFT               0
#define PMIC_RG_SPK_FORCE_EN_L_MASK                0x1
#define PMIC_RG_SPK_FORCE_EN_L_SHIFT               1
#define PMIC_RG_SPK_SLEW_L_MASK                    0x3
#define PMIC_RG_SPK_SLEW_L_SHIFT                   2
#define PMIC_RG_SPKAB_OBIAS_L_MASK                 0x3
#define PMIC_RG_SPKAB_OBIAS_L_SHIFT                4
#define PMIC_RG_SPKRCV_EN_L_MASK                   0x1
#define PMIC_RG_SPKRCV_EN_L_SHIFT                  6
#define PMIC_RG_SPK_DRC_EN_L_MASK                  0x1
#define PMIC_RG_SPK_DRC_EN_L_SHIFT                 7
#define PMIC_RG_SPK_TEST_EN_L_MASK                 0x1
#define PMIC_RG_SPK_TEST_EN_L_SHIFT                8
#define PMIC_RG_SPKAB_OC_EN_L_MASK                 0x1
#define PMIC_RG_SPKAB_OC_EN_L_SHIFT                9
#define PMIC_RG_SPK_OC_EN_L_MASK                   0x1
#define PMIC_RG_SPK_OC_EN_L_SHIFT                  10
#define PMIC_SPK_TRIM_WND_MASK                     0x7
#define PMIC_SPK_TRIM_WND_SHIFT                    0
#define PMIC_SPK_TRIM_THD_MASK                     0x3
#define PMIC_SPK_TRIM_THD_SHIFT                    4
#define PMIC_SPK_OC_WND_MASK                       0x3
#define PMIC_SPK_OC_WND_SHIFT                      8
#define PMIC_SPK_OC_THD_MASK                       0x3
#define PMIC_SPK_OC_THD_SHIFT                      10
#define PMIC_SPK_D_OC_L_DEG_MASK                   0x1
#define PMIC_SPK_D_OC_L_DEG_SHIFT                  14
#define PMIC_SPK_AB_OC_L_DEG_MASK                  0x1
#define PMIC_SPK_AB_OC_L_DEG_SHIFT                 15
#define PMIC_SPK_TD1_MASK                          0xF
#define PMIC_SPK_TD1_SHIFT                         0
#define PMIC_SPK_TD2_MASK                          0xF
#define PMIC_SPK_TD2_SHIFT                         4
#define PMIC_SPK_TD3_MASK                          0xF
#define PMIC_SPK_TD3_SHIFT                         8
#define PMIC_SPK_TRIM_DIV_MASK                     0x7
#define PMIC_SPK_TRIM_DIV_SHIFT                    12
#define PMIC_RG_BTL_SET_MASK                       0x3
#define PMIC_RG_BTL_SET_SHIFT                      0
#define PMIC_RG_SPK_IBIAS_SEL_MASK                 0x3
#define PMIC_RG_SPK_IBIAS_SEL_SHIFT                2
#define PMIC_RG_SPK_CCODE_MASK                     0xF
#define PMIC_RG_SPK_CCODE_SHIFT                    4
#define PMIC_RG_SPK_EN_VIEW_VCM_MASK               0x1
#define PMIC_RG_SPK_EN_VIEW_VCM_SHIFT              8
#define PMIC_RG_SPK_EN_VIEW_CLK_MASK               0x1
#define PMIC_RG_SPK_EN_VIEW_CLK_SHIFT              9
#define PMIC_RG_SPK_VCM_SEL_MASK                   0x1
#define PMIC_RG_SPK_VCM_SEL_SHIFT                  10
#define PMIC_RG_SPK_VCM_IBSEL_MASK                 0x1
#define PMIC_RG_SPK_VCM_IBSEL_SHIFT                11
#define PMIC_RG_SPK_FBRC_EN_MASK                   0x1
#define PMIC_RG_SPK_FBRC_EN_SHIFT                  12
#define PMIC_RG_SPKAB_OVDRV_MASK                   0x1
#define PMIC_RG_SPKAB_OVDRV_SHIFT                  13
#define PMIC_RG_SPK_OCTH_D_MASK                    0x1
#define PMIC_RG_SPK_OCTH_D_SHIFT                   14
#define PMIC_RG_SPK_RSV_MASK                       0xFF
#define PMIC_RG_SPK_RSV_SHIFT                      0
#define PMIC_RG_SPKPGA_GAIN_MASK                   0xF
#define PMIC_RG_SPKPGA_GAIN_SHIFT                  8
#define PMIC_SPK_RSV0_MASK                         0x1
#define PMIC_SPK_RSV0_SHIFT                        12
#define PMIC_SPK_VCM_FAST_EN_MASK                  0x1
#define PMIC_SPK_VCM_FAST_EN_SHIFT                 13
#define PMIC_SPK_TEST_MODE0_MASK                   0x1
#define PMIC_SPK_TEST_MODE0_SHIFT                  14
#define PMIC_SPK_TEST_MODE1_MASK                   0x1
#define PMIC_SPK_TEST_MODE1_SHIFT                  15
#define PMIC_RG_SPK_ISENSE_REFSEL_MASK             0x7
#define PMIC_RG_SPK_ISENSE_REFSEL_SHIFT            0
#define PMIC_RG_SPK_ISENSE_GAINSEL_MASK            0x7
#define PMIC_RG_SPK_ISENSE_GAINSEL_SHIFT           4
#define PMIC_RG_ISENSE_PD_RESET_MASK               0x1
#define PMIC_RG_ISENSE_PD_RESET_SHIFT              8
#define PMIC_RG_SPK_ISENSE_EN_MASK                 0x1
#define PMIC_RG_SPK_ISENSE_EN_SHIFT                9
#define PMIC_RG_SPK_ISENSE_TEST_EN_MASK            0x1
#define PMIC_RG_SPK_ISENSE_TEST_EN_SHIFT           10
#define PMIC_SPK_TD_WAIT_MASK                      0x7
#define PMIC_SPK_TD_WAIT_SHIFT                     0
#define PMIC_SPK_TD_DONE_MASK                      0x7
#define PMIC_SPK_TD_DONE_SHIFT                     4
#define PMIC_SPK_EN_MODE_MASK                      0x1
#define PMIC_SPK_EN_MODE_SHIFT                     0
#define PMIC_SPK_VCM_FAST_SW_MASK                  0x1
#define PMIC_SPK_VCM_FAST_SW_SHIFT                 1
#define PMIC_SPK_RST_L_SW_MASK                     0x1
#define PMIC_SPK_RST_L_SW_SHIFT                    3
#define PMIC_SPKMODE_L_SW_MASK                     0x1
#define PMIC_SPKMODE_L_SW_SHIFT                    5
#define PMIC_SPK_DEPOP_EN_L_SW_MASK                0x1
#define PMIC_SPK_DEPOP_EN_L_SW_SHIFT               7
#define PMIC_SPK_EN_L_SW_MASK                      0x1
#define PMIC_SPK_EN_L_SW_SHIFT                     9
#define PMIC_SPK_OUTSTG_EN_L_SW_MASK               0x1
#define PMIC_SPK_OUTSTG_EN_L_SW_SHIFT              11
#define PMIC_SPK_TRIM_EN_L_SW_MASK                 0x1
#define PMIC_SPK_TRIM_EN_L_SW_SHIFT                13
#define PMIC_SPK_TRIM_STOP_L_SW_MASK               0x1
#define PMIC_SPK_TRIM_STOP_L_SW_SHIFT              15
#define PMIC_CID_MASK                              0xFFFF
#define PMIC_CID_SHIFT                             0
#define PMIC_RG_CLKSQ_EN_AUD_MASK                  0x1
#define PMIC_RG_CLKSQ_EN_AUD_SHIFT                 0
#define PMIC_RG_CLKSQ_EN_AUX_MASK                  0x1
#define PMIC_RG_CLKSQ_EN_AUX_SHIFT                 1
#define PMIC_RG_CLKSQ_EN_FQR_MASK                  0x1
#define PMIC_RG_CLKSQ_EN_FQR_SHIFT                 2
#define PMIC_RG_STRUP_75K_CK_PDN_MASK              0x1
#define PMIC_RG_STRUP_75K_CK_PDN_SHIFT             3
#define PMIC_RG_STRUP_32K_CK_PDN_MASK              0x1
#define PMIC_RG_STRUP_32K_CK_PDN_SHIFT             4
#define PMIC_RG_RTC_75K_DIV4_CK_PDN_MASK           0x1
#define PMIC_RG_RTC_75K_DIV4_CK_PDN_SHIFT          5
#define PMIC_RG_RTC_75K_CK_PDN_MASK                0x1
#define PMIC_RG_RTC_75K_CK_PDN_SHIFT               6
#define PMIC_RG_RTC_32K_CK_PDN_MASK                0x1
#define PMIC_RG_RTC_32K_CK_PDN_SHIFT               7
#define PMIC_RG_PCHR_32K_CK_PDN_MASK               0x1
#define PMIC_RG_PCHR_32K_CK_PDN_SHIFT              8
#define PMIC_RG_LDOSTB_1M_CK_PDN_MASK              0x1
#define PMIC_RG_LDOSTB_1M_CK_PDN_SHIFT             9
#define PMIC_RG_INTRP_CK_PDN_MASK                  0x1
#define PMIC_RG_INTRP_CK_PDN_SHIFT                 10
#define PMIC_RG_DRV_32K_CK_PDN_MASK                0x1
#define PMIC_RG_DRV_32K_CK_PDN_SHIFT               11
#define PMIC_RG_BUCK_1M_CK_PDN_MASK                0x1
#define PMIC_RG_BUCK_1M_CK_PDN_SHIFT               12
#define PMIC_RG_BUCK_CK_PDN_MASK                   0x1
#define PMIC_RG_BUCK_CK_PDN_SHIFT                  13
#define PMIC_RG_BUCK_ANA_CK_PDN_MASK               0x1
#define PMIC_RG_BUCK_ANA_CK_PDN_SHIFT              14
#define PMIC_RG_BUCK32K_PDN_MASK                   0x1
#define PMIC_RG_BUCK32K_PDN_SHIFT                  15
#define PMIC_TOP_CKPDN0_SET_MASK                   0xFFFF
#define PMIC_TOP_CKPDN0_SET_SHIFT                  0
#define PMIC_TOP_CKPDN0_CLR_MASK                   0xFFFF
#define PMIC_TOP_CKPDN0_CLR_SHIFT                  0
#define PMIC_RG_STRUP_6M_PDN_MASK                  0x1
#define PMIC_RG_STRUP_6M_PDN_SHIFT                 0
#define PMIC_RG_SPK_PWM_DIV_PDN_MASK               0x1
#define PMIC_RG_SPK_PWM_DIV_PDN_SHIFT              1
#define PMIC_RG_SPK_DIV_PDN_MASK                   0x1
#define PMIC_RG_SPK_DIV_PDN_SHIFT                  2
#define PMIC_RG_SPK_CK_PDN_MASK                    0x1
#define PMIC_RG_SPK_CK_PDN_SHIFT                   3
#define PMIC_RG_PWMOC_CK_PDN_MASK                  0x1
#define PMIC_RG_PWMOC_CK_PDN_SHIFT                 4
#define PMIC_RG_FQMTR_PDN_MASK                     0x1
#define PMIC_RG_FQMTR_PDN_SHIFT                    5
#define PMIC_RG_DRV_2M_CK_PDN_MASK                 0x1
#define PMIC_RG_DRV_2M_CK_PDN_SHIFT                6
#define PMIC_RG_DRV_1M_CK_PDN_MASK                 0x1
#define PMIC_RG_DRV_1M_CK_PDN_SHIFT                7
#define PMIC_RG_AUD_26M_PDN_MASK                   0x1
#define PMIC_RG_AUD_26M_PDN_SHIFT                  8
#define PMIC_RG_ACCDET_CK_PDN_MASK                 0x1
#define PMIC_RG_ACCDET_CK_PDN_SHIFT                9
#define PMIC_RG_RTC_MCLK_PDN_MASK                  0x1
#define PMIC_RG_RTC_MCLK_PDN_SHIFT                 10
#define PMIC_RG_SMPS_CK_DIV_PDN_MASK               0x1
#define PMIC_RG_SMPS_CK_DIV_PDN_SHIFT              11
#define PMIC_RG_EFUSE_CK_PDN_MASK                  0x1
#define PMIC_RG_EFUSE_CK_PDN_SHIFT                 12
#define PMIC_RG_RTC32K_1V8_PDN_MASK                0x1
#define PMIC_RG_RTC32K_1V8_PDN_SHIFT               13
#define PMIC_RG_CLKSQ_EN_AUX_MD_MASK               0x1
#define PMIC_RG_CLKSQ_EN_AUX_MD_SHIFT              14
#define PMIC_RG_AUXADC_SDM_CK_WAKE_PDN_MASK        0x1
#define PMIC_RG_AUXADC_SDM_CK_WAKE_PDN_SHIFT       15
#define PMIC_TOP_CKPDN1_SET_MASK                   0xFFFF
#define PMIC_TOP_CKPDN1_SET_SHIFT                  0
#define PMIC_TOP_CKPDN1_CLR_MASK                   0xFFFF
#define PMIC_TOP_CKPDN1_CLR_SHIFT                  0
#define PMIC_RG_ISINK0_CK_PDN_MASK                 0x1
#define PMIC_RG_ISINK0_CK_PDN_SHIFT                0
#define PMIC_RG_ISINK1_CK_PDN_MASK                 0x1
#define PMIC_RG_ISINK1_CK_PDN_SHIFT                1
#define PMIC_RG_ISINK2_CK_PDN_MASK                 0x1
#define PMIC_RG_ISINK2_CK_PDN_SHIFT                2
#define PMIC_RG_ISINK3_CK_PDN_MASK                 0x1
#define PMIC_RG_ISINK3_CK_PDN_SHIFT                3
#define PMIC_RG_AUXADC_SDM_CK_PDN_MASK             0x1
#define PMIC_RG_AUXADC_SDM_CK_PDN_SHIFT            4
#define PMIC_RG_AUXADC_CTL_CK_PDN_MASK             0x1
#define PMIC_RG_AUXADC_CTL_CK_PDN_SHIFT            5
#define PMIC_RG_AUXADC_32K_CK_PDN_MASK             0x1
#define PMIC_RG_AUXADC_32K_CK_PDN_SHIFT            6
#define PMIC_RG_AUD26M_DIV4_CK_PDN_MASK            0x1
#define PMIC_RG_AUD26M_DIV4_CK_PDN_SHIFT           7
#define PMIC_TOP_CKPDN2_SET_MASK                   0xFFFF
#define PMIC_TOP_CKPDN2_SET_SHIFT                  0
#define PMIC_TOP_CKPDN2_CLR_MASK                   0xFFFF
#define PMIC_TOP_CKPDN2_CLR_SHIFT                  0
#define PMIC_RG_EFUSE_MAN_RST_MASK                 0x1
#define PMIC_RG_EFUSE_MAN_RST_SHIFT                0
#define PMIC_RG_AUXADC_RST_MASK                    0x1
#define PMIC_RG_AUXADC_RST_SHIFT                   1
#define PMIC_RG_AUDIO_RST_MASK                     0x1
#define PMIC_RG_AUDIO_RST_SHIFT                    2
#define PMIC_RG_ACCDET_RST_MASK                    0x1
#define PMIC_RG_ACCDET_RST_SHIFT                   4
#define PMIC_RG_SPK_RST_MASK                       0x1
#define PMIC_RG_SPK_RST_SHIFT                      5
#define PMIC_RG_DRIVER_RST_MASK                    0x1
#define PMIC_RG_DRIVER_RST_SHIFT                   6
#define PMIC_RG_RTC_RST_MASK                       0x1
#define PMIC_RG_RTC_RST_SHIFT                      7
#define PMIC_RG_FQMTR_RST_MASK                     0x1
#define PMIC_RG_FQMTR_RST_SHIFT                    8
#define PMIC_RG_TOP_RST_CON_RSV_15_9_MASK          0x7F
#define PMIC_RG_TOP_RST_CON_RSV_15_9_SHIFT         9
#define PMIC_TOP_RST_CON_SET_MASK                  0xFFFF
#define PMIC_TOP_RST_CON_SET_SHIFT                 0
#define PMIC_TOP_RST_CON_CLR_MASK                  0xFFFF
#define PMIC_TOP_RST_CON_CLR_SHIFT                 0
#define PMIC_RG_AP_RST_DIS_MASK                    0x1
#define PMIC_RG_AP_RST_DIS_SHIFT                   0
#define PMIC_RG_SYSRSTB_EN_MASK                    0x1
#define PMIC_RG_SYSRSTB_EN_SHIFT                   1
#define PMIC_RG_STRUP_MAN_RST_EN_MASK              0x1
#define PMIC_RG_STRUP_MAN_RST_EN_SHIFT             2
#define PMIC_RG_NEWLDO_RSTB_EN_MASK                0x1
#define PMIC_RG_NEWLDO_RSTB_EN_SHIFT               3
#define PMIC_RG_RST_PART_SEL_MASK                  0x1
#define PMIC_RG_RST_PART_SEL_SHIFT                 4
#define PMIC_RG_HOMEKEY_RST_EN_MASK                0x1
#define PMIC_RG_HOMEKEY_RST_EN_SHIFT               5
#define PMIC_RG_PWRKEY_RST_EN_MASK                 0x1
#define PMIC_RG_PWRKEY_RST_EN_SHIFT                6
#define PMIC_RG_PWRRST_TMR_DIS_MASK                0x1
#define PMIC_RG_PWRRST_TMR_DIS_SHIFT               7
#define PMIC_RG_PWRKEY_RST_TD_MASK                 0x3
#define PMIC_RG_PWRKEY_RST_TD_SHIFT                8
#define PMIC_TOP_RST_MISC_SET_MASK                 0xFFFF
#define PMIC_TOP_RST_MISC_SET_SHIFT                0
#define PMIC_TOP_RST_MISC_CLR_MASK                 0xFFFF
#define PMIC_TOP_RST_MISC_CLR_SHIFT                0
#define PMIC_RG_SRCLKEN_EN_MASK                    0x1
#define PMIC_RG_SRCLKEN_EN_SHIFT                   0
#define PMIC_RG_OSC_SEL_MASK                       0x1
#define PMIC_RG_OSC_SEL_SHIFT                      2
#define PMIC_RG_AUXADC_SDM_SEL_HW_MODE_MASK        0x1
#define PMIC_RG_AUXADC_SDM_SEL_HW_MODE_SHIFT       3
#define PMIC_RG_SRCLKEN_HW_MODE_MASK               0x1
#define PMIC_RG_SRCLKEN_HW_MODE_SHIFT              4
#define PMIC_RG_OSC_HW_MODE_MASK                   0x1
#define PMIC_RG_OSC_HW_MODE_SHIFT                  5
#define PMIC_RG_OSC_HW_SRC_SEL_MASK                0x1
#define PMIC_RG_OSC_HW_SRC_SEL_SHIFT               6
#define PMIC_RG_AUXADC_SDM_CK_HW_MODE_MASK         0x1
#define PMIC_RG_AUXADC_SDM_CK_HW_MODE_SHIFT        7
#define PMIC_RG_SMPS_AUTOFF_DIS_MASK               0x1
#define PMIC_RG_SMPS_AUTOFF_DIS_SHIFT              8
#define PMIC_RG_BUCK_1M_AUTOFF_DIS_MASK            0x1
#define PMIC_RG_BUCK_1M_AUTOFF_DIS_SHIFT           9
#define PMIC_RG_BUCK_ANA_AUTOFF_DIS_MASK           0x1
#define PMIC_RG_BUCK_ANA_AUTOFF_DIS_SHIFT          15
#define PMIC_TOP_CKCON0_SET_MASK                   0xFFFF
#define PMIC_TOP_CKCON0_SET_SHIFT                  0
#define PMIC_TOP_CKCON0_CLR_MASK                   0xFFFF
#define PMIC_TOP_CKCON0_CLR_SHIFT                  0
#define PMIC_RG_REGCK_SEL_MASK                     0x3
#define PMIC_RG_REGCK_SEL_SHIFT                    0
#define PMIC_RG_SPK_PWM_DIV_SEL_MASK               0x3
#define PMIC_RG_SPK_PWM_DIV_SEL_SHIFT              2
#define PMIC_RG_SPK_DIV_SEL_MASK                   0x3
#define PMIC_RG_SPK_DIV_SEL_SHIFT                  4
#define PMIC_RG_FQMTR_CKSEL_MASK                   0x3
#define PMIC_RG_FQMTR_CKSEL_SHIFT                  6
#define PMIC_RG_ACCDET_CKSEL_MASK                  0x3
#define PMIC_RG_ACCDET_CKSEL_SHIFT                 8
#define PMIC_RG_ISINK0_CK_SEL_MASK                 0x1
#define PMIC_RG_ISINK0_CK_SEL_SHIFT                10
#define PMIC_RG_ISINK1_CK_SEL_MASK                 0x1
#define PMIC_RG_ISINK1_CK_SEL_SHIFT                11
#define PMIC_RG_ISINK2_CK_SEL_MASK                 0x1
#define PMIC_RG_ISINK2_CK_SEL_SHIFT                12
#define PMIC_RG_ISINK3_CK_SEL_MASK                 0x1
#define PMIC_RG_ISINK3_CK_SEL_SHIFT                13
#define PMIC_RG_AUXADC_SDM_CK_SEL_MASK             0x1
#define PMIC_RG_AUXADC_SDM_CK_SEL_SHIFT            14
#define PMIC_RG_AUDIO_CK_SEL_MASK                  0x1
#define PMIC_RG_AUDIO_CK_SEL_SHIFT                 15
#define PMIC_TOP_CKCON1_SET_MASK                   0xFFFF
#define PMIC_TOP_CKCON1_SET_SHIFT                  0
#define PMIC_TOP_CKCON1_CLR_MASK                   0xFFFF
#define PMIC_TOP_CKCON1_CLR_SHIFT                  0
#define PMIC_RG_RTC32K_TST_DIS_MASK                0x1
#define PMIC_RG_RTC32K_TST_DIS_SHIFT               0
#define PMIC_RG_SPK_TST_DIS_MASK                   0x1
#define PMIC_RG_SPK_TST_DIS_SHIFT                  1
#define PMIC_RG_SMPS_TST_DIS_MASK                  0x1
#define PMIC_RG_SMPS_TST_DIS_SHIFT                 2
#define PMIC_RG_PMU75K_TST_DIS_MASK                0x1
#define PMIC_RG_PMU75K_TST_DIS_SHIFT               3
#define PMIC_RG_AUD26M_TST_DIS_MASK                0x1
#define PMIC_RG_AUD26M_TST_DIS_SHIFT               4
#define PMIC_RG_SPK_TSTSEL_MASK                    0x1
#define PMIC_RG_SPK_TSTSEL_SHIFT                   0
#define PMIC_RG_SMPS_TSTSEL_MASK                   0x1
#define PMIC_RG_SMPS_TSTSEL_SHIFT                  1
#define PMIC_RG_RTC32K_TSTSEL_MASK                 0x1
#define PMIC_RG_RTC32K_TSTSEL_SHIFT                2
#define PMIC_RG_PMU75K_TSTSEL_MASK                 0x1
#define PMIC_RG_PMU75K_TSTSEL_SHIFT                3
#define PMIC_RG_AUD26M_TSTSEL_MASK                 0x1
#define PMIC_RG_AUD26M_TSTSEL_SHIFT                4
#define PMIC_RG_RTCDET_TSTSEL_MASK                 0x1
#define PMIC_RG_RTCDET_TSTSEL_SHIFT                5
#define PMIC_RG_PWMOC_TSTSEL_MASK                  0x1
#define PMIC_RG_PWMOC_TSTSEL_SHIFT                 6
#define PMIC_RG_LDOSTB_TSTSEL_MASK                 0x1
#define PMIC_RG_LDOSTB_TSTSEL_SHIFT                7
#define PMIC_RG_ISINK_TSTSEL_MASK                  0x1
#define PMIC_RG_ISINK_TSTSEL_SHIFT                 8
#define PMIC_RG_FQMTR_TSTSEL_MASK                  0x1
#define PMIC_RG_FQMTR_TSTSEL_SHIFT                 9
#define PMIC_RG_CLASSD_TSTSEL_MASK                 0x1
#define PMIC_RG_CLASSD_TSTSEL_SHIFT                10
#define PMIC_RG_AUXADC_SDM_TSTSEL_MASK             0x1
#define PMIC_RG_AUXADC_SDM_TSTSEL_SHIFT            11
#define PMIC_RG_AUD26M_DIV4_TSTSEL_MASK            0x1
#define PMIC_RG_AUD26M_DIV4_TSTSEL_SHIFT           12
#define PMIC_RG_AUDIF_TSTSEL_MASK                  0x1
#define PMIC_RG_AUDIF_TSTSEL_SHIFT                 13
#define PMIC_RG_BGR_TEST_CK_SEL_MASK               0x1
#define PMIC_RG_BGR_TEST_CK_SEL_SHIFT              0
#define PMIC_RG_PCHR_TEST_CK_SEL_MASK              0x1
#define PMIC_RG_PCHR_TEST_CK_SEL_SHIFT             1
#define PMIC_RG_STRUP_75K_26M_SEL_MASK             0x1
#define PMIC_RG_STRUP_75K_26M_SEL_SHIFT            2
#define PMIC_RG_BGR_TESTMODE_MASK                  0x1
#define PMIC_RG_BGR_TESTMODE_SHIFT                 3
#define PMIC_RG_TOP_CKTST2_RSV_15_8_MASK           0xFF
#define PMIC_RG_TOP_CKTST2_RSV_15_8_SHIFT          8
#define PMIC_TEST_OUT_MASK                         0xF
#define PMIC_TEST_OUT_SHIFT                        0
#define PMIC_RG_MON_FLAG_SEL_MASK                  0xFF
#define PMIC_RG_MON_FLAG_SEL_SHIFT                 0
#define PMIC_RG_MON_GRP_SEL_MASK                   0xF
#define PMIC_RG_MON_GRP_SEL_SHIFT                  8
#define PMIC_RG_TEST_DRIVER_MASK                   0x1
#define PMIC_RG_TEST_DRIVER_SHIFT                  1
#define PMIC_RG_TEST_CLASSD_MASK                   0x1
#define PMIC_RG_TEST_CLASSD_SHIFT                  2
#define PMIC_RG_TEST_AUD_MASK                      0x1
#define PMIC_RG_TEST_AUD_SHIFT                     5
#define PMIC_RG_TEST_AUXADC_MASK                   0x1
#define PMIC_RG_TEST_AUXADC_SHIFT                  8
#define PMIC_RG_NANDTREE_MODE_MASK                 0x1
#define PMIC_RG_NANDTREE_MODE_SHIFT                9
#define PMIC_RG_EFUSE_MODE_MASK                    0x1
#define PMIC_RG_EFUSE_MODE_SHIFT                   10
#define PMIC_RG_TEST_STRUP_MASK                    0x1
#define PMIC_RG_TEST_STRUP_SHIFT                   11
#define PMIC_RG_TEST_SPK_MASK                      0x1
#define PMIC_RG_TEST_SPK_SHIFT                     12
#define PMIC_RG_TEST_SPK_PWM_MASK                  0x1
#define PMIC_RG_TEST_SPK_PWM_SHIFT                 13
#define PMIC_EN_STATUS_VPROC_MASK                  0x1
#define PMIC_EN_STATUS_VPROC_SHIFT                 0
#define PMIC_EN_STATUS_VSYS_MASK                   0x1
#define PMIC_EN_STATUS_VSYS_SHIFT                  1
#define PMIC_EN_STATUS_VPA_MASK                    0x1
#define PMIC_EN_STATUS_VPA_SHIFT                   2
#define PMIC_EN_STATUS_VRTC_MASK                   0x1
#define PMIC_EN_STATUS_VRTC_SHIFT                  3
#define PMIC_EN_STATUS_VA_MASK                     0x1
#define PMIC_EN_STATUS_VA_SHIFT                    4
#define PMIC_EN_STATUS_VCAMA_MASK                  0x1
#define PMIC_EN_STATUS_VCAMA_SHIFT                 5
#define PMIC_EN_STATUS_VCAMD_MASK                  0x1
#define PMIC_EN_STATUS_VCAMD_SHIFT                 6
#define PMIC_EN_STATUS_VCAM_AF_MASK                0x1
#define PMIC_EN_STATUS_VCAM_AF_SHIFT               7
#define PMIC_EN_STATUS_VCAM_IO_MASK                0x1
#define PMIC_EN_STATUS_VCAM_IO_SHIFT               8
#define PMIC_EN_STATUS_VCN28_MASK                  0x1
#define PMIC_EN_STATUS_VCN28_SHIFT                 9
#define PMIC_EN_STATUS_VCN33_MASK                  0x1
#define PMIC_EN_STATUS_VCN33_SHIFT                 10
#define PMIC_EN_STATUS_VCN_1V8_MASK                0x1
#define PMIC_EN_STATUS_VCN_1V8_SHIFT               11
#define PMIC_EN_STATUS_VEMC_3V3_MASK               0x1
#define PMIC_EN_STATUS_VEMC_3V3_SHIFT              12
#define PMIC_EN_STATUS_VGP1_MASK                   0x1
#define PMIC_EN_STATUS_VGP1_SHIFT                  13
#define PMIC_EN_STATUS_VGP2_MASK                   0x1
#define PMIC_EN_STATUS_VGP2_SHIFT                  14
#define PMIC_EN_STATUS_VGP3_MASK                   0x1
#define PMIC_EN_STATUS_VGP3_SHIFT                  15
#define PMIC_EN_STATUS_VIBR_MASK                   0x1
#define PMIC_EN_STATUS_VIBR_SHIFT                  0
#define PMIC_EN_STATUS_VIO18_MASK                  0x1
#define PMIC_EN_STATUS_VIO18_SHIFT                 1
#define PMIC_EN_STATUS_VIO28_MASK                  0x1
#define PMIC_EN_STATUS_VIO28_SHIFT                 2
#define PMIC_EN_STATUS_VM_MASK                     0x1
#define PMIC_EN_STATUS_VM_SHIFT                    3
#define PMIC_EN_STATUS_VMC_MASK                    0x1
#define PMIC_EN_STATUS_VMC_SHIFT                   4
#define PMIC_EN_STATUS_VMCH_MASK                   0x1
#define PMIC_EN_STATUS_VMCH_SHIFT                  5
#define PMIC_EN_STATUS_VRF18_MASK                  0x1
#define PMIC_EN_STATUS_VRF18_SHIFT                 6
#define PMIC_EN_STATUS_VSIM1_MASK                  0x1
#define PMIC_EN_STATUS_VSIM1_SHIFT                 7
#define PMIC_EN_STATUS_VSIM2_MASK                  0x1
#define PMIC_EN_STATUS_VSIM2_SHIFT                 8
#define PMIC_EN_STATUS_VTCXO_MASK                  0x1
#define PMIC_EN_STATUS_VTCXO_SHIFT                 9
#define PMIC_EN_STATUS_VUSB_MASK                   0x1
#define PMIC_EN_STATUS_VUSB_SHIFT                  10
#define PMIC_OC_STATUS_VPROC_MASK                  0x1
#define PMIC_OC_STATUS_VPROC_SHIFT                 0
#define PMIC_OC_STATUS_VSYS_MASK                   0x1
#define PMIC_OC_STATUS_VSYS_SHIFT                  1
#define PMIC_OC_STATUS_VPA_MASK                    0x1
#define PMIC_OC_STATUS_VPA_SHIFT                   2
#define PMIC_OC_STATUS_VA_MASK                     0x1
#define PMIC_OC_STATUS_VA_SHIFT                    4
#define PMIC_OC_STATUS_VCAMA_MASK                  0x1
#define PMIC_OC_STATUS_VCAMA_SHIFT                 5
#define PMIC_OC_STATUS_VCAMD_MASK                  0x1
#define PMIC_OC_STATUS_VCAMD_SHIFT                 6
#define PMIC_OC_STATUS_VCAM_AF_MASK                0x1
#define PMIC_OC_STATUS_VCAM_AF_SHIFT               7
#define PMIC_OC_STATUS_VCAM_IO_MASK                0x1
#define PMIC_OC_STATUS_VCAM_IO_SHIFT               8
#define PMIC_OC_STATUS_VCN28_MASK                  0x1
#define PMIC_OC_STATUS_VCN28_SHIFT                 9
#define PMIC_OC_STATUS_VCN33_MASK                  0x1
#define PMIC_OC_STATUS_VCN33_SHIFT                 10
#define PMIC_OC_STATUS_VCN_1V8_MASK                0x1
#define PMIC_OC_STATUS_VCN_1V8_SHIFT               11
#define PMIC_OC_STATUS_VEMC_3V3_MASK               0x1
#define PMIC_OC_STATUS_VEMC_3V3_SHIFT              12
#define PMIC_OC_STATUS_VGP1_MASK                   0x1
#define PMIC_OC_STATUS_VGP1_SHIFT                  13
#define PMIC_OC_STATUS_VGP2_MASK                   0x1
#define PMIC_OC_STATUS_VGP2_SHIFT                  14
#define PMIC_OC_STATUS_VGP3_MASK                   0x1
#define PMIC_OC_STATUS_VGP3_SHIFT                  15
#define PMIC_OC_STATUS_VIBR_MASK                   0x1
#define PMIC_OC_STATUS_VIBR_SHIFT                  0
#define PMIC_OC_STATUS_VIO18_MASK                  0x1
#define PMIC_OC_STATUS_VIO18_SHIFT                 1
#define PMIC_OC_STATUS_VIO28_MASK                  0x1
#define PMIC_OC_STATUS_VIO28_SHIFT                 2
#define PMIC_OC_STATUS_VM_MASK                     0x1
#define PMIC_OC_STATUS_VM_SHIFT                    3
#define PMIC_OC_STATUS_VMC_MASK                    0x1
#define PMIC_OC_STATUS_VMC_SHIFT                   4
#define PMIC_OC_STATUS_VMCH_MASK                   0x1
#define PMIC_OC_STATUS_VMCH_SHIFT                  5
#define PMIC_OC_STATUS_VRF18_MASK                  0x1
#define PMIC_OC_STATUS_VRF18_SHIFT                 6
#define PMIC_OC_STATUS_VSIM1_MASK                  0x1
#define PMIC_OC_STATUS_VSIM1_SHIFT                 7
#define PMIC_OC_STATUS_VSIM2_MASK                  0x1
#define PMIC_OC_STATUS_VSIM2_SHIFT                 8
#define PMIC_OC_STATUS_VTCXO_MASK                  0x1
#define PMIC_OC_STATUS_VTCXO_SHIFT                 9
#define PMIC_OC_STATUS_VUSB_MASK                   0x1
#define PMIC_OC_STATUS_VUSB_SHIFT                  10
#define PMIC_NI_SPK_OC_DET_D_L_MASK                0x1
#define PMIC_NI_SPK_OC_DET_D_L_SHIFT               11
#define PMIC_NI_SPK_OC_DET_AB_L_MASK               0x1
#define PMIC_NI_SPK_OC_DET_AB_L_SHIFT              12
#define PMIC_VPROC_PG_DEB_MASK                     0x1
#define PMIC_VPROC_PG_DEB_SHIFT                    0
#define PMIC_VSYS_PG_DEB_MASK                      0x1
#define PMIC_VSYS_PG_DEB_SHIFT                     1
#define PMIC_VM_PG_DEB_MASK                        0x1
#define PMIC_VM_PG_DEB_SHIFT                       2
#define PMIC_VIO18_PG_DEB_MASK                     0x1
#define PMIC_VIO18_PG_DEB_SHIFT                    3
#define PMIC_VTCXO_PG_DEB_MASK                     0x1
#define PMIC_VTCXO_PG_DEB_SHIFT                    4
#define PMIC_VA_PG_DEB_MASK                        0x1
#define PMIC_VA_PG_DEB_SHIFT                       5
#define PMIC_VIO28_PG_DEB_MASK                     0x1
#define PMIC_VIO28_PG_DEB_SHIFT                    6
#define PMIC_VGP2_PG_DEB_MASK                      0x1
#define PMIC_VGP2_PG_DEB_SHIFT                     7
#define PMIC_PMU_TEST_MODE_SCAN_MASK               0x1
#define PMIC_PMU_TEST_MODE_SCAN_SHIFT              0
#define PMIC_PWRKEY_DEB_MASK                       0x1
#define PMIC_PWRKEY_DEB_SHIFT                      1
#define PMIC_FCHRKEY_DEB_MASK                      0x1
#define PMIC_FCHRKEY_DEB_SHIFT                     2
#define PMIC_VBAT_OV_MASK                          0x1
#define PMIC_VBAT_OV_SHIFT                         3
#define PMIC_PCHR_CHRDET_MASK                      0x1
#define PMIC_PCHR_CHRDET_SHIFT                     4
#define PMIC_RO_BATON_UNDET_MASK                   0x1
#define PMIC_RO_BATON_UNDET_SHIFT                  5
#define PMIC_RTC_XTAL_DET_DONE_MASK                0x1
#define PMIC_RTC_XTAL_DET_DONE_SHIFT               6
#define PMIC_XOSC32_ENB_DET_MASK                   0x1
#define PMIC_XOSC32_ENB_DET_SHIFT                  7
#define PMIC_RTC_XTAL_DET_RSV_MASK                 0xF
#define PMIC_RTC_XTAL_DET_RSV_SHIFT                8
#define PMIC_RG_SIMAP_TDSEL_MASK                   0x1
#define PMIC_RG_SIMAP_TDSEL_SHIFT                  0
#define PMIC_RG_AUD_TDSEL_MASK                     0x1
#define PMIC_RG_AUD_TDSEL_SHIFT                    1
#define PMIC_RG_SPI_TDSEL_MASK                     0x1
#define PMIC_RG_SPI_TDSEL_SHIFT                    2
#define PMIC_RG_PMU_TDSEL_MASK                     0x1
#define PMIC_RG_PMU_TDSEL_SHIFT                    3
#define PMIC_RG_SIMLS_TDSEL_MASK                   0x3
#define PMIC_RG_SIMLS_TDSEL_SHIFT                  4
#define PMIC_RG_SIMAP_RDSEL_MASK                   0x1
#define PMIC_RG_SIMAP_RDSEL_SHIFT                  0
#define PMIC_RG_AUD_RDSEL_MASK                     0x1
#define PMIC_RG_AUD_RDSEL_SHIFT                    1
#define PMIC_RG_SPI_RDSEL_MASK                     0x1
#define PMIC_RG_SPI_RDSEL_SHIFT                    2
#define PMIC_RG_PMU_RDSEL_MASK                     0x1
#define PMIC_RG_PMU_RDSEL_SHIFT                    3
#define PMIC_RG_SIMLS_RDSEL_MASK                   0x3
#define PMIC_RG_SIMLS_RDSEL_SHIFT                  4
#define PMIC_RG_SMT_SYSRSTB_MASK                   0x1
#define PMIC_RG_SMT_SYSRSTB_SHIFT                  0
#define PMIC_RG_SMT_INT_MASK                       0x1
#define PMIC_RG_SMT_INT_SHIFT                      1
#define PMIC_RG_SMT_SRCLKEN_MASK                   0x1
#define PMIC_RG_SMT_SRCLKEN_SHIFT                  2
#define PMIC_RG_SMT_RTC_32K1V8_MASK                0x1
#define PMIC_RG_SMT_RTC_32K1V8_SHIFT               3
#define PMIC_RG_SMT_SPI_CLK_MASK                   0x1
#define PMIC_RG_SMT_SPI_CLK_SHIFT                  0
#define PMIC_RG_SMT_SPI_CSN_MASK                   0x1
#define PMIC_RG_SMT_SPI_CSN_SHIFT                  1
#define PMIC_RG_SMT_SPI_MOSI_MASK                  0x1
#define PMIC_RG_SMT_SPI_MOSI_SHIFT                 2
#define PMIC_RG_SMT_SPI_MISO_MASK                  0x1
#define PMIC_RG_SMT_SPI_MISO_SHIFT                 3
#define PMIC_RG_SMT_AUD_CLK_MASK                   0x1
#define PMIC_RG_SMT_AUD_CLK_SHIFT                  0
#define PMIC_RG_SMT_AUD_MOSI_MASK                  0x1
#define PMIC_RG_SMT_AUD_MOSI_SHIFT                 1
#define PMIC_RG_SMT_AUD_MISO_MASK                  0x1
#define PMIC_RG_SMT_AUD_MISO_SHIFT                 2
#define PMIC_RG_SMT_SIM1_AP_SCLK_MASK              0x1
#define PMIC_RG_SMT_SIM1_AP_SCLK_SHIFT             0
#define PMIC_RG_SMT_SIM1_AP_SRST_MASK              0x1
#define PMIC_RG_SMT_SIM1_AP_SRST_SHIFT             1
#define PMIC_RG_SMT_SIMLS1_SCLK_MASK               0x1
#define PMIC_RG_SMT_SIMLS1_SCLK_SHIFT              2
#define PMIC_RG_SMT_SIMLS1_SRST_MASK               0x1
#define PMIC_RG_SMT_SIMLS1_SRST_SHIFT              3
#define PMIC_RG_SMT_SIM2_AP_SCLK_MASK              0x1
#define PMIC_RG_SMT_SIM2_AP_SCLK_SHIFT             0
#define PMIC_RG_SMT_SIM2_AP_SRST_MASK              0x1
#define PMIC_RG_SMT_SIM2_AP_SRST_SHIFT             1
#define PMIC_RG_SMT_SIMLS2_SCLK_MASK               0x1
#define PMIC_RG_SMT_SIMLS2_SCLK_SHIFT              2
#define PMIC_RG_SMT_SIMLS2_SRST_MASK               0x1
#define PMIC_RG_SMT_SIMLS2_SRST_SHIFT              3
#define PMIC_RG_OCTL_INT_MASK                      0xF
#define PMIC_RG_OCTL_INT_SHIFT                     0
#define PMIC_RG_OCTL_SRCLKEN_MASK                  0xF
#define PMIC_RG_OCTL_SRCLKEN_SHIFT                 4
#define PMIC_RG_OCTL_RTC_32K1V8_MASK               0xF
#define PMIC_RG_OCTL_RTC_32K1V8_SHIFT              8
#define PMIC_RG_OCTL_SPI_CLK_MASK                  0xF
#define PMIC_RG_OCTL_SPI_CLK_SHIFT                 0
#define PMIC_RG_OCTL_SPI_CSN_MASK                  0xF
#define PMIC_RG_OCTL_SPI_CSN_SHIFT                 4
#define PMIC_RG_OCTL_SPI_MOSI_MASK                 0xF
#define PMIC_RG_OCTL_SPI_MOSI_SHIFT                8
#define PMIC_RG_OCTL_SPI_MISO_MASK                 0xF
#define PMIC_RG_OCTL_SPI_MISO_SHIFT                12
#define PMIC_RG_OCTL_AUD_CLK_MASK                  0xF
#define PMIC_RG_OCTL_AUD_CLK_SHIFT                 0
#define PMIC_RG_OCTL_AUD_MOSI_MASK                 0xF
#define PMIC_RG_OCTL_AUD_MOSI_SHIFT                4
#define PMIC_RG_OCTL_AUD_MISO_MASK                 0xF
#define PMIC_RG_OCTL_AUD_MISO_SHIFT                8
#define PMIC_RG_OCTL_SIM1_AP_SCLK_MASK             0xF
#define PMIC_RG_OCTL_SIM1_AP_SCLK_SHIFT            0
#define PMIC_RG_OCTL_SIM1_AP_SRST_MASK             0xF
#define PMIC_RG_OCTL_SIM1_AP_SRST_SHIFT            4
#define PMIC_RG_OCTL_SIMLS1_SCLK_MASK              0xF
#define PMIC_RG_OCTL_SIMLS1_SCLK_SHIFT             8
#define PMIC_RG_OCTL_SIMLS1_SRST_MASK              0xF
#define PMIC_RG_OCTL_SIMLS1_SRST_SHIFT             12
#define PMIC_RG_OCTL_SIM2_AP_SCLK_MASK             0xF
#define PMIC_RG_OCTL_SIM2_AP_SCLK_SHIFT            0
#define PMIC_RG_OCTL_SIM2_AP_SRST_MASK             0xF
#define PMIC_RG_OCTL_SIM2_AP_SRST_SHIFT            4
#define PMIC_RG_OCTL_SIMLS2_SCLK_MASK              0xF
#define PMIC_RG_OCTL_SIMLS2_SCLK_SHIFT             8
#define PMIC_RG_OCTL_SIMLS2_SRST_MASK              0xF
#define PMIC_RG_OCTL_SIMLS2_SRST_SHIFT             12
#define PMIC_RG_SIMLS1_SCLK_CONF_MASK              0xF
#define PMIC_RG_SIMLS1_SCLK_CONF_SHIFT             0
#define PMIC_RG_SIMLS1_SRST_CONF_MASK              0xF
#define PMIC_RG_SIMLS1_SRST_CONF_SHIFT             4
#define PMIC_RG_SIMLS2_SCLK_CONF_MASK              0xF
#define PMIC_RG_SIMLS2_SCLK_CONF_SHIFT             0
#define PMIC_RG_SIMLS2_SRST_CONF_MASK              0xF
#define PMIC_RG_SIMLS2_SRST_CONF_SHIFT             4
#define PMIC_RG_INT_EN_SPKL_AB_MASK                0x1
#define PMIC_RG_INT_EN_SPKL_AB_SHIFT               0
#define PMIC_RG_INT_EN_SPKL_MASK                   0x1
#define PMIC_RG_INT_EN_SPKL_SHIFT                  1
#define PMIC_RG_INT_EN_BAT_L_MASK                  0x1
#define PMIC_RG_INT_EN_BAT_L_SHIFT                 2
#define PMIC_RG_INT_EN_BAT_H_MASK                  0x1
#define PMIC_RG_INT_EN_BAT_H_SHIFT                 3
#define PMIC_RG_INT_EN_WATCHDOG_MASK               0x1
#define PMIC_RG_INT_EN_WATCHDOG_SHIFT              4
#define PMIC_RG_INT_EN_PWRKEY_MASK                 0x1
#define PMIC_RG_INT_EN_PWRKEY_SHIFT                5
#define PMIC_RG_INT_EN_THR_L_MASK                  0x1
#define PMIC_RG_INT_EN_THR_L_SHIFT                 6
#define PMIC_RG_INT_EN_THR_H_MASK                  0x1
#define PMIC_RG_INT_EN_THR_H_SHIFT                 7
#define PMIC_RG_INT_EN_VBATON_UNDET_MASK           0x1
#define PMIC_RG_INT_EN_VBATON_UNDET_SHIFT          8
#define PMIC_RG_INT_EN_BVALID_DET_MASK             0x1
#define PMIC_RG_INT_EN_BVALID_DET_SHIFT            9
#define PMIC_RG_INT_EN_CHRDET_MASK                 0x1
#define PMIC_RG_INT_EN_CHRDET_SHIFT                10
#define PMIC_RG_INT_EN_OV_MASK                     0x1
#define PMIC_RG_INT_EN_OV_SHIFT                    11
#define PMIC_INT_CON0_SET_MASK                     0xFFFF
#define PMIC_INT_CON0_SET_SHIFT                    0
#define PMIC_INT_CON0_CLR_MASK                     0xFFFF
#define PMIC_INT_CON0_CLR_SHIFT                    0
#define PMIC_RG_INT_EN_LDO_MASK                    0x1
#define PMIC_RG_INT_EN_LDO_SHIFT                   0
#define PMIC_RG_INT_EN_FCHRKEY_MASK                0x1
#define PMIC_RG_INT_EN_FCHRKEY_SHIFT               1
#define PMIC_RG_INT_EN_ACCDET_MASK                 0x1
#define PMIC_RG_INT_EN_ACCDET_SHIFT                2
#define PMIC_RG_INT_EN_AUDIO_MASK                  0x1
#define PMIC_RG_INT_EN_AUDIO_SHIFT                 3
#define PMIC_RG_INT_EN_RTC_MASK                    0x1
#define PMIC_RG_INT_EN_RTC_SHIFT                   4
#define PMIC_RG_INT_EN_VPROC_MASK                  0x1
#define PMIC_RG_INT_EN_VPROC_SHIFT                 5
#define PMIC_RG_INT_EN_VSYS_MASK                   0x1
#define PMIC_RG_INT_EN_VSYS_SHIFT                  6
#define PMIC_RG_INT_EN_VPA_MASK                    0x1
#define PMIC_RG_INT_EN_VPA_SHIFT                   7
#define PMIC_INT_CON1_SET_MASK                     0xFFFF
#define PMIC_INT_CON1_SET_SHIFT                    0
#define PMIC_INT_CON1_CLR_MASK                     0xFFFF
#define PMIC_INT_CON1_CLR_SHIFT                    0
#define PMIC_POLARITY_MASK                         0x1
#define PMIC_POLARITY_SHIFT                        0
#define PMIC_POLARITY_VBATON_UNDET_MASK            0x1
#define PMIC_POLARITY_VBATON_UNDET_SHIFT           1
#define PMIC_POLARITY_BVALID_DET_MASK              0x1
#define PMIC_POLARITY_BVALID_DET_SHIFT             2
#define PMIC_RG_FCHRKEY_INT_SEL_MASK               0x1
#define PMIC_RG_FCHRKEY_INT_SEL_SHIFT              3
#define PMIC_RG_PWRKEY_INT_SEL_MASK                0x1
#define PMIC_RG_PWRKEY_INT_SEL_SHIFT               4
#define PMIC_IVGEN_EXT_EN_MASK                     0x1
#define PMIC_IVGEN_EXT_EN_SHIFT                    7
#define PMIC_INT_MISC_CON_SET_MASK                 0xFFFF
#define PMIC_INT_MISC_CON_SET_SHIFT                0
#define PMIC_INT_MISC_CON_CLR_MASK                 0xFFFF
#define PMIC_INT_MISC_CON_CLR_SHIFT                0
#define PMIC_RG_INT_STATUS_SPKL_AB_MASK            0x1
#define PMIC_RG_INT_STATUS_SPKL_AB_SHIFT           0
#define PMIC_RG_INT_STATUS_SPKL_MASK               0x1
#define PMIC_RG_INT_STATUS_SPKL_SHIFT              1
#define PMIC_RG_INT_STATUS_BAT_L_MASK              0x1
#define PMIC_RG_INT_STATUS_BAT_L_SHIFT             2
#define PMIC_RG_INT_STATUS_BAT_H_MASK              0x1
#define PMIC_RG_INT_STATUS_BAT_H_SHIFT             3
#define PMIC_RG_INT_STATUS_WATCHDOG_MASK           0x1
#define PMIC_RG_INT_STATUS_WATCHDOG_SHIFT          4
#define PMIC_RG_INT_STATUS_PWRKEY_MASK             0x1
#define PMIC_RG_INT_STATUS_PWRKEY_SHIFT            5
#define PMIC_RG_INT_STATUS_THR_L_MASK              0x1
#define PMIC_RG_INT_STATUS_THR_L_SHIFT             6
#define PMIC_RG_INT_STATUS_THR_H_MASK              0x1
#define PMIC_RG_INT_STATUS_THR_H_SHIFT             7
#define PMIC_RG_INT_STATUS_VBATON_UNDET_MASK       0x1
#define PMIC_RG_INT_STATUS_VBATON_UNDET_SHIFT      8
#define PMIC_RG_INT_STATUS_BVALID_DET_MASK         0x1
#define PMIC_RG_INT_STATUS_BVALID_DET_SHIFT        9
#define PMIC_RG_INT_STATUS_CHRDET_MASK             0x1
#define PMIC_RG_INT_STATUS_CHRDET_SHIFT            10
#define PMIC_RG_INT_STATUS_OV_MASK                 0x1
#define PMIC_RG_INT_STATUS_OV_SHIFT                11
#define PMIC_RG_INT_STATUS_LDO_MASK                0x1
#define PMIC_RG_INT_STATUS_LDO_SHIFT               0
#define PMIC_RG_INT_STATUS_FCHRKEY_MASK            0x1
#define PMIC_RG_INT_STATUS_FCHRKEY_SHIFT           1
#define PMIC_RG_INT_STATUS_ACCDET_MASK             0x1
#define PMIC_RG_INT_STATUS_ACCDET_SHIFT            2
#define PMIC_RG_INT_STATUS_AUDIO_MASK              0x1
#define PMIC_RG_INT_STATUS_AUDIO_SHIFT             3
#define PMIC_RG_INT_STATUS_RTC_MASK                0x1
#define PMIC_RG_INT_STATUS_RTC_SHIFT               4
#define PMIC_RG_INT_STATUS_VPROC_MASK              0x1
#define PMIC_RG_INT_STATUS_VPROC_SHIFT             5
#define PMIC_RG_INT_STATUS_VSYS_MASK               0x1
#define PMIC_RG_INT_STATUS_VSYS_SHIFT              6
#define PMIC_RG_INT_STATUS_VPA_MASK                0x1
#define PMIC_RG_INT_STATUS_VPA_SHIFT               7
#define PMIC_OC_GEAR_BVALID_DET_MASK               0x3
#define PMIC_OC_GEAR_BVALID_DET_SHIFT              0
#define PMIC_OC_GEAR_VBATON_UNDET_MASK             0x3
#define PMIC_OC_GEAR_VBATON_UNDET_SHIFT            0
#define PMIC_OC_GEAR_LDO_MASK                      0x3
#define PMIC_OC_GEAR_LDO_SHIFT                     0
#define PMIC_VPROC_OC_THD_MASK                     0x3
#define PMIC_VPROC_OC_THD_SHIFT                    0
#define PMIC_VPROC_OC_WND_MASK                     0x3
#define PMIC_VPROC_OC_WND_SHIFT                    2
#define PMIC_VPROC_DEG_EN_MASK                     0x1
#define PMIC_VPROC_DEG_EN_SHIFT                    4
#define PMIC_VSYS_OC_THD_MASK                      0x3
#define PMIC_VSYS_OC_THD_SHIFT                     0
#define PMIC_VSYS_OC_WND_MASK                      0x3
#define PMIC_VSYS_OC_WND_SHIFT                     2
#define PMIC_VSYS_DEG_EN_MASK                      0x1
#define PMIC_VSYS_DEG_EN_SHIFT                     4
#define PMIC_VPA_OC_THD_MASK                       0x3
#define PMIC_VPA_OC_THD_SHIFT                      0
#define PMIC_VPA_OC_WND_MASK                       0x3
#define PMIC_VPA_OC_WND_SHIFT                      2
#define PMIC_VPA_DEG_EN_MASK                       0x1
#define PMIC_VPA_DEG_EN_SHIFT                      4
#define PMIC_FQMTR_TCKSEL_MASK                     0x7
#define PMIC_FQMTR_TCKSEL_SHIFT                    0
#define PMIC_FQMTR_BUSY_MASK                       0x1
#define PMIC_FQMTR_BUSY_SHIFT                      3
#define PMIC_FQMTR_EN_MASK                         0x1
#define PMIC_FQMTR_EN_SHIFT                        15
#define PMIC_FQMTR_WINSET_MASK                     0xFFFF
#define PMIC_FQMTR_WINSET_SHIFT                    0
#define PMIC_FQMTR_DATA_MASK                       0xFFFF
#define PMIC_FQMTR_DATA_SHIFT                      0
#define PMIC_RG_SPI_CON_MASK                       0x1
#define PMIC_RG_SPI_CON_SHIFT                      0
#define PMIC_DEW_DIO_EN_MASK                       0x1
#define PMIC_DEW_DIO_EN_SHIFT                      0
#define PMIC_DEW_READ_TEST_MASK                    0xFFFF
#define PMIC_DEW_READ_TEST_SHIFT                   0
#define PMIC_DEW_WRITE_TEST_MASK                   0xFFFF
#define PMIC_DEW_WRITE_TEST_SHIFT                  0
#define PMIC_DEW_CRC_SWRST_MASK                    0x1
#define PMIC_DEW_CRC_SWRST_SHIFT                   0
#define PMIC_DEW_CRC_EN_MASK                       0x1
#define PMIC_DEW_CRC_EN_SHIFT                      0
#define PMIC_DEW_CRC_VAL_MASK                      0xFF
#define PMIC_DEW_CRC_VAL_SHIFT                     0
#define PMIC_DEW_DBG_MON_SEL_MASK                  0xF
#define PMIC_DEW_DBG_MON_SEL_SHIFT                 0
#define PMIC_DEW_CIPHER_KEY_SEL_MASK               0x3
#define PMIC_DEW_CIPHER_KEY_SEL_SHIFT              0
#define PMIC_DEW_CIPHER_IV_SEL_MASK                0x3
#define PMIC_DEW_CIPHER_IV_SEL_SHIFT               0
#define PMIC_DEW_CIPHER_EN_MASK                    0x1
#define PMIC_DEW_CIPHER_EN_SHIFT                   0
#define PMIC_DEW_CIPHER_RDY_MASK                   0x1
#define PMIC_DEW_CIPHER_RDY_SHIFT                  0
#define PMIC_DEW_CIPHER_MODE_MASK                  0x1
#define PMIC_DEW_CIPHER_MODE_SHIFT                 0
#define PMIC_DEW_CIPHER_SWRST_MASK                 0x1
#define PMIC_DEW_CIPHER_SWRST_SHIFT                0
#define PMIC_DEW_RDDMY_NO_MASK                     0xF
#define PMIC_DEW_RDDMY_NO_SHIFT                    0
#define PMIC_DEW_RDATA_DLY_SEL_MASK                0x1
#define PMIC_DEW_RDATA_DLY_SEL_SHIFT               0
#define PMIC_RG_SMPS_TESTMODE_B_MASK               0xFF
#define PMIC_RG_SMPS_TESTMODE_B_SHIFT              8
#define PMIC_QI_VPROC_DIG_MON_MASK                 0xF
#define PMIC_QI_VPROC_DIG_MON_SHIFT                0
#define PMIC_QI_VSYS_DIG_MON_MASK                  0xF
#define PMIC_QI_VSYS_DIG_MON_SHIFT                 4
#define PMIC_VSLEEP_SRC0_MASK                      0x1FF
#define PMIC_VSLEEP_SRC0_SHIFT                     0
#define PMIC_VSLEEP_SRC1_MASK                      0xF
#define PMIC_VSLEEP_SRC1_SHIFT                     12
#define PMIC_R2R_SRC0_MASK                         0x1FF
#define PMIC_R2R_SRC0_SHIFT                        0
#define PMIC_R2R_SRC1_MASK                         0xF
#define PMIC_R2R_SRC1_SHIFT                        12
#define PMIC_BUCK_OSC_SEL_SRC0_MASK                0x1FF
#define PMIC_BUCK_OSC_SEL_SRC0_SHIFT               0
#define PMIC_SRCLKEN_DLY_SRC1_MASK                 0xF
#define PMIC_SRCLKEN_DLY_SRC1_SHIFT                12
#define PMIC_BUCK_CON5_RSV0_MASK                   0xFFFF
#define PMIC_BUCK_CON5_RSV0_SHIFT                  0
#define PMIC_RG_VPROC_TRIML_MASK                   0x7
#define PMIC_RG_VPROC_TRIML_SHIFT                  0
#define PMIC_RG_VPROC_TRIMH_MASK                   0x7
#define PMIC_RG_VPROC_TRIMH_SHIFT                  3
#define PMIC_RG_VPROC_CSM_MASK                     0x7
#define PMIC_RG_VPROC_CSM_SHIFT                    6
#define PMIC_RG_VPROC_ZXOS_TRIM_MASK               0x3F
#define PMIC_RG_VPROC_ZXOS_TRIM_SHIFT              9
#define PMIC_RG_VPROC_RZSEL_MASK                   0x3
#define PMIC_RG_VPROC_RZSEL_SHIFT                  0
#define PMIC_RG_VPROC_CC_MASK                      0x3
#define PMIC_RG_VPROC_CC_SHIFT                     4
#define PMIC_RG_VPROC_CSR_MASK                     0x3
#define PMIC_RG_VPROC_CSR_SHIFT                    6
#define PMIC_RG_VPROC_CSL_MASK                     0x3
#define PMIC_RG_VPROC_CSL_SHIFT                    8
#define PMIC_RG_VPROC_ZX_OS_MASK                   0x3
#define PMIC_RG_VPROC_ZX_OS_SHIFT                  14
#define PMIC_RG_VPROC_AVP_OS_MASK                  0x7
#define PMIC_RG_VPROC_AVP_OS_SHIFT                 0
#define PMIC_RG_VPROC_AVP_EN_MASK                  0x1
#define PMIC_RG_VPROC_AVP_EN_SHIFT                 3
#define PMIC_RG_VPROC_MODESET_MASK                 0x1
#define PMIC_RG_VPROC_MODESET_SHIFT                8
#define PMIC_RG_VPROC_NDIS_EN_MASK                 0x1
#define PMIC_RG_VPROC_NDIS_EN_SHIFT                9
#define PMIC_RG_VPROC_SLP_MASK                     0x3
#define PMIC_RG_VPROC_SLP_SHIFT                    0
#define PMIC_QI_VPROC_VSLEEP_MASK                  0x3
#define PMIC_QI_VPROC_VSLEEP_SHIFT                 4
#define PMIC_RG_VPROC_RSV_MASK                     0xFF
#define PMIC_RG_VPROC_RSV_SHIFT                    0
#define PMIC_VPROC_EN_CTRL_MASK                    0x1
#define PMIC_VPROC_EN_CTRL_SHIFT                   0
#define PMIC_VPROC_VOSEL_CTRL_MASK                 0x1
#define PMIC_VPROC_VOSEL_CTRL_SHIFT                1
#define PMIC_VPROC_DLC_CTRL_MASK                   0x1
#define PMIC_VPROC_DLC_CTRL_SHIFT                  2
#define PMIC_VPROC_BURST_CTRL_MASK                 0x1
#define PMIC_VPROC_BURST_CTRL_SHIFT                3
#define PMIC_VPROC_EN_MASK                         0x1
#define PMIC_VPROC_EN_SHIFT                        0
#define PMIC_QI_VPROC_STB_MASK                     0x1
#define PMIC_QI_VPROC_STB_SHIFT                    12
#define PMIC_QI_VPROC_EN_MASK                      0x1
#define PMIC_QI_VPROC_EN_SHIFT                     13
#define PMIC_QI_VPROC_OC_STATUS_MASK               0x1
#define PMIC_QI_VPROC_OC_STATUS_SHIFT              15
#define PMIC_VPROC_SFCHG_FRATE_MASK                0x7F
#define PMIC_VPROC_SFCHG_FRATE_SHIFT               0
#define PMIC_VPROC_SFCHG_FEN_MASK                  0x1
#define PMIC_VPROC_SFCHG_FEN_SHIFT                 7
#define PMIC_VPROC_SFCHG_RRATE_MASK                0x7F
#define PMIC_VPROC_SFCHG_RRATE_SHIFT               8
#define PMIC_VPROC_SFCHG_REN_MASK                  0x1
#define PMIC_VPROC_SFCHG_REN_SHIFT                 15
#define PMIC_VPROC_VOSEL_MASK                      0x7F
#define PMIC_VPROC_VOSEL_SHIFT                     0
#define PMIC_VPROC_VOSEL_ON_MASK                   0x7F
#define PMIC_VPROC_VOSEL_ON_SHIFT                  0
#define PMIC_VPROC_VOSEL_SLEEP_MASK                0x7F
#define PMIC_VPROC_VOSEL_SLEEP_SHIFT               0
#define PMIC_NI_VPROC_VOSEL_MASK                   0x7F
#define PMIC_NI_VPROC_VOSEL_SHIFT                  0
#define PMIC_VPROC_BURST_MASK                      0x3
#define PMIC_VPROC_BURST_SHIFT                     0
#define PMIC_VPROC_BURST_ON_MASK                   0x3
#define PMIC_VPROC_BURST_ON_SHIFT                  4
#define PMIC_VPROC_BURST_SLEEP_MASK                0x3
#define PMIC_VPROC_BURST_SLEEP_SHIFT               8
#define PMIC_QI_VPROC_BURST_MASK                   0x3
#define PMIC_QI_VPROC_BURST_SHIFT                  12
#define PMIC_VPROC_DLC_MASK                        0x3
#define PMIC_VPROC_DLC_SHIFT                       0
#define PMIC_VPROC_DLC_ON_MASK                     0x3
#define PMIC_VPROC_DLC_ON_SHIFT                    4
#define PMIC_VPROC_DLC_SLEEP_MASK                  0x3
#define PMIC_VPROC_DLC_SLEEP_SHIFT                 8
#define PMIC_QI_VPROC_DLC_MASK                     0x3
#define PMIC_QI_VPROC_DLC_SHIFT                    12
#define PMIC_VPROC_DLC_N_MASK                      0x3
#define PMIC_VPROC_DLC_N_SHIFT                     0
#define PMIC_VPROC_DLC_N_ON_MASK                   0x3
#define PMIC_VPROC_DLC_N_ON_SHIFT                  4
#define PMIC_VPROC_DLC_N_SLEEP_MASK                0x3
#define PMIC_VPROC_DLC_N_SLEEP_SHIFT               8
#define PMIC_QI_VPROC_DLC_N_MASK                   0x3
#define PMIC_QI_VPROC_DLC_N_SHIFT                  12
#define PMIC_VPROC_TRANSTD_MASK                    0x3
#define PMIC_VPROC_TRANSTD_SHIFT                   0
#define PMIC_VPROC_VOSEL_TRANS_EN_MASK             0x3
#define PMIC_VPROC_VOSEL_TRANS_EN_SHIFT            4
#define PMIC_VPROC_VOSEL_TRANS_ONCE_MASK           0x1
#define PMIC_VPROC_VOSEL_TRANS_ONCE_SHIFT          6
#define PMIC_NI_VPROC_VOSEL_TRANS_MASK             0x1
#define PMIC_NI_VPROC_VOSEL_TRANS_SHIFT            7
#define PMIC_VPROC_VSLEEP_EN_MASK                  0x1
#define PMIC_VPROC_VSLEEP_EN_SHIFT                 8
#define PMIC_VPROC_R2R_PDN_MASK                    0x1
#define PMIC_VPROC_R2R_PDN_SHIFT                   10
#define PMIC_VPROC_VSLEEP_SEL_MASK                 0x1
#define PMIC_VPROC_VSLEEP_SEL_SHIFT                11
#define PMIC_NI_VPROC_R2R_PDN_MASK                 0x1
#define PMIC_NI_VPROC_R2R_PDN_SHIFT                14
#define PMIC_NI_VPROC_VSLEEP_SEL_MASK              0x1
#define PMIC_NI_VPROC_VSLEEP_SEL_SHIFT             15
#define PMIC_RG_VSYS_TRIML_MASK                    0x7
#define PMIC_RG_VSYS_TRIML_SHIFT                   0
#define PMIC_RG_VSYS_TRIMH_MASK                    0x7
#define PMIC_RG_VSYS_TRIMH_SHIFT                   3
#define PMIC_RG_VSYS_CSM_MASK                      0x7
#define PMIC_RG_VSYS_CSM_SHIFT                     6
#define PMIC_RG_VSYS_ZXOS_TRIM_MASK                0x3F
#define PMIC_RG_VSYS_ZXOS_TRIM_SHIFT               9
#define PMIC_RG_VSYS_RZSEL_MASK                    0x3
#define PMIC_RG_VSYS_RZSEL_SHIFT                   0
#define PMIC_RG_VSYS_CC_MASK                       0x3
#define PMIC_RG_VSYS_CC_SHIFT                      4
#define PMIC_RG_VSYS_CSR_MASK                      0x3
#define PMIC_RG_VSYS_CSR_SHIFT                     6
#define PMIC_RG_VSYS_CSL_MASK                      0x3
#define PMIC_RG_VSYS_CSL_SHIFT                     8
#define PMIC_RG_VSYS_ZX_OS_MASK                    0x3
#define PMIC_RG_VSYS_ZX_OS_SHIFT                   14
#define PMIC_RG_VSYS_AVP_OS_MASK                   0x7
#define PMIC_RG_VSYS_AVP_OS_SHIFT                  0
#define PMIC_RG_VSYS_AVP_EN_MASK                   0x1
#define PMIC_RG_VSYS_AVP_EN_SHIFT                  3
#define PMIC_RG_VSYS_MODESET_MASK                  0x1
#define PMIC_RG_VSYS_MODESET_SHIFT                 8
#define PMIC_RG_VSYS_NDIS_EN_MASK                  0x1
#define PMIC_RG_VSYS_NDIS_EN_SHIFT                 9
#define PMIC_RG_VSYS_SLP_MASK                      0x3
#define PMIC_RG_VSYS_SLP_SHIFT                     0
#define PMIC_QI_VSYS_VSLEEP_MASK                   0x3
#define PMIC_QI_VSYS_VSLEEP_SHIFT                  4
#define PMIC_RG_VSYS_RSV_MASK                      0xFF
#define PMIC_RG_VSYS_RSV_SHIFT                     0
#define PMIC_VSYS_EN_CTRL_MASK                     0x1
#define PMIC_VSYS_EN_CTRL_SHIFT                    0
#define PMIC_VSYS_VOSEL_CTRL_MASK                  0x1
#define PMIC_VSYS_VOSEL_CTRL_SHIFT                 1
#define PMIC_VSYS_DLC_CTRL_MASK                    0x1
#define PMIC_VSYS_DLC_CTRL_SHIFT                   2
#define PMIC_VSYS_BURST_CTRL_MASK                  0x1
#define PMIC_VSYS_BURST_CTRL_SHIFT                 3
#define PMIC_VSYS_EN_MASK                          0x1
#define PMIC_VSYS_EN_SHIFT                         0
#define PMIC_QI_VSYS_STB_MASK                      0x1
#define PMIC_QI_VSYS_STB_SHIFT                     12
#define PMIC_QI_VSYS_EN_MASK                       0x1
#define PMIC_QI_VSYS_EN_SHIFT                      13
#define PMIC_QI_VSYS_OC_STATUS_MASK                0x1
#define PMIC_QI_VSYS_OC_STATUS_SHIFT               15
#define PMIC_VSYS_SFCHG_FRATE_MASK                 0x7F
#define PMIC_VSYS_SFCHG_FRATE_SHIFT                0
#define PMIC_VSYS_SFCHG_FEN_MASK                   0x1
#define PMIC_VSYS_SFCHG_FEN_SHIFT                  7
#define PMIC_VSYS_SFCHG_RRATE_MASK                 0x7F
#define PMIC_VSYS_SFCHG_RRATE_SHIFT                8
#define PMIC_VSYS_SFCHG_REN_MASK                   0x1
#define PMIC_VSYS_SFCHG_REN_SHIFT                  15
#define PMIC_VSYS_VOSEL_MASK                       0x7F
#define PMIC_VSYS_VOSEL_SHIFT                      0
#define PMIC_VSYS_VOSEL_ON_MASK                    0x7F
#define PMIC_VSYS_VOSEL_ON_SHIFT                   0
#define PMIC_VSYS_VOSEL_SLEEP_MASK                 0x7F
#define PMIC_VSYS_VOSEL_SLEEP_SHIFT                0
#define PMIC_NI_VSYS_VOSEL_MASK                    0x7F
#define PMIC_NI_VSYS_VOSEL_SHIFT                   0
#define PMIC_VSYS_BURST_MASK                       0x3
#define PMIC_VSYS_BURST_SHIFT                      0
#define PMIC_VSYS_BURST_ON_MASK                    0x3
#define PMIC_VSYS_BURST_ON_SHIFT                   4
#define PMIC_VSYS_BURST_SLEEP_MASK                 0x3
#define PMIC_VSYS_BURST_SLEEP_SHIFT                8
#define PMIC_QI_VSYS_BURST_MASK                    0x3
#define PMIC_QI_VSYS_BURST_SHIFT                   12
#define PMIC_VSYS_DLC_MASK                         0x3
#define PMIC_VSYS_DLC_SHIFT                        0
#define PMIC_VSYS_DLC_ON_MASK                      0x3
#define PMIC_VSYS_DLC_ON_SHIFT                     4
#define PMIC_VSYS_DLC_SLEEP_MASK                   0x3
#define PMIC_VSYS_DLC_SLEEP_SHIFT                  8
#define PMIC_QI_VSYS_DLC_MASK                      0x3
#define PMIC_QI_VSYS_DLC_SHIFT                     12
#define PMIC_VSYS_DLC_N_MASK                       0x3
#define PMIC_VSYS_DLC_N_SHIFT                      0
#define PMIC_VSYS_DLC_N_ON_MASK                    0x3
#define PMIC_VSYS_DLC_N_ON_SHIFT                   4
#define PMIC_VSYS_DLC_N_SLEEP_MASK                 0x3
#define PMIC_VSYS_DLC_N_SLEEP_SHIFT                8
#define PMIC_QI_VSYS_DLC_N_MASK                    0x3
#define PMIC_QI_VSYS_DLC_N_SHIFT                   12
#define PMIC_VSYS_TRANSTD_MASK                     0x3
#define PMIC_VSYS_TRANSTD_SHIFT                    0
#define PMIC_VSYS_VOSEL_TRANS_EN_MASK              0x3
#define PMIC_VSYS_VOSEL_TRANS_EN_SHIFT             4
#define PMIC_VSYS_VOSEL_TRANS_ONCE_MASK            0x1
#define PMIC_VSYS_VOSEL_TRANS_ONCE_SHIFT           6
#define PMIC_NI_VSYS_VOSEL_TRANS_MASK              0x1
#define PMIC_NI_VSYS_VOSEL_TRANS_SHIFT             7
#define PMIC_VSYS_VSLEEP_EN_MASK                   0x1
#define PMIC_VSYS_VSLEEP_EN_SHIFT                  8
#define PMIC_VSYS_R2R_PDN_MASK                     0x1
#define PMIC_VSYS_R2R_PDN_SHIFT                    10
#define PMIC_VSYS_VSLEEP_SEL_MASK                  0x1
#define PMIC_VSYS_VSLEEP_SEL_SHIFT                 11
#define PMIC_NI_VSYS_R2R_PDN_MASK                  0x1
#define PMIC_NI_VSYS_R2R_PDN_SHIFT                 14
#define PMIC_NI_VSYS_VSLEEP_SEL_MASK               0x1
#define PMIC_NI_VSYS_VSLEEP_SEL_SHIFT              15
#define PMIC_RG_VPA_TRIML_MASK                     0x7
#define PMIC_RG_VPA_TRIML_SHIFT                    0
#define PMIC_RG_VPA_TRIMH_MASK                     0x7
#define PMIC_RG_VPA_TRIMH_SHIFT                    3
#define PMIC_RG_VPA_RZSEL_MASK                     0x3
#define PMIC_RG_VPA_RZSEL_SHIFT                    0
#define PMIC_RG_VPA_CC_MASK                        0x3
#define PMIC_RG_VPA_CC_SHIFT                       4
#define PMIC_RG_VPA_CSR_MASK                       0x3
#define PMIC_RG_VPA_CSR_SHIFT                      6
#define PMIC_RG_VPA_CSL_MASK                       0x3
#define PMIC_RG_VPA_CSL_SHIFT                      8
#define PMIC_RG_VPA_SLEW_NMOS_MASK                 0x3
#define PMIC_RG_VPA_SLEW_NMOS_SHIFT                10
#define PMIC_RG_VPA_SLEW_MASK                      0x3
#define PMIC_RG_VPA_SLEW_SHIFT                     12
#define PMIC_RG_VPA_ZX_OS_MASK                     0x3
#define PMIC_RG_VPA_ZX_OS_SHIFT                    14
#define PMIC_RG_VPA_MODESET_MASK                   0x1
#define PMIC_RG_VPA_MODESET_SHIFT                  8
#define PMIC_RG_VPA_NDIS_EN_MASK                   0x1
#define PMIC_RG_VPA_NDIS_EN_SHIFT                  9
#define PMIC_RG_VPA_CSMIR_MASK                     0x3
#define PMIC_RG_VPA_CSMIR_SHIFT                    12
#define PMIC_RG_VPA_VBAT_DEL_MASK                  0x3
#define PMIC_RG_VPA_VBAT_DEL_SHIFT                 14
#define PMIC_RG_VPA_SLP_MASK                       0x3
#define PMIC_RG_VPA_SLP_SHIFT                      0
#define PMIC_RG_VPA_GPU_EN_MASK                    0x1
#define PMIC_RG_VPA_GPU_EN_SHIFT                   6
#define PMIC_RG_VPA_RSV_MASK                       0xFFFF
#define PMIC_RG_VPA_RSV_SHIFT                      0
#define PMIC_VPA_EN_CTRL_MASK                      0x1
#define PMIC_VPA_EN_CTRL_SHIFT                     0
#define PMIC_VPA_VOSEL_CTRL_MASK                   0x1
#define PMIC_VPA_VOSEL_CTRL_SHIFT                  1
#define PMIC_VPA_DLC_CTRL_MASK                     0x1
#define PMIC_VPA_DLC_CTRL_SHIFT                    2
#define PMIC_VPA_BURST_CTRL_MASK                   0x1
#define PMIC_VPA_BURST_CTRL_SHIFT                  3
#define PMIC_VPA_EN_MASK                           0x1
#define PMIC_VPA_EN_SHIFT                          0
#define PMIC_QI_VPA_STB_MASK                       0x1
#define PMIC_QI_VPA_STB_SHIFT                      12
#define PMIC_QI_VPA_EN_MASK                        0x1
#define PMIC_QI_VPA_EN_SHIFT                       13
#define PMIC_QI_VPA_OC_STATUS_MASK                 0x1
#define PMIC_QI_VPA_OC_STATUS_SHIFT                15
#define PMIC_VPA_SFCHG_FRATE_MASK                  0x7F
#define PMIC_VPA_SFCHG_FRATE_SHIFT                 0
#define PMIC_VPA_SFCHG_FEN_MASK                    0x1
#define PMIC_VPA_SFCHG_FEN_SHIFT                   7
#define PMIC_VPA_SFCHG_RRATE_MASK                  0x7F
#define PMIC_VPA_SFCHG_RRATE_SHIFT                 8
#define PMIC_VPA_SFCHG_REN_MASK                    0x1
#define PMIC_VPA_SFCHG_REN_SHIFT                   15
#define PMIC_VPA_VOSEL_MASK                        0x3F
#define PMIC_VPA_VOSEL_SHIFT                       0
#define PMIC_VPA_VOSEL_ON_MASK                     0x3F
#define PMIC_VPA_VOSEL_ON_SHIFT                    0
#define PMIC_VPA_VOSEL_SLEEP_MASK                  0x3F
#define PMIC_VPA_VOSEL_SLEEP_SHIFT                 0
#define PMIC_NI_VPA_VOSEL_MASK                     0x3F
#define PMIC_NI_VPA_VOSEL_SHIFT                    0
#define PMIC_VPA_DLC_MASK                          0x7
#define PMIC_VPA_DLC_SHIFT                         0
#define PMIC_VPA_DLC_ON_MASK                       0x7
#define PMIC_VPA_DLC_ON_SHIFT                      4
#define PMIC_VPA_DLC_SLEEP_MASK                    0x7
#define PMIC_VPA_DLC_SLEEP_SHIFT                   8
#define PMIC_QI_VPA_DLC_MASK                       0x7
#define PMIC_QI_VPA_DLC_SHIFT                      12
#define PMIC_VPA_BURSTH_MASK                       0x3
#define PMIC_VPA_BURSTH_SHIFT                      0
#define PMIC_VPA_BURSTH_ON_MASK                    0x3
#define PMIC_VPA_BURSTH_ON_SHIFT                   4
#define PMIC_VPA_BURSTH_SLEEP_MASK                 0x3
#define PMIC_VPA_BURSTH_SLEEP_SHIFT                8
#define PMIC_QI_VPA_BURSTH_MASK                    0x3
#define PMIC_QI_VPA_BURSTH_SHIFT                   12
#define PMIC_VPA_BURSTL_MASK                       0x3
#define PMIC_VPA_BURSTL_SHIFT                      0
#define PMIC_VPA_BURSTL_ON_MASK                    0x3
#define PMIC_VPA_BURSTL_ON_SHIFT                   4
#define PMIC_VPA_BURSTL_SLEEP_MASK                 0x3
#define PMIC_VPA_BURSTL_SLEEP_SHIFT                8
#define PMIC_QI_VPA_BURSTL_MASK                    0x3
#define PMIC_QI_VPA_BURSTL_SHIFT                   12
#define PMIC_VPA_TRANSTD_MASK                      0x3
#define PMIC_VPA_TRANSTD_SHIFT                     0
#define PMIC_VPA_VOSEL_TRANS_EN_MASK               0x3
#define PMIC_VPA_VOSEL_TRANS_EN_SHIFT              4
#define PMIC_VPA_VOSEL_TRANS_ONCE_MASK             0x1
#define PMIC_VPA_VOSEL_TRANS_ONCE_SHIFT            6
#define PMIC_NI_VPA_DVS_BW_MASK                    0x1
#define PMIC_NI_VPA_DVS_BW_SHIFT                   7
#define PMIC_VPA_DLC_MAP_EN_MASK                   0x1
#define PMIC_VPA_DLC_MAP_EN_SHIFT                  0
#define PMIC_VPA_VOSEL_DLC001_MASK                 0x3F
#define PMIC_VPA_VOSEL_DLC001_SHIFT                8
#define PMIC_VPA_VOSEL_DLC011_MASK                 0x3F
#define PMIC_VPA_VOSEL_DLC011_SHIFT                0
#define PMIC_VPA_VOSEL_DLC111_MASK                 0x3F
#define PMIC_VPA_VOSEL_DLC111_SHIFT                8
#define PMIC_K_RST_DONE_MASK                       0x1
#define PMIC_K_RST_DONE_SHIFT                      0
#define PMIC_K_MAP_SEL_MASK                        0x1
#define PMIC_K_MAP_SEL_SHIFT                       1
#define PMIC_K_ONCE_EN_MASK                        0x1
#define PMIC_K_ONCE_EN_SHIFT                       2
#define PMIC_K_ONCE_MASK                           0x1
#define PMIC_K_ONCE_SHIFT                          3
#define PMIC_K_START_MANUAL_MASK                   0x1
#define PMIC_K_START_MANUAL_SHIFT                  4
#define PMIC_K_SRC_SEL_MASK                        0x1
#define PMIC_K_SRC_SEL_SHIFT                       5
#define PMIC_K_AUTO_EN_MASK                        0x1
#define PMIC_K_AUTO_EN_SHIFT                       6
#define PMIC_K_INV_MASK                            0x1
#define PMIC_K_INV_SHIFT                           7
#define PMIC_K_CONTROL_SMPS_MASK                   0x1F
#define PMIC_K_CONTROL_SMPS_SHIFT                  8
#define PMIC_K_RESULT_MASK                         0x1
#define PMIC_K_RESULT_SHIFT                        0
#define PMIC_K_DONE_MASK                           0x1
#define PMIC_K_DONE_SHIFT                          1
#define PMIC_K_CONTROL_MASK                        0x1F
#define PMIC_K_CONTROL_SHIFT                       3
#define PMIC_QI_SMPS_OSC_CAL_MASK                  0x1F
#define PMIC_QI_SMPS_OSC_CAL_SHIFT                 8
#define PMIC_ISINK_CH0_MODE_MASK                   0x3
#define PMIC_ISINK_CH0_MODE_SHIFT                  2
#define PMIC_ISINK0_RSV1_MASK                      0xF
#define PMIC_ISINK0_RSV1_SHIFT                     4
#define PMIC_ISINK_DIM0_DUTY_MASK                  0x1F
#define PMIC_ISINK_DIM0_DUTY_SHIFT                 8
#define PMIC_ISINK0_RSV0_MASK                      0x7
#define PMIC_ISINK0_RSV0_SHIFT                     13
#define PMIC_ISINK_DIM0_FSEL_MASK                  0xFFFF
#define PMIC_ISINK_DIM0_FSEL_SHIFT                 0
#define PMIC_ISINK_SFSTR0_EN_MASK                  0x1
#define PMIC_ISINK_SFSTR0_EN_SHIFT                 0
#define PMIC_ISINK_SFSTR0_TC_MASK                  0x3
#define PMIC_ISINK_SFSTR0_TC_SHIFT                 1
#define PMIC_ISINK_CH0_STEP_MASK                   0x7
#define PMIC_ISINK_CH0_STEP_SHIFT                  12
#define PMIC_ISINK_BREATH0_TOFF_SEL_MASK           0xF
#define PMIC_ISINK_BREATH0_TOFF_SEL_SHIFT          0
#define PMIC_ISINK_BREATH0_TON_SEL_MASK            0xF
#define PMIC_ISINK_BREATH0_TON_SEL_SHIFT           8
#define PMIC_ISINK_BREATH0_TRF_SEL_MASK            0xF
#define PMIC_ISINK_BREATH0_TRF_SEL_SHIFT           12
#define PMIC_ISINK_CH1_MODE_MASK                   0x3
#define PMIC_ISINK_CH1_MODE_SHIFT                  2
#define PMIC_ISINK1_RSV1_MASK                      0xF
#define PMIC_ISINK1_RSV1_SHIFT                     4
#define PMIC_ISINK_DIM1_DUTY_MASK                  0x1F
#define PMIC_ISINK_DIM1_DUTY_SHIFT                 8
#define PMIC_ISINK1_RSV0_MASK                      0x7
#define PMIC_ISINK1_RSV0_SHIFT                     13
#define PMIC_ISINK_DIM1_FSEL_MASK                  0xFFFF
#define PMIC_ISINK_DIM1_FSEL_SHIFT                 0
#define PMIC_ISINK_SFSTR1_EN_MASK                  0x1
#define PMIC_ISINK_SFSTR1_EN_SHIFT                 0
#define PMIC_ISINK_SFSTR1_TC_MASK                  0x3
#define PMIC_ISINK_SFSTR1_TC_SHIFT                 1
#define PMIC_ISINK_CH1_STEP_MASK                   0x7
#define PMIC_ISINK_CH1_STEP_SHIFT                  12
#define PMIC_ISINK_BREATH1_TOFF_SEL_MASK           0xF
#define PMIC_ISINK_BREATH1_TOFF_SEL_SHIFT          0
#define PMIC_ISINK_BREATH1_TON_SEL_MASK            0xF
#define PMIC_ISINK_BREATH1_TON_SEL_SHIFT           8
#define PMIC_ISINK_BREATH1_TRF_SEL_MASK            0xF
#define PMIC_ISINK_BREATH1_TRF_SEL_SHIFT           12
#define PMIC_ISINK_CH2_MODE_MASK                   0x3
#define PMIC_ISINK_CH2_MODE_SHIFT                  2
#define PMIC_ISINK2_RSV1_MASK                      0xF
#define PMIC_ISINK2_RSV1_SHIFT                     4
#define PMIC_ISINK_DIM2_DUTY_MASK                  0x1F
#define PMIC_ISINK_DIM2_DUTY_SHIFT                 8
#define PMIC_ISINK2_RSV0_MASK                      0x7
#define PMIC_ISINK2_RSV0_SHIFT                     13
#define PMIC_ISINK_DIM2_FSEL_MASK                  0xFFFF
#define PMIC_ISINK_DIM2_FSEL_SHIFT                 0
#define PMIC_ISINK_SFSTR2_EN_MASK                  0x1
#define PMIC_ISINK_SFSTR2_EN_SHIFT                 0
#define PMIC_ISINK_SFSTR2_TC_MASK                  0x3
#define PMIC_ISINK_SFSTR2_TC_SHIFT                 1
#define PMIC_ISINK_CH2_STEP_MASK                   0x7
#define PMIC_ISINK_CH2_STEP_SHIFT                  12
#define PMIC_ISINK_BREATH2_TOFF_SEL_MASK           0xF
#define PMIC_ISINK_BREATH2_TOFF_SEL_SHIFT          0
#define PMIC_ISINK_BREATH2_TON_SEL_MASK            0xF
#define PMIC_ISINK_BREATH2_TON_SEL_SHIFT           8
#define PMIC_ISINK_BREATH2_TRF_SEL_MASK            0xF
#define PMIC_ISINK_BREATH2_TRF_SEL_SHIFT           12
#define PMIC_ISINK_CH3_MODE_MASK                   0x3
#define PMIC_ISINK_CH3_MODE_SHIFT                  2
#define PMIC_ISINK3_RSV1_MASK                      0xF
#define PMIC_ISINK3_RSV1_SHIFT                     4
#define PMIC_ISINK_DIM3_DUTY_MASK                  0x1F
#define PMIC_ISINK_DIM3_DUTY_SHIFT                 8
#define PMIC_ISINK3_RSV0_MASK                      0x7
#define PMIC_ISINK3_RSV0_SHIFT                     13
#define PMIC_ISINK_DIM3_FSEL_MASK                  0xFFFF
#define PMIC_ISINK_DIM3_FSEL_SHIFT                 0
#define PMIC_ISINK_SFSTR3_EN_MASK                  0x1
#define PMIC_ISINK_SFSTR3_EN_SHIFT                 0
#define PMIC_ISINK_SFSTR3_TC_MASK                  0x3
#define PMIC_ISINK_SFSTR3_TC_SHIFT                 1
#define PMIC_ISINK_CH3_STEP_MASK                   0x7
#define PMIC_ISINK_CH3_STEP_SHIFT                  12
#define PMIC_ISINK_BREATH3_TOFF_SEL_MASK           0xF
#define PMIC_ISINK_BREATH3_TOFF_SEL_SHIFT          0
#define PMIC_ISINK_BREATH3_TON_SEL_MASK            0xF
#define PMIC_ISINK_BREATH3_TON_SEL_SHIFT           8
#define PMIC_ISINK_BREATH3_TRF_SEL_MASK            0xF
#define PMIC_ISINK_BREATH3_TRF_SEL_SHIFT           12
#define PMIC_RG_ISINKS_RSV_MASK                    0xFF
#define PMIC_RG_ISINKS_RSV_SHIFT                   0
#define PMIC_RG_ISINK3_DOUBLE_EN_MASK              0x1
#define PMIC_RG_ISINK3_DOUBLE_EN_SHIFT             8
#define PMIC_RG_ISINK2_DOUBLE_EN_MASK              0x1
#define PMIC_RG_ISINK2_DOUBLE_EN_SHIFT             9
#define PMIC_RG_ISINK1_DOUBLE_EN_MASK              0x1
#define PMIC_RG_ISINK1_DOUBLE_EN_SHIFT             10
#define PMIC_RG_ISINK0_DOUBLE_EN_MASK              0x1
#define PMIC_RG_ISINK0_DOUBLE_EN_SHIFT             11
#define PMIC_RG_TRIM_SEL_MASK                      0x7
#define PMIC_RG_TRIM_SEL_SHIFT                     12
#define PMIC_RG_TRIM_EN_MASK                       0x1
#define PMIC_RG_TRIM_EN_SHIFT                      15
#define PMIC_NI_ISINK3_STATUS_MASK                 0x1
#define PMIC_NI_ISINK3_STATUS_SHIFT                0
#define PMIC_NI_ISINK2_STATUS_MASK                 0x1
#define PMIC_NI_ISINK2_STATUS_SHIFT                1
#define PMIC_NI_ISINK1_STATUS_MASK                 0x1
#define PMIC_NI_ISINK1_STATUS_SHIFT                2
#define PMIC_NI_ISINK0_STATUS_MASK                 0x1
#define PMIC_NI_ISINK0_STATUS_SHIFT                3
#define PMIC_ISINK_PHASE0_DLY_EN_MASK              0x1
#define PMIC_ISINK_PHASE0_DLY_EN_SHIFT             0
#define PMIC_ISINK_PHASE1_DLY_EN_MASK              0x1
#define PMIC_ISINK_PHASE1_DLY_EN_SHIFT             1
#define PMIC_ISINK_PHASE2_DLY_EN_MASK              0x1
#define PMIC_ISINK_PHASE2_DLY_EN_SHIFT             2
#define PMIC_ISINK_PHASE3_DLY_EN_MASK              0x1
#define PMIC_ISINK_PHASE3_DLY_EN_SHIFT             3
#define PMIC_ISINK_PHASE_DLY_TC_MASK               0x3
#define PMIC_ISINK_PHASE_DLY_TC_SHIFT              4
#define PMIC_ISINK_CH0_EN_MASK                     0x1
#define PMIC_ISINK_CH0_EN_SHIFT                    0
#define PMIC_ISINK_CH1_EN_MASK                     0x1
#define PMIC_ISINK_CH1_EN_SHIFT                    1
#define PMIC_ISINK_CH2_EN_MASK                     0x1
#define PMIC_ISINK_CH2_EN_SHIFT                    2
#define PMIC_ISINK_CH3_EN_MASK                     0x1
#define PMIC_ISINK_CH3_EN_SHIFT                    3
#define PMIC_ISINK_CHOP0_EN_MASK                   0x1
#define PMIC_ISINK_CHOP0_EN_SHIFT                  4
#define PMIC_ISINK_CHOP1_EN_MASK                   0x1
#define PMIC_ISINK_CHOP1_EN_SHIFT                  5
#define PMIC_ISINK_CHOP2_EN_MASK                   0x1
#define PMIC_ISINK_CHOP2_EN_SHIFT                  6
#define PMIC_ISINK_CHOP3_EN_MASK                   0x1
#define PMIC_ISINK_CHOP3_EN_SHIFT                  7
#define PMIC_RG_ANALDORSV1_MASK                    0xFFFF
#define PMIC_RG_ANALDORSV1_SHIFT                   0
#define PMIC_VTCXO_LP_SEL_MASK                     0x1
#define PMIC_VTCXO_LP_SEL_SHIFT                    0
#define PMIC_VTCXO_LP_SET_MASK                     0x1
#define PMIC_VTCXO_LP_SET_SHIFT                    1
#define PMIC_QI_VTCXO_MODE_MASK                    0x1
#define PMIC_QI_VTCXO_MODE_SHIFT                   7
#define PMIC_RG_VTCXO_STBTD_MASK                   0x3
#define PMIC_RG_VTCXO_STBTD_SHIFT                  8
#define PMIC_RG_VTCXO_EN_MASK                      0x1
#define PMIC_RG_VTCXO_EN_SHIFT                     10
#define PMIC_VTCXO_ON_CTRL_MASK                    0x1
#define PMIC_VTCXO_ON_CTRL_SHIFT                   11
#define PMIC_QI_VTCXO_EN_MASK                      0x1
#define PMIC_QI_VTCXO_EN_SHIFT                     15
#define PMIC_VA_LP_SEL_MASK                        0x1
#define PMIC_VA_LP_SEL_SHIFT                       0
#define PMIC_VA_LP_SET_MASK                        0x1
#define PMIC_VA_LP_SET_SHIFT                       1
#define PMIC_QI_VA_MODE_MASK                       0x1
#define PMIC_QI_VA_MODE_SHIFT                      7
#define PMIC_RG_VA_SENSE_SEL_MASK                  0x3
#define PMIC_RG_VA_SENSE_SEL_SHIFT                 8
#define PMIC_RG_VA_STBTD_MASK                      0x3
#define PMIC_RG_VA_STBTD_SHIFT                     12
#define PMIC_RG_VA_EN_MASK                         0x1
#define PMIC_RG_VA_EN_SHIFT                        14
#define PMIC_QI_VA_EN_MASK                         0x1
#define PMIC_QI_VA_EN_SHIFT                        15
#define PMIC_RG_ANALDORSV2_MASK                    0xFFFF
#define PMIC_RG_ANALDORSV2_SHIFT                   0
#define PMIC_RG_VCAMA_STBTD_MASK                   0x3
#define PMIC_RG_VCAMA_STBTD_SHIFT                  12
#define PMIC_RG_VCAMA_EN_MASK                      0x1
#define PMIC_RG_VCAMA_EN_SHIFT                     15
#define PMIC_RG_VCAMA_BIST_EN_MASK                 0x1
#define PMIC_RG_VCAMA_BIST_EN_SHIFT                0
#define PMIC_RG_VA_BIST_EN_MASK                    0x1
#define PMIC_RG_VA_BIST_EN_SHIFT                   3
#define PMIC_RG_VTCXO_BIST_EN_MASK                 0x1
#define PMIC_RG_VTCXO_BIST_EN_SHIFT                5
#define PMIC_QI_VCAMA_OC_STATUS_MASK               0x1
#define PMIC_QI_VCAMA_OC_STATUS_SHIFT              8
#define PMIC_QI_VA_OC_STATUS_MASK                  0x1
#define PMIC_QI_VA_OC_STATUS_SHIFT                 11
#define PMIC_QI_VTCXO_OC_STATUS_MASK               0x1
#define PMIC_QI_VTCXO_OC_STATUS_SHIFT              13
#define PMIC_RG_ANALDORSV3_MASK                    0xFFFF
#define PMIC_RG_ANALDORSV3_SHIFT                   0
#define PMIC_RG_VTCXO_NDIS_EN_MASK                 0x1
#define PMIC_RG_VTCXO_NDIS_EN_SHIFT                4
#define PMIC_RG_VTCXO_OCFB_MASK                    0x1
#define PMIC_RG_VTCXO_OCFB_SHIFT                   6
#define PMIC_RG_VTCXO_CAL_MASK                     0xF
#define PMIC_RG_VTCXO_CAL_SHIFT                    8
#define PMIC_RG_VA_NDIS_EN_MASK                    0x1
#define PMIC_RG_VA_NDIS_EN_SHIFT                   2
#define PMIC_RG_VA_OCFB_MASK                       0x1
#define PMIC_RG_VA_OCFB_SHIFT                      4
#define PMIC_RG_VA_VOSEL_MASK                      0x1
#define PMIC_RG_VA_VOSEL_SHIFT                     6
#define PMIC_RG_VA_CAL_MASK                        0xF
#define PMIC_RG_VA_CAL_SHIFT                       8
#define PMIC_RG_VCAMA_FBSEL_MASK                   0x3
#define PMIC_RG_VCAMA_FBSEL_SHIFT                  0
#define PMIC_RG_VCAMA_NDIS_EN_MASK                 0x1
#define PMIC_RG_VCAMA_NDIS_EN_SHIFT                2
#define PMIC_RG_VCAMA_OCFB_MASK                    0x1
#define PMIC_RG_VCAMA_OCFB_SHIFT                   3
#define PMIC_RG_VCAMA_STB_SEL_MASK                 0x1
#define PMIC_RG_VCAMA_STB_SEL_SHIFT                4
#define PMIC_RG_VCAMA_VOSEL_MASK                   0x3
#define PMIC_RG_VCAMA_VOSEL_SHIFT                  5
#define PMIC_VCAMA_ON_CTRL_MASK                    0x1
#define PMIC_VCAMA_ON_CTRL_SHIFT                   7
#define PMIC_RG_VCAMA_CAL_MASK                     0xF
#define PMIC_RG_VCAMA_CAL_SHIFT                    8
#define PMIC_RG_RESERVE_STB_SEL_MASK               0xF
#define PMIC_RG_RESERVE_STB_SEL_SHIFT              0
#define PMIC_RG_ALDO_RESERVE_MASK                  0xF
#define PMIC_RG_ALDO_RESERVE_SHIFT                 12
#define PMIC_RG_VCN33_VOSEL_MASK                   0x3
#define PMIC_RG_VCN33_VOSEL_SHIFT                  2
#define PMIC_RG_VCN33_NDIS_EN_MASK                 0x1
#define PMIC_RG_VCN33_NDIS_EN_SHIFT                4
#define PMIC_VCN33_ON_CTRL_BT_MASK                 0x1
#define PMIC_VCN33_ON_CTRL_BT_SHIFT                5
#define PMIC_RG_VCN33_OCFB_MASK                    0x1
#define PMIC_RG_VCN33_OCFB_SHIFT                   6
#define PMIC_RG_VCN33_EN_BT_MASK                   0x1
#define PMIC_RG_VCN33_EN_BT_SHIFT                  7
#define PMIC_RG_VCN33_CAL_MASK                     0xF
#define PMIC_RG_VCN33_CAL_SHIFT                    11
#define PMIC_RG_VCN33_STBTD_MASK                   0x3
#define PMIC_RG_VCN33_STBTD_SHIFT                  8
#define PMIC_RG_VCN33_EN_WIFI_MASK                 0x1
#define PMIC_RG_VCN33_EN_WIFI_SHIFT                12
#define PMIC_VCN33_ON_CTRL_WIFI_MASK               0x1
#define PMIC_VCN33_ON_CTRL_WIFI_SHIFT              14
#define PMIC_QI_VCN33_EN_MASK                      0x1
#define PMIC_QI_VCN33_EN_SHIFT                     15
#define PMIC_RG_VCN28_BIST_EN_MASK                 0x1
#define PMIC_RG_VCN28_BIST_EN_SHIFT                1
#define PMIC_RG_VCN28_NDIS_EN_MASK                 0x1
#define PMIC_RG_VCN28_NDIS_EN_SHIFT                2
#define PMIC_RG_VCN28_OCFB_MASK                    0x1
#define PMIC_RG_VCN28_OCFB_SHIFT                   4
#define PMIC_RG_VCN28_VOSEL_MASK                   0x1
#define PMIC_RG_VCN28_VOSEL_SHIFT                  6
#define PMIC_RG_VCN28_CAL_MASK                     0xF
#define PMIC_RG_VCN28_CAL_SHIFT                    8
#define PMIC_RG_VCN28_STBTD_MASK                   0x3
#define PMIC_RG_VCN28_STBTD_SHIFT                  8
#define PMIC_RG_VCN28_EN_MASK                      0x1
#define PMIC_RG_VCN28_EN_SHIFT                     12
#define PMIC_VCN28_ON_CTRL_MASK                    0x1
#define PMIC_VCN28_ON_CTRL_SHIFT                   14
#define PMIC_QI_VCN28_EN_MASK                      0x1
#define PMIC_QI_VCN28_EN_SHIFT                     15
#define PMIC_VCN28_LP_SEL_MASK                     0x1
#define PMIC_VCN28_LP_SEL_SHIFT                    0
#define PMIC_VCN28_LP_SET_MASK                     0x1
#define PMIC_VCN28_LP_SET_SHIFT                    1
#define PMIC_QI_VCN28_MODE_MASK                    0x1
#define PMIC_QI_VCN28_MODE_SHIFT                   7
#define PMIC_QI_VCN28_OC_STATUS_MASK               0x1
#define PMIC_QI_VCN28_OC_STATUS_SHIFT              15
#define PMIC_VCN33_LP_SEL_MASK                     0x1
#define PMIC_VCN33_LP_SEL_SHIFT                    0
#define PMIC_VCN33_LP_SET_MASK                     0x1
#define PMIC_VCN33_LP_SET_SHIFT                    1
#define PMIC_QI_VCN33_MODE_MASK                    0x1
#define PMIC_QI_VCN33_MODE_SHIFT                   7
#define PMIC_RG_VCN33_EN_MASK                      0x1
#define PMIC_RG_VCN33_EN_SHIFT                     12
#define PMIC_RG_VCN33_BIST_EN_MASK                 0x1
#define PMIC_RG_VCN33_BIST_EN_SHIFT                14
#define PMIC_QI_VCN33_OC_STATUS_MASK               0x1
#define PMIC_QI_VCN33_OC_STATUS_SHIFT              15
#define PMIC_VIO28_LP_SEL_MASK                     0x1
#define PMIC_VIO28_LP_SEL_SHIFT                    0
#define PMIC_VIO28_LP_MODE_SET_MASK                0x1
#define PMIC_VIO28_LP_MODE_SET_SHIFT               1
#define PMIC_QI_VIO28_MODE_MASK                    0x1
#define PMIC_QI_VIO28_MODE_SHIFT                   7
#define PMIC_RG_VIO28_STBTD_MASK                   0x3
#define PMIC_RG_VIO28_STBTD_SHIFT                  12
#define PMIC_VIO28_EN_MASK                         0x1
#define PMIC_VIO28_EN_SHIFT                        14
#define PMIC_QI_VIO28_EN_MASK                      0x1
#define PMIC_QI_VIO28_EN_SHIFT                     15
#define PMIC_VUSB_LP_SEL_MASK                      0x1
#define PMIC_VUSB_LP_SEL_SHIFT                     0
#define PMIC_VUSB_LP_MODE_SET_MASK                 0x1
#define PMIC_VUSB_LP_MODE_SET_SHIFT                1
#define PMIC_QI_VUSB_MODE_MASK                     0x1
#define PMIC_QI_VUSB_MODE_SHIFT                    7
#define PMIC_RG_VUSB_STBTD_MASK                    0x3
#define PMIC_RG_VUSB_STBTD_SHIFT                   12
#define PMIC_RG_VUSB_EN_MASK                       0x1
#define PMIC_RG_VUSB_EN_SHIFT                      14
#define PMIC_QI_VUSB_EN_MASK                       0x1
#define PMIC_QI_VUSB_EN_SHIFT                      15
#define PMIC_VMC_LP_SEL_MASK                       0x1
#define PMIC_VMC_LP_SEL_SHIFT                      0
#define PMIC_VMC_LP_MODE_SET_MASK                  0x1
#define PMIC_VMC_LP_MODE_SET_SHIFT                 1
#define PMIC_RG_STB_SEL_MASK                       0x1
#define PMIC_RG_STB_SEL_SHIFT                      2
#define PMIC_QI_VMC_MODE_MASK                      0x1
#define PMIC_QI_VMC_MODE_SHIFT                     7
#define PMIC_RG_VMC_STBTD_MASK                     0x3
#define PMIC_RG_VMC_STBTD_SHIFT                    8
#define PMIC_RG_VMC_EN_MASK                        0x1
#define PMIC_RG_VMC_EN_SHIFT                       12
#define PMIC_RG_VMC_INT_DIS_SEL_MASK               0x1
#define PMIC_RG_VMC_INT_DIS_SEL_SHIFT              14
#define PMIC_QI_VMC_EN_MASK                        0x1
#define PMIC_QI_VMC_EN_SHIFT                       15
#define PMIC_VMCH_LP_SEL_MASK                      0x1
#define PMIC_VMCH_LP_SEL_SHIFT                     0
#define PMIC_VMCH_LP_MODE_SET_MASK                 0x1
#define PMIC_VMCH_LP_MODE_SET_SHIFT                1
#define PMIC_QI_VMCH_MODE_MASK                     0x1
#define PMIC_QI_VMCH_MODE_SHIFT                    7
#define PMIC_RG_VMCH_STBTD_MASK                    0x3
#define PMIC_RG_VMCH_STBTD_SHIFT                   12
#define PMIC_RG_VMCH_EN_MASK                       0x1
#define PMIC_RG_VMCH_EN_SHIFT                      14
#define PMIC_QI_VMCH_EN_MASK                       0x1
#define PMIC_QI_VMCH_EN_SHIFT                      15
#define PMIC_VEMC_3V3_LP_SEL_MASK                  0x1
#define PMIC_VEMC_3V3_LP_SEL_SHIFT                 0
#define PMIC_VEMC_3V3_LP_MODE_SET_MASK             0x1
#define PMIC_VEMC_3V3_LP_MODE_SET_SHIFT            1
#define PMIC_QI_VEMC_3V3_MODE_MASK                 0x1
#define PMIC_QI_VEMC_3V3_MODE_SHIFT                7
#define PMIC_RG_VEMC_3V3_STBTD_MASK                0x3
#define PMIC_RG_VEMC_3V3_STBTD_SHIFT               12
#define PMIC_RG_VEMC_3V3_EN_MASK                   0x1
#define PMIC_RG_VEMC_3V3_EN_SHIFT                  14
#define PMIC_QI_VEMC_3V3_EN_MASK                   0x1
#define PMIC_QI_VEMC_3V3_EN_SHIFT                  15
#define PMIC_VGP1_LP_SEL_MASK                      0x1
#define PMIC_VGP1_LP_SEL_SHIFT                     0
#define PMIC_VGP1_LP_MODE_SET_MASK                 0x1
#define PMIC_VGP1_LP_MODE_SET_SHIFT                1
#define PMIC_QI_VGP1_MODE_MASK                     0x1
#define PMIC_QI_VGP1_MODE_SHIFT                    7
#define PMIC_RG_VGP1_STBTD_MASK                    0x3
#define PMIC_RG_VGP1_STBTD_SHIFT                   12
#define PMIC_RG_VGP1_EN_MASK                       0x1
#define PMIC_RG_VGP1_EN_SHIFT                      15
#define PMIC_VGP2_LP_SEL_MASK                      0x1
#define PMIC_VGP2_LP_SEL_SHIFT                     0
#define PMIC_VGP2_LP_MODE_SET_MASK                 0x1
#define PMIC_VGP2_LP_MODE_SET_SHIFT                1
#define PMIC_QI_VGP2_MODE_MASK                     0x1
#define PMIC_QI_VGP2_MODE_SHIFT                    7
#define PMIC_RG_VGP2_STBTD_MASK                    0x3
#define PMIC_RG_VGP2_STBTD_SHIFT                   12
#define PMIC_RG_VGP2_EN_MASK                       0x1
#define PMIC_RG_VGP2_EN_SHIFT                      15
#define PMIC_VGP3_LP_SEL_MASK                      0x1
#define PMIC_VGP3_LP_SEL_SHIFT                     0
#define PMIC_VGP3_LP_MODE_SET_MASK                 0x1
#define PMIC_VGP3_LP_MODE_SET_SHIFT                1
#define PMIC_QI_VGP3_MODE_MASK                     0x1
#define PMIC_QI_VGP3_MODE_SHIFT                    7
#define PMIC_RG_VGP3_STBTD_MASK                    0x3
#define PMIC_RG_VGP3_STBTD_SHIFT                   12
#define PMIC_RG_VGP3_EN_MASK                       0x1
#define PMIC_RG_VGP3_EN_SHIFT                      15
#define PMIC_RG_VCN_1V8_NDIS_EN_MASK               0x1
#define PMIC_RG_VCN_1V8_NDIS_EN_SHIFT              0
#define PMIC_VCN_1V8_ON_CTRL_MASK                  0x1
#define PMIC_VCN_1V8_ON_CTRL_SHIFT                 1
#define PMIC_RG_VCN_1V8_OCFB_MASK                  0x1
#define PMIC_RG_VCN_1V8_OCFB_SHIFT                 2
#define PMIC_RG_VCN_1V8_STB_SEL_MASK               0x1
#define PMIC_RG_VCN_1V8_STB_SEL_SHIFT              4
#define PMIC_RG_VCN_1V8_CAL_MASK                   0xF
#define PMIC_RG_VCN_1V8_CAL_SHIFT                  8
#define PMIC_VCN_1V8_LP_SEL_MASK                   0x1
#define PMIC_VCN_1V8_LP_SEL_SHIFT                  0
#define PMIC_VCN_1V8_LP_MODE_SET_MASK              0x1
#define PMIC_VCN_1V8_LP_MODE_SET_SHIFT             1
#define PMIC_QI_VCN_1V8_MODE_MASK                  0x1
#define PMIC_QI_VCN_1V8_MODE_SHIFT                 7
#define PMIC_RG_VCN_1V8_STBTD_MASK                 0x3
#define PMIC_RG_VCN_1V8_STBTD_SHIFT                12
#define PMIC_RG_VCN_1V8_EN_MASK                    0x1
#define PMIC_RG_VCN_1V8_EN_SHIFT                   14
#define PMIC_QI_VCN_1V8_EN_MASK                    0x1
#define PMIC_QI_VCN_1V8_EN_SHIFT                   15
#define PMIC_RG_STB_SIM1_SIO_MASK                  0x1
#define PMIC_RG_STB_SIM1_SIO_SHIFT                 0
#define PMIC_RE_DIGLDORSV1_MASK                    0x7FFF
#define PMIC_RE_DIGLDORSV1_SHIFT                   1
#define PMIC_VSIM1_LP_SEL_MASK                     0x1
#define PMIC_VSIM1_LP_SEL_SHIFT                    0
#define PMIC_VSIM1_LP_MODE_SET_MASK                0x1
#define PMIC_VSIM1_LP_MODE_SET_SHIFT               1
#define PMIC_QI_VSIM1_MODE_MASK                    0x1
#define PMIC_QI_VSIM1_MODE_SHIFT                   7
#define PMIC_RG_VSIM1_STBTD_MASK                   0x3
#define PMIC_RG_VSIM1_STBTD_SHIFT                  12
#define PMIC_RG_VSIM1_EN_MASK                      0x1
#define PMIC_RG_VSIM1_EN_SHIFT                     15
#define PMIC_VSIM2_LP_SEL_MASK                     0x1
#define PMIC_VSIM2_LP_SEL_SHIFT                    0
#define PMIC_VSIM2_LP_MODE_SET_MASK                0x1
#define PMIC_VSIM2_LP_MODE_SET_SHIFT               1
#define PMIC_VSIM2_THER_SHDN_EN_MASK               0x1
#define PMIC_VSIM2_THER_SHDN_EN_SHIFT              2
#define PMIC_QI_VSIM2_MODE_MASK                    0x1
#define PMIC_QI_VSIM2_MODE_SHIFT                   7
#define PMIC_RG_VSIM2_STBTD_MASK                   0x3
#define PMIC_RG_VSIM2_STBTD_SHIFT                  12
#define PMIC_RG_VSIM2_EN_MASK                      0x1
#define PMIC_RG_VSIM2_EN_SHIFT                     15
#define PMIC_RG_VRTC_FORCE_ON_MASK                 0x1
#define PMIC_RG_VRTC_FORCE_ON_SHIFT                0
#define PMIC_VRTC_EN_MASK                          0x1
#define PMIC_VRTC_EN_SHIFT                         8
#define PMIC_QI_VRTC_EN_MASK                       0x1
#define PMIC_QI_VRTC_EN_SHIFT                      15
#define PMIC_RG_VEMC_3V3_BIST_EN_MASK              0x1
#define PMIC_RG_VEMC_3V3_BIST_EN_SHIFT             3
#define PMIC_RG_VMCH_BIST_EN_MASK                  0x1
#define PMIC_RG_VMCH_BIST_EN_SHIFT                 6
#define PMIC_RG_VMC_BIST_EN_MASK                   0x1
#define PMIC_RG_VMC_BIST_EN_SHIFT                  10
#define PMIC_RG_VUSB_BIST_EN_MASK                  0x1
#define PMIC_RG_VUSB_BIST_EN_SHIFT                 11
#define PMIC_RG_VIO28_BIST_EN_MASK                 0x1
#define PMIC_RG_VIO28_BIST_EN_SHIFT                15
#define PMIC_RG_VRTC_BIST_EN_MASK                  0x1
#define PMIC_RG_VRTC_BIST_EN_SHIFT                 0
#define PMIC_RG_VSIM2_BIST_EN_MASK                 0x1
#define PMIC_RG_VSIM2_BIST_EN_SHIFT                2
#define PMIC_RG_VSIM1_BIST_EN_MASK                 0x1
#define PMIC_RG_VSIM1_BIST_EN_SHIFT                3
#define PMIC_RG_VIBR_BIST_EN_MASK                  0x1
#define PMIC_RG_VIBR_BIST_EN_SHIFT                 5
#define PMIC_RG_VGP3_BIST_EN_MASK                  0x1
#define PMIC_RG_VGP3_BIST_EN_SHIFT                 11
#define PMIC_RG_VGP2_BIST_EN_MASK                  0x1
#define PMIC_RG_VGP2_BIST_EN_SHIFT                 14
#define PMIC_RG_VGP1_BIST_EN_MASK                  0x1
#define PMIC_RG_VGP1_BIST_EN_SHIFT                 15
#define PMIC_QI_VEMC_3V3_OC_STATUS_MASK            0x1
#define PMIC_QI_VEMC_3V3_OC_STATUS_SHIFT           3
#define PMIC_QI_VMCH_OC_STATUS_MASK                0x1
#define PMIC_QI_VMCH_OC_STATUS_SHIFT               6
#define PMIC_QI_VMC_OC_STATUS_MASK                 0x1
#define PMIC_QI_VMC_OC_STATUS_SHIFT                10
#define PMIC_QI_VUSB_OC_STATUS_MASK                0x1
#define PMIC_QI_VUSB_OC_STATUS_SHIFT               11
#define PMIC_QI_VIO28_OC_STATUS_MASK               0x1
#define PMIC_QI_VIO28_OC_STATUS_SHIFT              15
#define PMIC_QI_VSIM2_OC_STATUS_MASK               0x1
#define PMIC_QI_VSIM2_OC_STATUS_SHIFT              2
#define PMIC_QI_VSIM1_OC_STATUS_MASK               0x1
#define PMIC_QI_VSIM1_OC_STATUS_SHIFT              3
#define PMIC_QI_VIBR_OC_STATUS_MASK                0x1
#define PMIC_QI_VIBR_OC_STATUS_SHIFT               5
#define PMIC_QI_VGP3_OC_STATUS_MASK                0x1
#define PMIC_QI_VGP3_OC_STATUS_SHIFT               11
#define PMIC_QI_VGP2_OC_STATUS_MASK                0x1
#define PMIC_QI_VGP2_OC_STATUS_SHIFT               14
#define PMIC_QI_VGP1_OC_STATUS_MASK                0x1
#define PMIC_QI_VGP1_OC_STATUS_SHIFT               15
#define PMIC_RG_STB_SIM2_SIO_MASK                  0x1
#define PMIC_RG_STB_SIM2_SIO_SHIFT                 0
#define PMIC_RE_DIGLDORSV2_MASK                    0x7FFF
#define PMIC_RE_DIGLDORSV2_SHIFT                   1
#define PMIC_RG_VIO28_NDIS_EN_MASK                 0x1
#define PMIC_RG_VIO28_NDIS_EN_SHIFT                4
#define PMIC_RG_VIO28_OCFB_MASK                    0x1
#define PMIC_RG_VIO28_OCFB_SHIFT                   6
#define PMIC_RG_VIO28_CAL_MASK                     0xF
#define PMIC_RG_VIO28_CAL_SHIFT                    8
#define PMIC_RG_VUSB_NDIS_EN_MASK                  0x1
#define PMIC_RG_VUSB_NDIS_EN_SHIFT                 4
#define PMIC_RG_VUSB_OCFB_MASK                     0x1
#define PMIC_RG_VUSB_OCFB_SHIFT                    6
#define PMIC_RG_VUSB_CAL_MASK                      0xF
#define PMIC_RG_VUSB_CAL_SHIFT                     8
#define PMIC_RG_VMC_NDIS_EN_MASK                   0x1
#define PMIC_RG_VMC_NDIS_EN_SHIFT                  0
#define PMIC_VMC_ON_CTRL_MASK                      0x1
#define PMIC_VMC_ON_CTRL_SHIFT                     1
#define PMIC_RG_VMC_OCFB_MASK                      0x1
#define PMIC_RG_VMC_OCFB_SHIFT                     2
#define PMIC_RG_VMC_VOSEL_MASK                     0x1
#define PMIC_RG_VMC_VOSEL_SHIFT                    4
#define PMIC_RG_VMC_STB_SEL_MASK                   0x1
#define PMIC_RG_VMC_STB_SEL_SHIFT                  6
#define PMIC_RG_VMC_STB_SEL_CAL_MASK               0x3
#define PMIC_RG_VMC_STB_SEL_CAL_SHIFT              7
#define PMIC_RG_VMC_CAL_MASK                       0xF
#define PMIC_RG_VMC_CAL_SHIFT                      9
#define PMIC_RG_VMCH_NDIS_EN_MASK                  0x1
#define PMIC_RG_VMCH_NDIS_EN_SHIFT                 0
#define PMIC_VMCH_ON_CTRL_MASK                     0x1
#define PMIC_VMCH_ON_CTRL_SHIFT                    1
#define PMIC_RG_VMCH_OCFB_MASK                     0x1
#define PMIC_RG_VMCH_OCFB_SHIFT                    2
#define PMIC_RG_VMCH_DB_EN_MASK                    0x1
#define PMIC_RG_VMCH_DB_EN_SHIFT                   4
#define PMIC_RG_VMCH_STB_SEL_MASK                  0x1
#define PMIC_RG_VMCH_STB_SEL_SHIFT                 6
#define PMIC_RG_VMCH_VOSEL_MASK                    0x1
#define PMIC_RG_VMCH_VOSEL_SHIFT                   7
#define PMIC_RG_VMCH_STB_SEL_CAL_MASK              0x3
#define PMIC_RG_VMCH_STB_SEL_CAL_SHIFT             8
#define PMIC_RG_VMCH_CAL_MASK                      0xF
#define PMIC_RG_VMCH_CAL_SHIFT                     10
#define PMIC_RG_VEMC_3V3_NDIS_EN_MASK              0x1
#define PMIC_RG_VEMC_3V3_NDIS_EN_SHIFT             0
#define PMIC_VEMC_3V3_ON_CTRL_MASK                 0x1
#define PMIC_VEMC_3V3_ON_CTRL_SHIFT                1
#define PMIC_RG_VEMC_3V3_OCFB_MASK                 0x1
#define PMIC_RG_VEMC_3V3_OCFB_SHIFT                2
#define PMIC_RG_VEMC_3V3_DL_EN_MASK                0x1
#define PMIC_RG_VEMC_3V3_DL_EN_SHIFT               3
#define PMIC_RG_VEMC_3V3_DB_EN_MASK                0x1
#define PMIC_RG_VEMC_3V3_DB_EN_SHIFT               4
#define PMIC_RG_VEMC_3V3_STB_SEL_MASK              0x1
#define PMIC_RG_VEMC_3V3_STB_SEL_SHIFT             6
#define PMIC_RG_VEMC_3V3_VOSEL_MASK                0x1
#define PMIC_RG_VEMC_3V3_VOSEL_SHIFT               7
#define PMIC_RG_VEMC_3V3_STB_SEL_CAL_MASK          0x3
#define PMIC_RG_VEMC_3V3_STB_SEL_CAL_SHIFT         8
#define PMIC_RG_VEMC_3V3_CAL_MASK                  0xF
#define PMIC_RG_VEMC_3V3_CAL_SHIFT                 10
#define PMIC_RG_VGP1_NDIS_EN_MASK                  0x1
#define PMIC_RG_VGP1_NDIS_EN_SHIFT                 0
#define PMIC_RG_VGP1_OCFB_MASK                     0x1
#define PMIC_RG_VGP1_OCFB_SHIFT                    2
#define PMIC_RG_VGP1_STB_SEL_MASK                  0x1
#define PMIC_RG_VGP1_STB_SEL_SHIFT                 4
#define PMIC_RG_VGP1_VOSEL_MASK                    0x7
#define PMIC_RG_VGP1_VOSEL_SHIFT                   5
#define PMIC_RG_VGP1_CAL_MASK                      0xF
#define PMIC_RG_VGP1_CAL_SHIFT                     8
#define PMIC_RG_VGP2_NDIS_EN_MASK                  0x1
#define PMIC_RG_VGP2_NDIS_EN_SHIFT                 0
#define PMIC_RG_VGP2_OCFB_MASK                     0x1
#define PMIC_RG_VGP2_OCFB_SHIFT                    2
#define PMIC_RG_VGP2_STB_SEL_MASK                  0x1
#define PMIC_RG_VGP2_STB_SEL_SHIFT                 4
#define PMIC_RG_VGP2_VOSEL_MASK                    0x7
#define PMIC_RG_VGP2_VOSEL_SHIFT                   5
#define PMIC_RG_VGP2_CAL_MASK                      0xF
#define PMIC_RG_VGP2_CAL_SHIFT                     8
#define PMIC_RG_VGP3_NDIS_EN_MASK                  0x1
#define PMIC_RG_VGP3_NDIS_EN_SHIFT                 0
#define PMIC_RG_VGP3_OCFB_MASK                     0x1
#define PMIC_RG_VGP3_OCFB_SHIFT                    2
#define PMIC_RG_VGP3_STB_SEL_MASK                  0x1
#define PMIC_RG_VGP3_STB_SEL_SHIFT                 4
#define PMIC_RG_VGP3_VOSEL_MASK                    0x3
#define PMIC_RG_VGP3_VOSEL_SHIFT                   5
#define PMIC_RG_VGP3_CAL_MASK                      0xF
#define PMIC_RG_VGP3_CAL_SHIFT                     8
#define PMIC_VCAM_AF_LP_SEL_MASK                   0x1
#define PMIC_VCAM_AF_LP_SEL_SHIFT                  0
#define PMIC_VCAM_AF_LP_MODE_SET_MASK              0x1
#define PMIC_VCAM_AF_LP_MODE_SET_SHIFT             1
#define PMIC_QI_VCAM_AF_MODE_MASK                  0x1
#define PMIC_QI_VCAM_AF_MODE_SHIFT                 7
#define PMIC_RG_VCAM_AF_STBTD_MASK                 0x3
#define PMIC_RG_VCAM_AF_STBTD_SHIFT                12
#define PMIC_RG_VCAM_AF_EN_MASK                    0x1
#define PMIC_RG_VCAM_AF_EN_SHIFT                   15
#define PMIC_RG_VCAM_AF_NDIS_EN_MASK               0x1
#define PMIC_RG_VCAM_AF_NDIS_EN_SHIFT              0
#define PMIC_RG_VCAM_AF_OCFB_MASK                  0x1
#define PMIC_RG_VCAM_AF_OCFB_SHIFT                 2
#define PMIC_VCAM_AF_ON_CTRL_MASK                  0x1
#define PMIC_VCAM_AF_ON_CTRL_SHIFT                 3
#define PMIC_RG_VCAM_AF_STB_SEL_MASK               0x1
#define PMIC_RG_VCAM_AF_STB_SEL_SHIFT              4
#define PMIC_RG_VCAM_AF_VOSEL_MASK                 0x7
#define PMIC_RG_VCAM_AF_VOSEL_SHIFT                5
#define PMIC_RG_VCAM_AF_CAL_MASK                   0xF
#define PMIC_RG_VCAM_AF_CAL_SHIFT                  11
#define PMIC_RE_DIGLDORSV3_MASK                    0xFFFF
#define PMIC_RE_DIGLDORSV3_SHIFT                   0
#define PMIC_RG_VSIM1_NDIS_EN_MASK                 0x1
#define PMIC_RG_VSIM1_NDIS_EN_SHIFT                0
#define PMIC_RG_VSIM1_OCFB_MASK                    0x1
#define PMIC_RG_VSIM1_OCFB_SHIFT                   2
#define PMIC_RG_VSIM1_STB_SEL_MASK                 0x1
#define PMIC_RG_VSIM1_STB_SEL_SHIFT                4
#define PMIC_RG_VSIM1_VOSEL_MASK                   0x1
#define PMIC_RG_VSIM1_VOSEL_SHIFT                  5
#define PMIC_RG_VSIM1_CAL_MASK                     0xF
#define PMIC_RG_VSIM1_CAL_SHIFT                    8
#define PMIC_RG_VSIM2_NDIS_EN_MASK                 0x1
#define PMIC_RG_VSIM2_NDIS_EN_SHIFT                0
#define PMIC_RG_VSIM2_OCFB_MASK                    0x1
#define PMIC_RG_VSIM2_OCFB_SHIFT                   2
#define PMIC_RG_VSIM2_STB_SEL_MASK                 0x1
#define PMIC_RG_VSIM2_STB_SEL_SHIFT                4
#define PMIC_RG_VSIM2_VOSEL_MASK                   0x1
#define PMIC_RG_VSIM2_VOSEL_SHIFT                  5
#define PMIC_RG_VSIM2_CAL_MASK                     0xF
#define PMIC_RG_VSIM2_CAL_SHIFT                    8
#define PMIC_RG_VSYSLDO_RESERVE_MASK               0x3
#define PMIC_RG_VSYSLDO_RESERVE_SHIFT              0
#define PMIC_VIBR_LP_SEL_MASK                      0x1
#define PMIC_VIBR_LP_SEL_SHIFT                     0
#define PMIC_VIBR_LP_MODE_SET_MASK                 0x1
#define PMIC_VIBR_LP_MODE_SET_SHIFT                1
#define PMIC_VIBR_THER_SHEN_EN_MASK                0x1
#define PMIC_VIBR_THER_SHEN_EN_SHIFT               2
#define PMIC_QI_VIBR_MODE_MASK                     0x1
#define PMIC_QI_VIBR_MODE_SHIFT                    7
#define PMIC_RG_VIBR_STBTD_MASK                    0x3
#define PMIC_RG_VIBR_STBTD_SHIFT                   12
#define PMIC_RG_VIBR_EN_MASK                       0x1
#define PMIC_RG_VIBR_EN_SHIFT                      15
#define PMIC_RG_VIBR_NDIS_EN_MASK                  0x1
#define PMIC_RG_VIBR_NDIS_EN_SHIFT                 0
#define PMIC_RG_VIBR_OCFB_MASK                     0x1
#define PMIC_RG_VIBR_OCFB_SHIFT                    2
#define PMIC_RG_VIBR_STB_SEL_MASK                  0x1
#define PMIC_RG_VIBR_STB_SEL_SHIFT                 4
#define PMIC_RG_VIBR_VOSEL_MASK                    0x7
#define PMIC_RG_VIBR_VOSEL_SHIFT                   5
#define PMIC_RG_VIBR_STB_SEL_CAL_MASK              0x3
#define PMIC_RG_VIBR_STB_SEL_CAL_SHIFT             8
#define PMIC_RG_VIBR_CAL_MASK                      0xF
#define PMIC_RG_VIBR_CAL_SHIFT                     10
#define PMIC_DIGLDO_RSV1_MASK                      0xFF
#define PMIC_DIGLDO_RSV1_SHIFT                     0
#define PMIC_DIGLDO_RSV0_MASK                      0xF
#define PMIC_DIGLDO_RSV0_SHIFT                     8
#define PMIC_RG_LDO_FT_MASK                        0x1
#define PMIC_RG_LDO_FT_SHIFT                       15
#define PMIC_QI_VCAM_IO_OC_STATUS_MASK             0x1
#define PMIC_QI_VCAM_IO_OC_STATUS_SHIFT            3
#define PMIC_QI_VCAMD_OC_STATUS_MASK               0x1
#define PMIC_QI_VCAMD_OC_STATUS_SHIFT              5
#define PMIC_QI_VCN_1V8_OC_STATUS_MASK             0x1
#define PMIC_QI_VCN_1V8_OC_STATUS_SHIFT            7
#define PMIC_QI_VIO18_OC_STATUS_MASK               0x1
#define PMIC_QI_VIO18_OC_STATUS_SHIFT              9
#define PMIC_QI_VRF18_OC_STATUS_MASK               0x1
#define PMIC_QI_VRF18_OC_STATUS_SHIFT              11
#define PMIC_QI_VM_OC_STATUS_MASK                  0x1
#define PMIC_QI_VM_OC_STATUS_SHIFT                 13
#define PMIC_QI_VCAM_AF_OC_STATUS_MASK             0x1
#define PMIC_QI_VCAM_AF_OC_STATUS_SHIFT            15
#define PMIC_RG_VCAM_AF_BIST_EN_MASK               0x1
#define PMIC_RG_VCAM_AF_BIST_EN_SHIFT              2
#define PMIC_RG_VCAMD_IO_BIST_EN_MASK              0x1
#define PMIC_RG_VCAMD_IO_BIST_EN_SHIFT             3
#define PMIC_RG_VCN_1V8_BIST_EN_MASK               0x1
#define PMIC_RG_VCN_1V8_BIST_EN_SHIFT              4
#define PMIC_RG_VCAMD_BIST_EN_MASK                 0x1
#define PMIC_RG_VCAMD_BIST_EN_SHIFT                6
#define PMIC_RG_VIO18_BIST_EN_MASK                 0x1
#define PMIC_RG_VIO18_BIST_EN_SHIFT                10
#define PMIC_RG_VM_BIST_EN_MASK                    0x1
#define PMIC_RG_VM_BIST_EN_SHIFT                   11
#define PMIC_RG_VRF18_BIST_EN_MASK                 0x1
#define PMIC_RG_VRF18_BIST_EN_SHIFT                15
#define PMIC_VIBR_ON_CTRL_MASK                     0x1
#define PMIC_VIBR_ON_CTRL_SHIFT                    7
#define PMIC_VSIM2_ON_CTRL_MASK                    0x1
#define PMIC_VSIM2_ON_CTRL_SHIFT                   8
#define PMIC_VSIM1_ON_CTRL_MASK                    0x1
#define PMIC_VSIM1_ON_CTRL_SHIFT                   9
#define PMIC_VGP3_ON_CTRL_MASK                     0x1
#define PMIC_VGP3_ON_CTRL_SHIFT                    13
#define PMIC_VGP2_ON_CTRL_MASK                     0x1
#define PMIC_VGP2_ON_CTRL_SHIFT                    14
#define PMIC_VGP1_ON_CTRL_MASK                     0x1
#define PMIC_VGP1_ON_CTRL_SHIFT                    15
#define PMIC_VRF18_LP_SEL_MASK                     0x1
#define PMIC_VRF18_LP_SEL_SHIFT                    0
#define PMIC_VRF18_LP_MODE_SET_MASK                0x1
#define PMIC_VRF18_LP_MODE_SET_SHIFT               1
#define PMIC_QI_VRF18_MODE_MASK                    0x1
#define PMIC_QI_VRF18_MODE_SHIFT                   7
#define PMIC_RG_VRF18_STBTD_MASK                   0x3
#define PMIC_RG_VRF18_STBTD_SHIFT                  12
#define PMIC_RG_VRF18_EN_MASK                      0x1
#define PMIC_RG_VRF18_EN_SHIFT                     15
#define PMIC_RG_VRF18_NDIS_EN_MASK                 0x1
#define PMIC_RG_VRF18_NDIS_EN_SHIFT                0
#define PMIC_VRF18_ON_CTRL_MASK                    0x1
#define PMIC_VRF18_ON_CTRL_SHIFT                   1
#define PMIC_RG_VRF18_OCFB_MASK                    0x1
#define PMIC_RG_VRF18_OCFB_SHIFT                   2
#define PMIC_RG_VRF18_STB_SEL_MASK                 0x1
#define PMIC_RG_VRF18_STB_SEL_SHIFT                4
#define PMIC_RG_VRF18_CAL_MASK                     0xF
#define PMIC_RG_VRF18_CAL_SHIFT                    8
#define PMIC_VM_LP_SEL_MASK                        0x1
#define PMIC_VM_LP_SEL_SHIFT                       0
#define PMIC_VM_LP_MODE_SET_MASK                   0x1
#define PMIC_VM_LP_MODE_SET_SHIFT                  1
#define PMIC_QI_VM_MODE_MASK                       0x1
#define PMIC_QI_VM_MODE_SHIFT                      7
#define PMIC_RG_VM_STBTD_MASK                      0x3
#define PMIC_RG_VM_STBTD_SHIFT                     12
#define PMIC_RG_VM_EN_MASK                         0x1
#define PMIC_RG_VM_EN_SHIFT                        14
#define PMIC_QI_VM_EN_MASK                         0x1
#define PMIC_QI_VM_EN_SHIFT                        15
#define PMIC_RG_VM_NDIS_EN_MASK                    0x1
#define PMIC_RG_VM_NDIS_EN_SHIFT                   0
#define PMIC_RG_VM_PLCUR_EN_MASK                   0x1
#define PMIC_RG_VM_PLCUR_EN_SHIFT                  1
#define PMIC_RG_VM_PLCUR_CAL_MASK                  0x3
#define PMIC_RG_VM_PLCUR_CAL_SHIFT                 2
#define PMIC_RG_VM_VOSEL_MASK                      0x3
#define PMIC_RG_VM_VOSEL_SHIFT                     4
#define PMIC_RG_VM_OCFB_MASK                       0x1
#define PMIC_RG_VM_OCFB_SHIFT                      6
#define PMIC_RG_VM_CAL_MASK                        0xF
#define PMIC_RG_VM_CAL_SHIFT                       8
#define PMIC_VIO18_LP_SEL_MASK                     0x1
#define PMIC_VIO18_LP_SEL_SHIFT                    0
#define PMIC_VIO18_LP_MODE_SET_MASK                0x1
#define PMIC_VIO18_LP_MODE_SET_SHIFT               1
#define PMIC_QI_VIO18_MODE_MASK                    0x1
#define PMIC_QI_VIO18_MODE_SHIFT                   7
#define PMIC_RG_VIO18_STBTD_MASK                   0x3
#define PMIC_RG_VIO18_STBTD_SHIFT                  12
#define PMIC_RG_VIO18_EN_MASK                      0x1
#define PMIC_RG_VIO18_EN_SHIFT                     14
#define PMIC_QI_VIO18_EN_MASK                      0x1
#define PMIC_QI_VIO18_EN_SHIFT                     15
#define PMIC_RG_VIO18_NDIS_EN_MASK                 0x1
#define PMIC_RG_VIO18_NDIS_EN_SHIFT                0
#define PMIC_VIO18_ON_CTRL_MASK                    0x1
#define PMIC_VIO18_ON_CTRL_SHIFT                   1
#define PMIC_RG_VIO18_OCFB_MASK                    0x1
#define PMIC_RG_VIO18_OCFB_SHIFT                   2
#define PMIC_RG_VIO18_STB_SEL_MASK                 0x1
#define PMIC_RG_VIO18_STB_SEL_SHIFT                4
#define PMIC_RG_VIO18_CAL_MASK                     0xF
#define PMIC_RG_VIO18_CAL_SHIFT                    8
#define PMIC_VCAMD_LP_SEL_MASK                     0x1
#define PMIC_VCAMD_LP_SEL_SHIFT                    0
#define PMIC_VCAMD_LP_MODE_SET_MASK                0x1
#define PMIC_VCAMD_LP_MODE_SET_SHIFT               1
#define PMIC_QI_VCAMD_MODE_MASK                    0x1
#define PMIC_QI_VCAMD_MODE_SHIFT                   7
#define PMIC_RG_VCAMD_STBTD_MASK                   0x3
#define PMIC_RG_VCAMD_STBTD_SHIFT                  12
#define PMIC_RG_VCAMD_EN_MASK                      0x1
#define PMIC_RG_VCAMD_EN_SHIFT                     14
#define PMIC_QI_VCAMD_EN_MASK                      0x1
#define PMIC_QI_VCAMD_EN_SHIFT                     15
#define PMIC_RG_VCAMD_NDIS_EN_MASK                 0x1
#define PMIC_RG_VCAMD_NDIS_EN_SHIFT                0
#define PMIC_VCAMD_ON_CTRL_MASK                    0x1
#define PMIC_VCAMD_ON_CTRL_SHIFT                   1
#define PMIC_RG_VCAMD_OCFB_MASK                    0x1
#define PMIC_RG_VCAMD_OCFB_SHIFT                   2
#define PMIC_RG_VCAMD_STB_SEL_MASK                 0x1
#define PMIC_RG_VCAMD_STB_SEL_SHIFT                4
#define PMIC_RG_VCAMD_VOSEL_MASK                   0x3
#define PMIC_RG_VCAMD_VOSEL_SHIFT                  5
#define PMIC_RG_VCAMD_CAL_MASK                     0xF
#define PMIC_RG_VCAMD_CAL_SHIFT                    8
#define PMIC_VCAM_IO_LP_SEL_MASK                   0x1
#define PMIC_VCAM_IO_LP_SEL_SHIFT                  0
#define PMIC_VCAM_IO_LP_MODE_SET_MASK              0x1
#define PMIC_VCAM_IO_LP_MODE_SET_SHIFT             1
#define PMIC_QI_VCAM_IO_MODE_MASK                  0x1
#define PMIC_QI_VCAM_IO_MODE_SHIFT                 7
#define PMIC_RG_VCAM_IO_STBTD_MASK                 0x3
#define PMIC_RG_VCAM_IO_STBTD_SHIFT                12
#define PMIC_RG_VCAM_IO_EN_MASK                    0x1
#define PMIC_RG_VCAM_IO_EN_SHIFT                   14
#define PMIC_QI_VCAM_IO_EN_MASK                    0x1
#define PMIC_QI_VCAM_IO_EN_SHIFT                   15
#define PMIC_RG_VCAM_IO_NDIS_EN_MASK               0x1
#define PMIC_RG_VCAM_IO_NDIS_EN_SHIFT              0
#define PMIC_VCAM_IO_ON_CTRL_MASK                  0x1
#define PMIC_VCAM_IO_ON_CTRL_SHIFT                 1
#define PMIC_RG_VCAM_IO_OCFB_MASK                  0x1
#define PMIC_RG_VCAM_IO_OCFB_SHIFT                 2
#define PMIC_RG_VCAM_IO_STB_SEL_MASK               0x1
#define PMIC_RG_VCAM_IO_STB_SEL_SHIFT              4
#define PMIC_RG_VCAM_IO_CAL_MASK                   0xF
#define PMIC_RG_VCAM_IO_CAL_SHIFT                  8
#define PMIC_RG_EFUSE_ADDR_MASK                    0x1F
#define PMIC_RG_EFUSE_ADDR_SHIFT                   0
#define PMIC_RG_EFUSE_PROG_MASK                    0x3F
#define PMIC_RG_EFUSE_PROG_SHIFT                   0
#define PMIC_RG_EFUSE_EN_MASK                      0x1
#define PMIC_RG_EFUSE_EN_SHIFT                     0
#define PMIC_RG_EFUSE_PKEY_MASK                    0xFFFF
#define PMIC_RG_EFUSE_PKEY_SHIFT                   0
#define PMIC_RG_EFUSE_RD_TRIG_MASK                 0x1
#define PMIC_RG_EFUSE_RD_TRIG_SHIFT                0
#define PMIC_RG_EFUSE_PROG_SRC_MASK                0x1
#define PMIC_RG_EFUSE_PROG_SRC_SHIFT               0
#define PMIC_RG_SKIP_EFUSE_OUT_MASK                0x1
#define PMIC_RG_SKIP_EFUSE_OUT_SHIFT               2
#define PMIC_RG_RD_RDY_BYPASS_MASK                 0x1
#define PMIC_RG_RD_RDY_BYPASS_SHIFT                4
#define PMIC_RG_EFUSE_RD_ACK_MASK                  0x1
#define PMIC_RG_EFUSE_RD_ACK_SHIFT                 0
#define PMIC_RG_EFUSE_BUSY_MASK                    0x1
#define PMIC_RG_EFUSE_BUSY_SHIFT                   2
#define PMIC_RG_EFUSE_VAL_0_15_MASK                0xFFFF
#define PMIC_RG_EFUSE_VAL_0_15_SHIFT               0
#define PMIC_RG_EFUSE_VAL_16_31_MASK               0xFFFF
#define PMIC_RG_EFUSE_VAL_16_31_SHIFT              0
#define PMIC_RG_EFUSE_VAL_32_47_MASK               0xFFFF
#define PMIC_RG_EFUSE_VAL_32_47_SHIFT              0
#define PMIC_RG_EFUSE_VAL_48_63_MASK               0xFFFF
#define PMIC_RG_EFUSE_VAL_48_63_SHIFT              0
#define PMIC_RG_EFUSE_VAL_64_79_MASK               0xFFFF
#define PMIC_RG_EFUSE_VAL_64_79_SHIFT              0
#define PMIC_RG_EFUSE_VAL_80_95_MASK               0xFFFF
#define PMIC_RG_EFUSE_VAL_80_95_SHIFT              0
#define PMIC_RG_EFUSE_VAL_96_111_MASK              0xFFFF
#define PMIC_RG_EFUSE_VAL_96_111_SHIFT             0
#define PMIC_RG_EFUSE_VAL_112_127_MASK             0xFFFF
#define PMIC_RG_EFUSE_VAL_112_127_SHIFT            0
#define PMIC_RG_EFUSE_VAL_128_143_MASK             0xFFFF
#define PMIC_RG_EFUSE_VAL_128_143_SHIFT            0
#define PMIC_RG_EFUSE_VAL_144_159_MASK             0xFFFF
#define PMIC_RG_EFUSE_VAL_144_159_SHIFT            0
#define PMIC_RG_EFUSE_VAL_160_175_MASK             0xFFFF
#define PMIC_RG_EFUSE_VAL_160_175_SHIFT            0
#define PMIC_RG_EFUSE_VAL_176_191_MASK             0xFFFF
#define PMIC_RG_EFUSE_VAL_176_191_SHIFT            0
#define PMIC_RG_EFUSE_DOUT_0_15_MASK               0xFFFF
#define PMIC_RG_EFUSE_DOUT_0_15_SHIFT              0
#define PMIC_RG_EFUSE_DOUT_16_31_MASK              0xFFFF
#define PMIC_RG_EFUSE_DOUT_16_31_SHIFT             0
#define PMIC_RG_EFUSE_DOUT_32_47_MASK              0xFFFF
#define PMIC_RG_EFUSE_DOUT_32_47_SHIFT             0
#define PMIC_RG_EFUSE_DOUT_48_63_MASK              0xFFFF
#define PMIC_RG_EFUSE_DOUT_48_63_SHIFT             0
#define PMIC_RG_EFUSE_DOUT_64_79_MASK              0xFFFF
#define PMIC_RG_EFUSE_DOUT_64_79_SHIFT             0
#define PMIC_RG_EFUSE_DOUT_80_95_MASK              0xFFFF
#define PMIC_RG_EFUSE_DOUT_80_95_SHIFT             0
#define PMIC_RG_EFUSE_DOUT_96_111_MASK             0xFFFF
#define PMIC_RG_EFUSE_DOUT_96_111_SHIFT            0
#define PMIC_RG_EFUSE_DOUT_112_127_MASK            0xFFFF
#define PMIC_RG_EFUSE_DOUT_112_127_SHIFT           0
#define PMIC_RG_EFUSE_DOUT_128_143_MASK            0xFFFF
#define PMIC_RG_EFUSE_DOUT_128_143_SHIFT           0
#define PMIC_RG_EFUSE_DOUT_144_159_MASK            0xFFFF
#define PMIC_RG_EFUSE_DOUT_144_159_SHIFT           0
#define PMIC_RG_EFUSE_DOUT_160_175_MASK            0xFFFF
#define PMIC_RG_EFUSE_DOUT_160_175_SHIFT           0
#define PMIC_RG_EFUSE_DOUT_176_191_MASK            0xFFFF
#define PMIC_RG_EFUSE_DOUT_176_191_SHIFT           0
#define PMIC_RG_OTP_PA_MASK                        0x3
#define PMIC_RG_OTP_PA_SHIFT                       0
#define PMIC_RG_OTP_PDIN_MASK                      0xFF
#define PMIC_RG_OTP_PDIN_SHIFT                     0
#define PMIC_RG_OTP_PTM_MASK                       0x3
#define PMIC_RG_OTP_PTM_SHIFT                      0
#define PMIC_MIX_EOSC32_OPT_MASK                   0x3
#define PMIC_MIX_EOSC32_OPT_SHIFT                  0
#define PMIC_MIX_XOSC32_STP_CPDTB_MASK             0x1
#define PMIC_MIX_XOSC32_STP_CPDTB_SHIFT            2
#define PMIC_MIX_XOSC32_STP_PWDB_MASK              0x1
#define PMIC_MIX_XOSC32_STP_PWDB_SHIFT             3
#define PMIC_MIX_XOSC32_STP_LPDTB_MASK             0x1
#define PMIC_MIX_XOSC32_STP_LPDTB_SHIFT            4
#define PMIC_MIX_XOSC32_STP_LPDEN_MASK             0x1
#define PMIC_MIX_XOSC32_STP_LPDEN_SHIFT            5
#define PMIC_MIX_XOSC32_STP_LPDRST_MASK            0x1
#define PMIC_MIX_XOSC32_STP_LPDRST_SHIFT           6
#define PMIC_MIX_XOSC32_STP_CALI_MASK              0x1F
#define PMIC_MIX_XOSC32_STP_CALI_SHIFT             7
#define PMIC_STMP_MODE_MASK                        0x1
#define PMIC_STMP_MODE_SHIFT                       12
#define PMIC_MIX_EOSC32_STP_CHOP_EN_MASK           0x1
#define PMIC_MIX_EOSC32_STP_CHOP_EN_SHIFT          0
#define PMIC_MIX_DCXO_STP_LVSH_EN_MASK             0x1
#define PMIC_MIX_DCXO_STP_LVSH_EN_SHIFT            1
#define PMIC_MIX_PMU_STP_DDLO_VRTC_MASK            0x1
#define PMIC_MIX_PMU_STP_DDLO_VRTC_SHIFT           2
#define PMIC_MIX_PMU_STP_DDLO_VRTC_EN_MASK         0x1
#define PMIC_MIX_PMU_STP_DDLO_VRTC_EN_SHIFT        3
#define PMIC_MIX_RTC_STP_XOSC32_ENB_MASK           0x1
#define PMIC_MIX_RTC_STP_XOSC32_ENB_SHIFT          4
#define PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_MASK  0x1
#define PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_SHIFT 5
#define PMIC_MIX_EOSC32_STP_RSV_MASK               0x3
#define PMIC_MIX_EOSC32_STP_RSV_SHIFT              6
#define PMIC_MIX_EOSC32_VCT_EN_MASK                0x1
#define PMIC_MIX_EOSC32_VCT_EN_SHIFT               8
#define PMIC_MIX_STP_BBWAKEUP_MASK                 0x1
#define PMIC_MIX_STP_BBWAKEUP_SHIFT                9
#define PMIC_MIX_STP_RTC_DDLO_MASK                 0x1
#define PMIC_MIX_STP_RTC_DDLO_SHIFT                10
#define PMIC_MIX_RTC_XOSC32_ENB_MASK               0x1
#define PMIC_MIX_RTC_XOSC32_ENB_SHIFT              11
#define PMIC_MIX_EFUSE_XOSC32_ENB_OPT_MASK         0x1
#define PMIC_MIX_EFUSE_XOSC32_ENB_OPT_SHIFT        12
#define PMIC_RG_AUDULL_VCFG_MASK                   0xF
#define PMIC_RG_AUDULL_VCFG_SHIFT                  0
#define PMIC_RG_AUDULL_VUPG_MASK                   0x7
#define PMIC_RG_AUDULL_VUPG_SHIFT                  4
#define PMIC_RG_AUDULL_VPWDB_PGA_MASK              0x1
#define PMIC_RG_AUDULL_VPWDB_PGA_SHIFT             7
#define PMIC_RG_AUDULL_VPWDB_ADC_MASK              0x1
#define PMIC_RG_AUDULL_VPWDB_ADC_SHIFT             8
#define PMIC_RG_AUDULL_VADC_DENB_MASK              0x1
#define PMIC_RG_AUDULL_VADC_DENB_SHIFT             9
#define PMIC_RG_AUDULL_VADC_DVREF_CAL_MASK         0x1
#define PMIC_RG_AUDULL_VADC_DVREF_CAL_SHIFT        10
#define PMIC_RG_AUDULL_VREF24_EN_MASK              0x1
#define PMIC_RG_AUDULL_VREF24_EN_SHIFT             11
#define PMIC_RG_AUDULL_VCM14_EN_MASK               0x1
#define PMIC_RG_AUDULL_VCM14_EN_SHIFT              12
#define PMIC_RG_AUDULL_VCMSEL_MASK                 0x1
#define PMIC_RG_AUDULL_VCMSEL_SHIFT                13
#define PMIC_RG_AUDULL_CHS_EN_MASK                 0x1
#define PMIC_RG_AUDULL_CHS_EN_SHIFT                14
#define PMIC_RG_AUDULL_VCALI_MASK                  0x7
#define PMIC_RG_AUDULL_VCALI_SHIFT                 0
#define PMIC_RG_AUDULR_VCFG_MASK                   0xF
#define PMIC_RG_AUDULR_VCFG_SHIFT                  4
#define PMIC_RG_AUDULR_VUPG_MASK                   0x7
#define PMIC_RG_AUDULR_VUPG_SHIFT                  8
#define PMIC_RG_AUDULR_VPWDB_PGA_MASK              0x1
#define PMIC_RG_AUDULR_VPWDB_PGA_SHIFT             0
#define PMIC_RG_AUDULR_VPWDB_ADC_MASK              0x1
#define PMIC_RG_AUDULR_VPWDB_ADC_SHIFT             1
#define PMIC_RG_AUDULR_VADC_DENB_MASK              0x1
#define PMIC_RG_AUDULR_VADC_DENB_SHIFT             2
#define PMIC_RG_AUDULR_VADC_DVREF_CAL_MASK         0x1
#define PMIC_RG_AUDULR_VADC_DVREF_CAL_SHIFT        3
#define PMIC_RG_AUDULR_VREF24_EN_MASK              0x1
#define PMIC_RG_AUDULR_VREF24_EN_SHIFT             4
#define PMIC_RG_AUDULR_VCM14_EN_MASK               0x1
#define PMIC_RG_AUDULR_VCM14_EN_SHIFT              5
#define PMIC_RG_AUDULR_VCMSEL_MASK                 0x1
#define PMIC_RG_AUDULR_VCMSEL_SHIFT                6
#define PMIC_RG_AUDULR_CHS_EN_MASK                 0x1
#define PMIC_RG_AUDULR_CHS_EN_SHIFT                7
#define PMIC_RG_AUDULR_VCALI_MASK                  0x7
#define PMIC_RG_AUDULR_VCALI_SHIFT                 0
#define PMIC_RG_AUD_IGBIAS_CALI_MASK               0x3
#define PMIC_RG_AUD_IGBIAS_CALI_SHIFT              4
#define PMIC_RG_AUD_RSV_MASK                       0xFF
#define PMIC_RG_AUD_RSV_SHIFT                      8
#define PMIC_RG_AMUTER_MASK                        0x1
#define PMIC_RG_AMUTER_SHIFT                       0
#define PMIC_RG_AMUTEL_MASK                        0x1
#define PMIC_RG_AMUTEL_SHIFT                       1
#define PMIC_RG_ADACL_PWDB_MASK                    0x1
#define PMIC_RG_ADACL_PWDB_SHIFT                   2
#define PMIC_RG_ADACR_PWDB_MASK                    0x1
#define PMIC_RG_ADACR_PWDB_SHIFT                   3
#define PMIC_RG_ABIAS_PWDB_MASK                    0x1
#define PMIC_RG_ABIAS_PWDB_SHIFT                   4
#define PMIC_RG_AOUTL_PWDB_MASK                    0x1
#define PMIC_RG_AOUTL_PWDB_SHIFT                   5
#define PMIC_RG_AOUTR_PWDB_MASK                    0x1
#define PMIC_RG_AOUTR_PWDB_SHIFT                   6
#define PMIC_RG_ACALI_MASK                         0x1F
#define PMIC_RG_ACALI_SHIFT                        0
#define PMIC_RG_APGR_MASK                          0x7
#define PMIC_RG_APGR_SHIFT                         8
#define PMIC_RG_APGL_MASK                          0x7
#define PMIC_RG_APGL_SHIFT                         12
#define PMIC_RG_ABUF_BIAS_MASK                     0x3
#define PMIC_RG_ABUF_BIAS_SHIFT                    0
#define PMIC_RG_ABUF_INSHORT_MASK                  0x1
#define PMIC_RG_ABUF_INSHORT_SHIFT                 2
#define PMIC_RG_AHFMODE_MASK                       0x1
#define PMIC_RG_AHFMODE_SHIFT                      3
#define PMIC_RG_ADACCK_EN_MASK                     0x1
#define PMIC_RG_ADACCK_EN_SHIFT                    4
#define PMIC_RG_DACREF_MASK                        0x1
#define PMIC_RG_DACREF_SHIFT                       5
#define PMIC_RG_ADEPOPX_EN_MASK                    0x1
#define PMIC_RG_ADEPOPX_EN_SHIFT                   6
#define PMIC_RG_ADEPOPX_MASK                       0x3
#define PMIC_RG_ADEPOPX_SHIFT                      7
#define PMIC_RG_DEPOP_VCM_EN_MASK                  0x1
#define PMIC_RG_DEPOP_VCM_EN_SHIFT                 9
#define PMIC_RG_DEPOP_VCMSEL_MASK                  0x1
#define PMIC_RG_DEPOP_VCMSEL_SHIFT                 10
#define PMIC_RG_DEPOP_CURSEL_MASK                  0x3
#define PMIC_RG_DEPOP_CURSEL_SHIFT                 11
#define PMIC_RG_CHARGEOPTION_DEPOP_MASK            0x1
#define PMIC_RG_CHARGEOPTION_DEPOP_SHIFT           13
#define PMIC_RG_AVCMGEN_EN_MASK                    0x1
#define PMIC_RG_AVCMGEN_EN_SHIFT                   14
#define PMIC_RG_AUDDL_VREF24_EN_MASK               0x1
#define PMIC_RG_AUDDL_VREF24_EN_SHIFT              15
#define PMIC_RG_ABIRSV_MASK                        0x3
#define PMIC_RG_ABIRSV_SHIFT                       0
#define PMIC_RG_VBUF_FLOAT_MASK                    0x1
#define PMIC_RG_VBUF_FLOAT_SHIFT                   2
#define PMIC_RG_VDPG_MASK                          0xF
#define PMIC_RG_VDPG_SHIFT                         4
#define PMIC_RG_VBUF_PWDB_MASK                     0x1
#define PMIC_RG_VBUF_PWDB_SHIFT                    8
#define PMIC_RG_VBUF_BIAS_MASK                     0x3
#define PMIC_RG_VBUF_BIAS_SHIFT                    9
#define PMIC_RG_VDEPOP_MASK                        0x1
#define PMIC_RG_VDEPOP_SHIFT                       11
#define PMIC_RG_V2SPK_MASK                         0x1
#define PMIC_RG_V2SPK_SHIFT                        12
#define PMIC_RG_HSOUTSTBENH_MASK                   0x1
#define PMIC_RG_HSOUTSTBENH_SHIFT                  13
#define PMIC_AUDTOP_CON8_RSV_0_MASK                0x1
#define PMIC_AUDTOP_CON8_RSV_0_SHIFT               0
#define PMIC_RG_CLKSQ_MONEN_MASK                   0x1
#define PMIC_RG_CLKSQ_MONEN_SHIFT                  1
#define PMIC_RG_AUDDIGMICEN_MASK                   0x1
#define PMIC_RG_AUDDIGMICEN_SHIFT                  2
#define PMIC_RG_AUDPWDBMICBIAS_MASK                0x1
#define PMIC_RG_AUDPWDBMICBIAS_SHIFT               3
#define PMIC_RG_AUDDIGMICPDUTY_MASK                0x3
#define PMIC_RG_AUDDIGMICPDUTY_SHIFT               4
#define PMIC_RG_AUDDIGMICNDUTY_MASK                0x3
#define PMIC_RG_AUDDIGMICNDUTY_SHIFT               6
#define PMIC_RG_AUDDIGMICBIAS_MASK                 0x3
#define PMIC_RG_AUDDIGMICBIAS_SHIFT                8
#define PMIC_RG_AUDMICBIASVREF_MASK                0x3
#define PMIC_RG_AUDMICBIASVREF_SHIFT               10
#define PMIC_RG_AUDSPAREVMIC_MASK                  0xF
#define PMIC_RG_AUDSPAREVMIC_SHIFT                 12
#define PMIC_RG_VBIRX_ZCD_EN_MASK                  0x1
#define PMIC_RG_VBIRX_ZCD_EN_SHIFT                 0
#define PMIC_RG_VBIRX_ZCD_CALI_MASK                0x3
#define PMIC_RG_VBIRX_ZCD_CALI_SHIFT               1
#define PMIC_RG_VBIRX_ZCD_HYS_ENB_MASK             0x1
#define PMIC_RG_VBIRX_ZCD_HYS_ENB_SHIFT            3
#define PMIC_RG_VBIRX_ZCD_STATUS_MASK              0xF
#define PMIC_RG_VBIRX_ZCD_STATUS_SHIFT             4
#define PMIC_RG_ADC_OUT_BATSNS_MASK                0x7FFF
#define PMIC_RG_ADC_OUT_BATSNS_SHIFT               0
#define PMIC_RG_ADC_RDY_BATSNS_MASK                0x1
#define PMIC_RG_ADC_RDY_BATSNS_SHIFT               15
#define PMIC_RG_ADC_OUT_ISENSE_MASK                0x7FFF
#define PMIC_RG_ADC_OUT_ISENSE_SHIFT               0
#define PMIC_RG_ADC_RDY_ISENSE_MASK                0x1
#define PMIC_RG_ADC_RDY_ISENSE_SHIFT               15
#define PMIC_RG_ADC_OUT_VCDT_MASK                  0x7FFF
#define PMIC_RG_ADC_OUT_VCDT_SHIFT                 0
#define PMIC_RG_ADC_RDY_VCDT_MASK                  0x1
#define PMIC_RG_ADC_RDY_VCDT_SHIFT                 15
#define PMIC_RG_ADC_OUT_BATON1_MASK                0x7FFF
#define PMIC_RG_ADC_OUT_BATON1_SHIFT               0
#define PMIC_RG_ADC_RDY_BATON1_MASK                0x1
#define PMIC_RG_ADC_RDY_BATON1_SHIFT               15
#define PMIC_RG_ADC_OUT_THR_SENSE1_MASK            0x7FFF
#define PMIC_RG_ADC_OUT_THR_SENSE1_SHIFT           0
#define PMIC_RG_ADC_RDY_THR_SENSE1_MASK            0x1
#define PMIC_RG_ADC_RDY_THR_SENSE1_SHIFT           15
#define PMIC_RG_ADC_OUT_THR_SENSE2_MASK            0x7FFF
#define PMIC_RG_ADC_OUT_THR_SENSE2_SHIFT           0
#define PMIC_RG_ADC_RDY_THR_SENSE2_MASK            0x1
#define PMIC_RG_ADC_RDY_THR_SENSE2_SHIFT           15
#define PMIC_RG_ADC_OUT_BATON2_MASK                0x7FFF
#define PMIC_RG_ADC_OUT_BATON2_SHIFT               0
#define PMIC_RG_ADC_RDY_BATON2_MASK                0x1
#define PMIC_RG_ADC_RDY_BATON2_SHIFT               15
#define PMIC_RG_ADC_OUT_CH5_MASK                   0x7FFF
#define PMIC_RG_ADC_OUT_CH5_SHIFT                  0
#define PMIC_RG_ADC_RDY_CH5_MASK                   0x1
#define PMIC_RG_ADC_RDY_CH5_SHIFT                  15
#define PMIC_RG_ADC_OUT_WAKEUP_PCHR_MASK           0x7FFF
#define PMIC_RG_ADC_OUT_WAKEUP_PCHR_SHIFT          0
#define PMIC_RG_ADC_RDY_WAKEUP_PCHR_MASK           0x1
#define PMIC_RG_ADC_RDY_WAKEUP_PCHR_SHIFT          15
#define PMIC_RG_ADC_OUT_WAKEUP_SWCHR_MASK          0x7FFF
#define PMIC_RG_ADC_OUT_WAKEUP_SWCHR_SHIFT         0
#define PMIC_RG_ADC_RDY_WAKEUP_SWCHR_MASK          0x1
#define PMIC_RG_ADC_RDY_WAKEUP_SWCHR_SHIFT         15
#define PMIC_RG_ADC_OUT_LBAT_MASK                  0xFFF
#define PMIC_RG_ADC_OUT_LBAT_SHIFT                 0
#define PMIC_RG_ADC_RDY_LBAT_MASK                  0x1
#define PMIC_RG_ADC_RDY_LBAT_SHIFT                 15
#define PMIC_RG_ADC_OUT_CH6_MASK                   0x7FFF
#define PMIC_RG_ADC_OUT_CH6_SHIFT                  0
#define PMIC_RG_ADC_RDY_CH6_MASK                   0x1
#define PMIC_RG_ADC_RDY_CH6_SHIFT                  15
#define PMIC_RG_ADC_RDY_GPS_MASK                   0x1
#define PMIC_RG_ADC_RDY_GPS_SHIFT                  15
#define PMIC_RG_ADC_OUT_GPS_MASK                   0xFFFF
#define PMIC_RG_ADC_OUT_GPS_SHIFT                  0
#define PMIC_RG_ADC_OUT_GPS_LSB_MASK               0x1
#define PMIC_RG_ADC_OUT_GPS_LSB_SHIFT              15
#define PMIC_RG_ADC_OUT_MD_MASK                    0xFFFF
#define PMIC_RG_ADC_OUT_MD_SHIFT                   0
#define PMIC_RG_ADC_OUT_MD_LSB_MASK                0x1
#define PMIC_RG_ADC_OUT_MD_LSB_SHIFT               0
#define PMIC_RG_ADC_RDY_MD_MASK                    0x1
#define PMIC_RG_ADC_RDY_MD_SHIFT                   15
#define PMIC_RG_ADC_OUT_INT_MASK                   0x7FFF
#define PMIC_RG_ADC_OUT_INT_SHIFT                  0
#define PMIC_RG_ADC_RDY_INT_MASK                   0x1
#define PMIC_RG_ADC_RDY_INT_SHIFT                  15
#define PMIC_RG_ADC_OUT_RSV1_MASK                  0xFFFF
#define PMIC_RG_ADC_OUT_RSV1_SHIFT                 0
#define PMIC_RG_ADC_OUT_RSV2_MASK                  0xFFFF
#define PMIC_RG_ADC_OUT_RSV2_SHIFT                 0
#define PMIC_RG_ADC_OUT_RSV3_MASK                  0xFFFF
#define PMIC_RG_ADC_OUT_RSV3_SHIFT                 0
#define PMIC_RG_SW_GAIN_TRIM_MASK                  0xFFFF
#define PMIC_RG_SW_GAIN_TRIM_SHIFT                 0
#define PMIC_RG_SW_OFFSET_TRIM_MASK                0xFFFF
#define PMIC_RG_SW_OFFSET_TRIM_SHIFT               0
#define PMIC_RG_ADC_PWDB_MASK                      0x1
#define PMIC_RG_ADC_PWDB_SHIFT                     0
#define PMIC_RG_ADC_PWDB_SWCTRL_MASK               0x1
#define PMIC_RG_ADC_PWDB_SWCTRL_SHIFT              2
#define PMIC_RG_ADC_CALI_RATE_MASK                 0x3
#define PMIC_RG_ADC_CALI_RATE_SHIFT                4
#define PMIC_RG_ADC_CALI_EN_MASK                   0x1
#define PMIC_RG_ADC_CALI_EN_SHIFT                  6
#define PMIC_RG_ADC_CALI_FORCE_MASK                0x1
#define PMIC_RG_ADC_CALI_FORCE_SHIFT               7
#define PMIC_RG_ADC_AUTORST_RANGE_MASK             0x3
#define PMIC_RG_ADC_AUTORST_RANGE_SHIFT            8
#define PMIC_RG_ADC_AUTORST_EN_MASK                0x1
#define PMIC_RG_ADC_AUTORST_EN_SHIFT               10
#define PMIC_RG_ADC_LATCH_EDGE_MASK                0x1
#define PMIC_RG_ADC_LATCH_EDGE_SHIFT               11
#define PMIC_RG_ADC_FILTER_ORDER_MASK              0x1
#define PMIC_RG_ADC_FILTER_ORDER_SHIFT             12
#define PMIC_RG_ADC_SWCTRL_EN_MASK                 0x1
#define PMIC_RG_ADC_SWCTRL_EN_SHIFT                0
#define PMIC_RG_ADCIN_VSEN_EN_MASK                 0x1
#define PMIC_RG_ADCIN_VSEN_EN_SHIFT                1
#define PMIC_RG_ADCIN_VSEN_MUX_EN_MASK             0x1
#define PMIC_RG_ADCIN_VSEN_MUX_EN_SHIFT            2
#define PMIC_RG_ADCIN_VBAT_EN_MASK                 0x1
#define PMIC_RG_ADCIN_VBAT_EN_SHIFT                4
#define PMIC_RG_ADCIN_CHR_EN_MASK                  0x1
#define PMIC_RG_ADCIN_CHR_EN_SHIFT                 5
#define PMIC_RG_AUXADC_CHSEL_MASK                  0xF
#define PMIC_RG_AUXADC_CHSEL_SHIFT                 12
#define PMIC_RG_LBAT_DEBT_MAX_MASK                 0xFF
#define PMIC_RG_LBAT_DEBT_MAX_SHIFT                0
#define PMIC_RG_LBAT_DEBT_MIN_MASK                 0xFF
#define PMIC_RG_LBAT_DEBT_MIN_SHIFT                8
#define PMIC_RG_LBAT_DET_PRD_15_0_MASK             0xFFFF
#define PMIC_RG_LBAT_DET_PRD_15_0_SHIFT            0
#define PMIC_RG_LBAT_DET_PRD_19_16_MASK            0xF
#define PMIC_RG_LBAT_DET_PRD_19_16_SHIFT           0
#define PMIC_RG_LBAT_VOLT_MAX_MASK                 0xFFF
#define PMIC_RG_LBAT_VOLT_MAX_SHIFT                0
#define PMIC_RG_LBAT_IRQ_EN_MAX_MASK               0x1
#define PMIC_RG_LBAT_IRQ_EN_MAX_SHIFT              12
#define PMIC_RG_LBAT_EN_MAX_MASK                   0x1
#define PMIC_RG_LBAT_EN_MAX_SHIFT                  13
#define PMIC_RG_LBAT_MAX_IRQ_B_MASK                0x1
#define PMIC_RG_LBAT_MAX_IRQ_B_SHIFT               15
#define PMIC_RG_LBAT_VOLT_MIN_MASK                 0xFFF
#define PMIC_RG_LBAT_VOLT_MIN_SHIFT                0
#define PMIC_RG_LBAT_IRQ_EN_MIN_MASK               0x1
#define PMIC_RG_LBAT_IRQ_EN_MIN_SHIFT              12
#define PMIC_RG_LBAT_EN_MIN_MASK                   0x1
#define PMIC_RG_LBAT_EN_MIN_SHIFT                  13
#define PMIC_RG_LBAT_MIN_IRQ_B_MASK                0x1
#define PMIC_RG_LBAT_MIN_IRQ_B_SHIFT               15
#define PMIC_RG_LBAT_DEBOUNCE_COUNT_MAX_MASK       0x1FF
#define PMIC_RG_LBAT_DEBOUNCE_COUNT_MAX_SHIFT      0
#define PMIC_RG_LBAT_DEBOUNCE_COUNT_MIN_MASK       0x1FF
#define PMIC_RG_LBAT_DEBOUNCE_COUNT_MIN_SHIFT      0
#define PMIC_RG_DATA_REUSE_SEL_MASK                0x3
#define PMIC_RG_DATA_REUSE_SEL_SHIFT               3
#define PMIC_RG_AUXADC_BIST_ENB_MASK               0x1
#define PMIC_RG_AUXADC_BIST_ENB_SHIFT              5
#define PMIC_RG_OSR_MASK                           0x7
#define PMIC_RG_OSR_SHIFT                          10
#define PMIC_RG_OSR_GPS_MASK                       0x7
#define PMIC_RG_OSR_GPS_SHIFT                      13
#define PMIC_RG_ADC_TRIM_CH7_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH7_SEL_SHIFT             0
#define PMIC_RG_ADC_TRIM_CH6_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH6_SEL_SHIFT             2
#define PMIC_RG_ADC_TRIM_CH5_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH5_SEL_SHIFT             4
#define PMIC_RG_ADC_TRIM_CH4_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH4_SEL_SHIFT             6
#define PMIC_RG_ADC_TRIM_CH3_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH3_SEL_SHIFT             8
#define PMIC_RG_ADC_TRIM_CH2_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH2_SEL_SHIFT             10
#define PMIC_RG_ADC_TRIM_CH0_SEL_MASK              0x3
#define PMIC_RG_ADC_TRIM_CH0_SEL_SHIFT             14
#define PMIC_RG_VBUF_CALEN_MASK                    0x1
#define PMIC_RG_VBUF_CALEN_SHIFT                   0
#define PMIC_RG_VBUF_EXTEN_MASK                    0x1
#define PMIC_RG_VBUF_EXTEN_SHIFT                   1
#define PMIC_RG_VBUF_BYP_MASK                      0x1
#define PMIC_RG_VBUF_BYP_SHIFT                     2
#define PMIC_RG_VBUF_EN_MASK                       0x1
#define PMIC_RG_VBUF_EN_SHIFT                      4
#define PMIC_RG_SOURCE_LBAT_SEL_MASK               0x1
#define PMIC_RG_SOURCE_LBAT_SEL_SHIFT              15
#define PMIC_EFUSE_GAIN_CH0_TRIM_MASK              0x1FF
#define PMIC_EFUSE_GAIN_CH0_TRIM_SHIFT             0
#define PMIC_EFUSE_OFFSET_CH0_TRIM_MASK            0xFF
#define PMIC_EFUSE_OFFSET_CH0_TRIM_SHIFT           0
#define PMIC_EFUSE_GAIN_CH4_TRIM_MASK              0x1FF
#define PMIC_EFUSE_GAIN_CH4_TRIM_SHIFT             0
#define PMIC_EFUSE_OFFSET_CH4_TRIM_MASK            0xFF
#define PMIC_EFUSE_OFFSET_CH4_TRIM_SHIFT           0
#define PMIC_EFUSE_GAIN_CH7_TRIM_MASK              0xFFFF
#define PMIC_EFUSE_GAIN_CH7_TRIM_SHIFT             0
#define PMIC_EFUSE_OFFSET_CH7_TRIM_MASK            0xFFFF
#define PMIC_EFUSE_OFFSET_CH7_TRIM_SHIFT           0
#define PMIC_RG_ADC_IBIAS_MASK                     0x3
#define PMIC_RG_ADC_IBIAS_SHIFT                    0
#define PMIC_RG_ADC_RST_MASK                       0x1
#define PMIC_RG_ADC_RST_SHIFT                      2
#define PMIC_RG_ADC_LP_EN_MASK                     0x1
#define PMIC_RG_ADC_LP_EN_SHIFT                    3
#define PMIC_RG_ADC_INPUT_SHORT_MASK               0x1
#define PMIC_RG_ADC_INPUT_SHORT_SHIFT              4
#define PMIC_RG_ADC_CHOPPER_EN_MASK                0x1
#define PMIC_RG_ADC_CHOPPER_EN_SHIFT               5
#define PMIC_RG_VPWDB_ADC_MASK                     0x1
#define PMIC_RG_VPWDB_ADC_SHIFT                    6
#define PMIC_RG_VREF18_EN_MASK                     0x1
#define PMIC_RG_VREF18_EN_SHIFT                    7
#define PMIC_RG_ADC_CHS_SEL_MASK                   0x3
#define PMIC_RG_ADC_CHS_SEL_SHIFT                  8
#define PMIC_RG_ADC_DVREF_CAL_MASK                 0x1
#define PMIC_RG_ADC_DVREF_CAL_SHIFT                14
#define PMIC_RG_ADC_DENB_MASK                      0x1
#define PMIC_RG_ADC_DENB_SHIFT                     15
#define PMIC_RG_ADC_SLEEP_MODE_EN_MASK             0x1
#define PMIC_RG_ADC_SLEEP_MODE_EN_SHIFT            0
#define PMIC_RG_ADC_GPS_STATUS_MASK                0x1
#define PMIC_RG_ADC_GPS_STATUS_SHIFT               1
#define PMIC_RG_ADC_RSV_BIT_MASK                   0x1
#define PMIC_RG_ADC_RSV_BIT_SHIFT                  2
#define PMIC_RG_ADC_TEST_MODE_EN_MASK              0x1
#define PMIC_RG_ADC_TEST_MODE_EN_SHIFT             3
#define PMIC_RG_ADC_TEST_OUT_SEL_MASK              0x1
#define PMIC_RG_ADC_TEST_OUT_SEL_SHIFT             4
#define PMIC_RG_DECI_BYPASS_EN_MASK                0x1
#define PMIC_RG_DECI_BYPASS_EN_SHIFT               5
#define PMIC_RG_ADC_CLK_AON_MASK                   0x1
#define PMIC_RG_ADC_CLK_AON_SHIFT                  7
#define PMIC_RG_ADC_DECI_FORCE_MASK                0x1
#define PMIC_RG_ADC_DECI_FORCE_SHIFT               12
#define PMIC_RG_ADC_DECI_GDLY_MASK                 0x3
#define PMIC_RG_ADC_DECI_GDLY_SHIFT                14
#define PMIC_RG_MD_RQST_MASK                       0x1
#define PMIC_RG_MD_RQST_SHIFT                      15
#define PMIC_RG_GPS_RQST_MASK                      0x1
#define PMIC_RG_GPS_RQST_SHIFT                     15
#define PMIC_RG_AP_RQST_LIST_MASK                  0x1FF
#define PMIC_RG_AP_RQST_LIST_SHIFT                 0
#define PMIC_RG_AP_RQST_MASK                       0x1
#define PMIC_RG_AP_RQST_SHIFT                      15
#define PMIC_RG_AP_RQST_LIST_RSV_MASK              0xFF
#define PMIC_RG_AP_RQST_LIST_RSV_SHIFT             0
#define PMIC_RG_ADC_OUT_TRIM_ENB_MASK              0x1
#define PMIC_RG_ADC_OUT_TRIM_ENB_SHIFT             1
#define PMIC_RG_ADC_TRIM_COMP_MASK                 0x1
#define PMIC_RG_ADC_TRIM_COMP_SHIFT                2
#define PMIC_RG_ADC_2S_COMP_ENB_MASK               0x1
#define PMIC_RG_ADC_2S_COMP_ENB_SHIFT              3
#define PMIC_RG_CIC_OUT_RAW_MASK                   0x1
#define PMIC_RG_CIC_OUT_RAW_SHIFT                  4
#define PMIC_RG_DATA_SKIP_ENB_MASK                 0x1
#define PMIC_RG_DATA_SKIP_ENB_SHIFT                5
#define PMIC_RG_DATA_SKIP_NUM_MASK                 0x3
#define PMIC_RG_DATA_SKIP_NUM_SHIFT                6
#define PMIC_RG_ADC_REV_MASK                       0xFF
#define PMIC_RG_ADC_REV_SHIFT                      0
#define PMIC_RG_DECI_GDLY_SEL_MODE_MASK            0x1
#define PMIC_RG_DECI_GDLY_SEL_MODE_SHIFT           0
#define PMIC_RG_DECI_GDLY_VREF18_SELB_MASK         0x1
#define PMIC_RG_DECI_GDLY_VREF18_SELB_SHIFT        1
#define PMIC_RG_ADC_RSV1_MASK                      0x1FFF
#define PMIC_RG_ADC_RSV1_SHIFT                     2
#define PMIC_RG_VREF18_ENB_MASK                    0x1
#define PMIC_RG_VREF18_ENB_SHIFT                   15
#define PMIC_RG_ADC_MD_STATUS_MASK                 0x1
#define PMIC_RG_ADC_MD_STATUS_SHIFT                0
#define PMIC_RG_ADC_RSV2_MASK                      0x3FFF
#define PMIC_RG_ADC_RSV2_SHIFT                     1
#define PMIC_RG_VREF18_ENB_MD_MASK                 0x1
#define PMIC_RG_VREF18_ENB_MD_SHIFT                15
#define PMIC_RG_AUDACCDETVTHCAL_MASK               0x3
#define PMIC_RG_AUDACCDETVTHCAL_SHIFT              0
#define PMIC_RG_AUDACCDETSWCTRL_MASK               0x7
#define PMIC_RG_AUDACCDETSWCTRL_SHIFT              4
#define PMIC_RG_AUDACCDETTVDET_MASK                0x1
#define PMIC_RG_AUDACCDETTVDET_SHIFT               8
#define PMIC_RG_AUDACCDETVIN1PULLLOW_MASK          0x1
#define PMIC_RG_AUDACCDETVIN1PULLLOW_SHIFT         9
#define PMIC_AUDACCDETAUXADCSWCTRL_MASK            0x1
#define PMIC_AUDACCDETAUXADCSWCTRL_SHIFT           10
#define PMIC_AUDACCDETAUXADCSWCTRL_SEL_MASK        0x1
#define PMIC_AUDACCDETAUXADCSWCTRL_SEL_SHIFT       11
#define PMIC_RG_AUDACCDETRSV_MASK                  0xF
#define PMIC_RG_AUDACCDETRSV_SHIFT                 12
#define PMIC_ACCDET_EN_MASK                        0x1
#define PMIC_ACCDET_EN_SHIFT                       0
#define PMIC_ACCDET_SEQ_INIT_MASK                  0x1
#define PMIC_ACCDET_SEQ_INIT_SHIFT                 1
#define PMIC_ACCDET_CMP_PWM_EN_MASK                0x1
#define PMIC_ACCDET_CMP_PWM_EN_SHIFT               0
#define PMIC_ACCDET_VTH_PWM_EN_MASK                0x1
#define PMIC_ACCDET_VTH_PWM_EN_SHIFT               1
#define PMIC_ACCDET_MBIAS_PWM_EN_MASK              0x1
#define PMIC_ACCDET_MBIAS_PWM_EN_SHIFT             2
#define PMIC_ACCDET_CMP_PWM_IDLE_MASK              0x1
#define PMIC_ACCDET_CMP_PWM_IDLE_SHIFT             4
#define PMIC_ACCDET_VTH_PWM_IDLE_MASK              0x1
#define PMIC_ACCDET_VTH_PWM_IDLE_SHIFT             5
#define PMIC_ACCDET_MBIAS_PWM_IDLE_MASK            0x1
#define PMIC_ACCDET_MBIAS_PWM_IDLE_SHIFT           6
#define PMIC_ACCDET_PWM_WIDTH_MASK                 0xFFFF
#define PMIC_ACCDET_PWM_WIDTH_SHIFT                0
#define PMIC_ACCDET_PWM_THRESH_MASK                0xFFFF
#define PMIC_ACCDET_PWM_THRESH_SHIFT               0
#define PMIC_ACCDET_RISE_DELAY_MASK                0x7FFF
#define PMIC_ACCDET_RISE_DELAY_SHIFT               0
#define PMIC_ACCDET_FALL_DELAY_MASK                0x1
#define PMIC_ACCDET_FALL_DELAY_SHIFT               15
#define PMIC_ACCDET_DEBOUNCE0_MASK                 0xFFFF
#define PMIC_ACCDET_DEBOUNCE0_SHIFT                0
#define PMIC_ACCDET_DEBOUNCE1_MASK                 0xFFFF
#define PMIC_ACCDET_DEBOUNCE1_SHIFT                0
#define PMIC_ACCDET_DEBOUNCE2_MASK                 0xFFFF
#define PMIC_ACCDET_DEBOUNCE2_SHIFT                0
#define PMIC_ACCDET_DEBOUNCE3_MASK                 0xFFFF
#define PMIC_ACCDET_DEBOUNCE3_SHIFT                0
#define PMIC_ACCDET_IVAL_CUR_IN_MASK               0x3
#define PMIC_ACCDET_IVAL_CUR_IN_SHIFT              0
#define PMIC_ACCDET_IVAL_SAM_IN_MASK               0x3
#define PMIC_ACCDET_IVAL_SAM_IN_SHIFT              4
#define PMIC_ACCDET_IVAL_MEM_IN_MASK               0x3
#define PMIC_ACCDET_IVAL_MEM_IN_SHIFT              8
#define PMIC_ACCDET_IVAL_SEL_MASK                  0x1
#define PMIC_ACCDET_IVAL_SEL_SHIFT                 15
#define PMIC_ACCDET_IRQ_MASK                       0x1
#define PMIC_ACCDET_IRQ_SHIFT                      0
#define PMIC_ACCDET_IRQ_CLR_MASK                   0x1
#define PMIC_ACCDET_IRQ_CLR_SHIFT                  8
#define PMIC_ACCDET_TEST_MODE0_MASK                0x1
#define PMIC_ACCDET_TEST_MODE0_SHIFT               0
#define PMIC_ACCDET_TEST_MODE1_MASK                0x1
#define PMIC_ACCDET_TEST_MODE1_SHIFT               1
#define PMIC_ACCDET_TEST_MODE2_MASK                0x1
#define PMIC_ACCDET_TEST_MODE2_SHIFT               2
#define PMIC_ACCDET_TEST_MODE3_MASK                0x1
#define PMIC_ACCDET_TEST_MODE3_SHIFT               3
#define PMIC_ACCDET_TEST_MODE4_MASK                0x1
#define PMIC_ACCDET_TEST_MODE4_SHIFT               4
#define PMIC_ACCDET_TEST_MODE5_MASK                0x1
#define PMIC_ACCDET_TEST_MODE5_SHIFT               5
#define PMIC_ACCDET_PWM_SEL_MASK                   0x3
#define PMIC_ACCDET_PWM_SEL_SHIFT                  6
#define PMIC_ACCDET_IN_SW_MASK                     0x3
#define PMIC_ACCDET_IN_SW_SHIFT                    8
#define PMIC_ACCDET_CMP_EN_SW_MASK                 0x1
#define PMIC_ACCDET_CMP_EN_SW_SHIFT                12
#define PMIC_ACCDET_VTH_EN_SW_MASK                 0x1
#define PMIC_ACCDET_VTH_EN_SW_SHIFT                13
#define PMIC_ACCDET_MBIAS_EN_SW_MASK               0x1
#define PMIC_ACCDET_MBIAS_EN_SW_SHIFT              14
#define PMIC_ACCDET_PWM_EN_SW_MASK                 0x1
#define PMIC_ACCDET_PWM_EN_SW_SHIFT                15
#define PMIC_ACCDET_IN_MASK                        0x3
#define PMIC_ACCDET_IN_SHIFT                       0
#define PMIC_ACCDET_CUR_IN_MASK                    0x3
#define PMIC_ACCDET_CUR_IN_SHIFT                   2
#define PMIC_ACCDET_SAM_IN_MASK                    0x3
#define PMIC_ACCDET_SAM_IN_SHIFT                   4
#define PMIC_ACCDET_MEM_IN_MASK                    0x3
#define PMIC_ACCDET_MEM_IN_SHIFT                   6
#define PMIC_ACCDET_STATE_MASK                     0x7
#define PMIC_ACCDET_STATE_SHIFT                    8
#define PMIC_ACCDET_MBIAS_CLK_MASK                 0x1
#define PMIC_ACCDET_MBIAS_CLK_SHIFT                12
#define PMIC_ACCDET_VTH_CLK_MASK                   0x1
#define PMIC_ACCDET_VTH_CLK_SHIFT                  13
#define PMIC_ACCDET_CMP_CLK_MASK                   0x1
#define PMIC_ACCDET_CMP_CLK_SHIFT                  14
#define PMIC_DA_AUDACCDETAUXADCSWCTRL_MASK         0x1
#define PMIC_DA_AUDACCDETAUXADCSWCTRL_SHIFT        15
#define PMIC_ACCDET_CUR_DEB_MASK                   0xFFFF
#define PMIC_ACCDET_CUR_DEB_SHIFT                  0
#define PMIC_ACCDET_RSV_CON0_MASK                  0xFFFF
#define PMIC_ACCDET_RSV_CON0_SHIFT                 0
#define PMIC_ACCDET_RSV_CON1_MASK                  0xFFFF
#define PMIC_ACCDET_RSV_CON1_SHIFT                 0

typedef enum {
	PMIC_RG_VCDT_HV_EN,
} PMU_FLAGS_LIST_ENUM;

typedef struct {
	PMU_FLAGS_LIST_ENUM flagname;
	unsigned short offset;
	unsigned short mask;
	unsigned char shift;
} PMU_FLAG_TABLE_ENTRY;

#endif
